<?php


function getXML($filename)
{
	$contents = "";
	if($handle = fopen($filename ,"r"))
	{
		while(!feof($handle))
		{
			$contents .= fgetc($handle);
		}
	}

	$result = new SimpleXMLElement($contents);
	return $result;
}

function str_to_time( $time )
{
	return sprintf( "%02d:%02d:%02d"
	, substr( $time, 0, 2 ), substr( $time, 2, 2 ), substr( $time, 4, 2 ) );
}
function str_to_date( $date )
{
	return sprintf( "%04d-%02d-%02d"
	, substr( $date, 0, 4 ), substr( $date, 4, 2 ), substr( $date, 6, 2 ) );
}


function monitoring_socket( $szHost, $szPort, $szMsg ) {
	$fp = fsockopen( $szHost, $szPort, $szErrNo, $szErrMsg, 15 );

	if ( !$fp ) {
		$szReturnMsg = sprintf( "Error [%s] : %s", $szErrNo, $szErrMsg );
	} else {
		fwrite( $sock, $szMsg );

		while( !feof( $fp ) ) {
			$szReturnMsg .= fgets( $fp, 1024 );
		}
	}
	fclose( $sock );

	Return $szReturnMsg;
}

function OnMsgDisplay( $szMsg, $szType = '', $szReturnUrl = '' ) {

	switch( $szType ) {
		case "0" :
			$szLocation = sprintf( "location.href = '%s';", $szReturnUrl );
			break;
		case "-1" :
			$szLocation = sprintf( "parent.location.href = '%s';", $szReturnUrl );
			break;
		case "-2" :
			$szLocation = sprintf( "parent.parent.location.href = '%s';", $szReturnUrl );
			break;
		case "t" :
			$szLocation = sprintf( "top.location.href = '/';" );
			break;
		default :
			//$szLocation = "history.back();";
			$szLocation = "top.location.href = '/work/index.php'";
			break;
	}

	echo <<<EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<TITLE></TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<LINK href="../../css/lgnotel.css?time=1400385835" type=text/css rel=StyleSheet>
<script>
	alert( '{$szMsg}' );
	{$szLocation}
</script>
</head>
<body></body>
</html>
EOT;
	exit;
}

function OnCheckPermission( $db, $_SESSIONS, $szMenuPos, $szType = '', $szReturnUrl = '' ) {
	global $_SERVER;

	//if ( !session_is_registered() ) {
	//	OnMsgDisplay( $arPermissionMsg['FRC_PermissionAccesNot'], $szType, '/work/index.php' );
	//	exit;
	//}

	$xml = getXML(sprintf("%s/work/lang/%s/permission.xml", $_SERVER['DOCUMENT_ROOT'], $_SESSIONS['Lang'] ? $_SESSIONS['Lang'] : 'kr' ));

	$arPermissionMsg = array (
		'FRC_PermissionAccesNot'=> $xml->data[0]->list[0]->FRC_PermissionAccesNot[0]["Stitle"],
	);


	if ($_SESSIONS['PermissionLevel']==""){$_SESSIONS['PermissionLevel']="E1001";}
	$szQuery = sprintf( "SELECT * FROM rs_access_list WHERE r_level_code='%s' AND r_program_src='%s' AND r_read_yn='Y'"
	, $_SESSIONS['PermissionLevel'], $szMenuPos );

	$db->ExecSql( $szQuery, "S" );
	if ( $db->Num > 0 ) {
		$arInfo = $db->Fetch();
		$db->ResultFree();

		return array( 'read' => $arInfo['r_read_yn'], 'write' => $arInfo['r_modi_yn'], 'delete' => $arInfo['r_del_yn'] );
	} else {
		//OnLogginProc( $db, '5124', sprintf( "접근 권한 없는 사용자 접근 (%s => [%s] %s)", $_SESSION['UserId'], $szMenuPos, $_SERVER['PHP_SELF'] ) );

		OnMsgDisplay( $arPermissionMsg['FRC_PermissionAccesNot'], $szType, $szReturnUrl );
	}
}

function OnLogginProc( $db, $szCode, $szMsg )
{
	global $_SESSION;

	if ( !isset( $_SESSION['UserId'] ) ) $_SESSION['UserId'] = "";
	if ( !isset( $_SESSION['ExtNo'] ) ) $_SESSION['ExtNo'] = "";

	$szMsg = sprintf( "[%s] %s", $_SESSION['UserId'], htmlspecialchars( $szMsg, ENT_QUOTES) );

	$szQuery = sprintf( "INSERT INTO rs_log_info ( r_log_date, r_log_time, r_log_type, r_log_ext, r_log_contents ) VALUES ( '%s', '%s', '%s', '%s', '%s' )"
	, date( "Ymd" )
	, date( "His" )
	, $szCode
	, $_SESSION['ExtNo']
	, $szMsg );
	//print_r( $szQuery );
	$db->ExecSql( $szQuery, "I" );
	//print_r( $db->Error() );
}

function OnChannelCheck($db)
{

	$szMsg = sprintf( "MSG=/RECSEE/M/%s/%s/", 'A', '' );

	OnLogginProc( $db, '5123', sprintf( "Channel Call Status Check (%s)", $szMsg ) );

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, sprintf( "http://%s/work/interface/RecSeeSocketControl.php", $_SERVER['HTTP_HOST'] ));
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $szMsg);

	ob_start();
	curl_exec($ch);
	$szResult = ob_get_contents();
	ob_end_clean();

	$arResult = explode( "|", $szResult );
	$return = 'true';
	if ( sizeof( $arResult ) > 1 ) {
		for( $i = 1; $i < sizeof( $arResult ); $i++ ) {
			$arStatus = explode( "/", $arResult[$i] );
			if ( $arStatus['3'] == "5"  || $arStatus['3'] == "7") { // 선택 녹취 시에도 반영안되도록 
				$return = 'false';
				break;
			}
		}
	}

	curl_close($ch);

	return $return;

}

function OnIPCRRestart($db)
{

	$szMsg = "vProc=Restart";

	OnLogginProc( $db, '5128', "IPCR Restart " );

	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, sprintf( "http://%s/work/interface/FcManagerSocketControl.php", $_SERVER['HTTP_HOST'] ));
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $szMsg);

	ob_start();
	curl_exec($ch);
	$szResult = ob_get_contents();
	ob_end_clean();

	$arResult = explode( "|", $szResult );
	$return = 'true';
	if ( sizeof( $arResult ) > 1 ) {
		for( $i = 1; $i < sizeof( $arResult ); $i++ ) {
			$arStatus = explode( "/", $arResult[$i] );
			if ( $arStatus['3'] == "5" || $arStatus['3'] == "7" ) {
				$return = 'false';
				break;
			}
		}
	}

	curl_close($ch);

	return $return;
}


function OnChannelProc( $db, $arParam )
{

	$szMsg = sprintf( "MSG=/RECSEE/%s/%-14s/%-8s/%s/"
	, $arParam['Control'], $arParam['ExtNo'], $arParam['AgentId'], $arParam['Type'] );
	OnLogginProc( $db, '5123', sprintf( "Channel Information Processing delivery (%s)", $szMsg ) );

	$ch = curl_init();

	curl_setopt($ch, CURLOPT_URL, sprintf( "http://%s/work/interface/RecSeeSocketControl.php", $_SERVER['HTTP_HOST'] ));
	curl_setopt($ch, CURLOPT_HEADER, false);
	curl_setopt($ch, CURLOPT_POST, true);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $szMsg);

	ob_start();
	curl_exec($ch);
	//$content = ob_get_contents();
	ob_end_clean();
	//echo $contents;

	curl_close($ch);
}

function OnPageRowsProc( $iPageRows, $arPageRows )
{
	$arRows = array();
	foreach( $arPageRows AS $key => $iPageRow ) {
		array_push( $arRows, sprintf( "<option value='%s'%s>%s</option>", $iPageRow, $iPageRows == $iPageRow ? " selected" : "", $iPageRow ) );
	}

	if ( sizeof( $arRows ) > 0 ) $szReturn = implode( "\\n", $arRows );
	else $szReturn = "";

	return $szReturn;
}

function OnArrayStripTag( $arArray, $szMsg )
{
	if ( is_array( $arArray ) ) {
		foreach( $arArray AS $key => $arArr ) {
			if ( is_array( $arArr ) ) {
				$arArray[ $key ] = OnArrayStripTag( $arArr, $szMsg );
			} else {
				$arArray[ $key ] = strip_tags( $arArr );
				if ( empty( $arArray[ $key ] ) && !empty( $arArr ) ) {
					echo <<<EOT
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
<TITLE></TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<LINK href="/work/css/lgnotel.css?time=1400385835" type=text/css rel=StyleSheet>
<script>
	alert( '{$szMsg}' );
	history.back();
</script>
</head>
<body></body>
</html>
EOT;
					exit;
				}
			}
		}
	}
	return $arArray;
}

function OnLocalUrlProc( $szUrl, $szHttpHost )
{
	$arHost = parse_url( $szUrl );
	$szHost = isset( $arHost['host'] ) ? $arHost['host'] : "";

	if ( $szHost == $szHttpHost )
	{
		return $szUrl;
	} else {
		return str_replace( $szHost, $szHttpHost, $szUrl );
	}
}

function MultiIPCR_Selection($db, $ipcr_ip = "")
{
	global $FRC_IPCRServerID;
	
	$return_str = "";

	$query = "select r_master_ip from rs_ipcr_multi_master ";
	$db->ExecSql($query,"S");
	if($db->Num>0){
		$return_str.="<table width='100%'  bgcolor='#d1d3d4' border='0' cellspacing='0' cellpadding='0'><tr><td width='100%' height=30 align=right>";
		$return_str .= "<img src='/work/images/search_dot.gif'> {$FRC_IPCRServerID} ";
		$return_str .= "<select name='ipcr_ServerInfo' id='ipcr_ServerInfo' class='input01' style='width:150px;height:20px;' onchange='IPCR_ServerChange(this.value);'>";

		$query_target = "select r_sys_id, r_sys_name, r_sys_ip from rs_sys_info_ipcr order by r_sys_type, r_sys_id";

		$db->ExecSql($query_target,"S");
		if($db->Num>0)
		{
			for($i=0;$i<$db->Num;$i++)
			{
				$row = $db->GetPosition($i);
				if ($row['r_sys_ip']==$ipcr_ip){$selected="selected";}
				else{$selected="";}

				$return_str .= "<option value = '".$row['r_sys_ip']."' ".$selected.">".$row['r_sys_id']."</option>";
			}
		}

		$return_str .= "</select></td></tr></table>";

	}

	return $return_str;

}

function MultiIPCR_MyType($db){

	$return_str="";

	$query_target = sprintf("select r_sys_type from rs_sys_info_ipcr where r_sys_ip = '%s' ", $_SERVER['HTTP_HOST']);

	$db->ExecSql($query_target,"S");

	if($db->Num>0)
	{
		$row = $db->GetPosition(0); 

		if ( !isset( $row['r_sys_type'] ) ) $row['r_sys_type'] = "";
		if ($row['r_sys_type']=="M"){$sys_type = "MASTER" ;}
		else if ($row['r_sys_type']=="S"){$sys_type = "SLAVE" ;}
		else {$sys_type="";}
	
		if ($sys_type!=""){
			//$return_str.="<table width='100%' border='0' cellspacing='0' cellpadding='0'><tr><td width='100%' height=30 align=center>";
			//$return_str.="<a href='#' class='left_menu' style='font-size:13px;'>";
			$return_str .= "<center><span class='left_menu' style='font-size:13px; text-align: center'>IPCR TYPE : ".$sys_type."</span></center>";
			//$return_str.="</a>";
			//$return_str.="</td></tr></table>";
		}	
	}
	return $return_str;
}


function IPCR_MySysId($db) {

	$return_str="";

	$query_target = sprintf("select r_sys_id from rs_sys_info_ipcr where r_sys_ip = '%s' ", $_SERVER['HTTP_HOST']);

	$db->ExecSql($query_target,"S");
	if($db->Num>0)
	{
		$row = $db->GetPosition(0); 
		$return_str = 	$row['r_sys_id'];

	}
	return $return_str;
}


function IPCR_SessionCreate($db, $NowLang) { //마스터에서 슬래이브 iframe 불러올때 사용.

	$szMyType = MultiIPCR_MyType($db);
	
	if ( preg_match( '/MASTER/', $szMyType ) == 0 && !empty( $NowLang ) ) {
		if ($_SESSION['UserId']==""){
		
			$query="select * from RS_RUSER_INFO where R_USER_ID='admin' ";
			$db->ExecSql($query,"S");
			if( $db->Num>0 )
			{
				$arRow = $db->GetPosition(0);
				$_SESSION['UserId'] = $arRow['r_user_id'];
				$_SESSION['PermissionLevel'] = $arRow['r_user_level'];
				$_SESSION['GroupCode'] = array( 'bg' => $arRow['r_bg_code'], 'mg' => $arRow['r_mg_code'], 'sg' => $arRow['r_sg_code'] );
				$_SESSION['AccessGroupCode'] = fnAccessGroupCode1( $db, $arRow['r_user_level'] );
				$_SESSION['ExtNo'] = '';
				$_SESSION['Lang'] = empty($NowLang) ? "en" : $NowLang;
				$_SESSION['Type'] = 'Slave';
		
				OnLogginProc( $db, '5002', sprintf( "RS_AUSER_INFO Table\\nUserId => %s\\nPassword => %s", $arRow["r_user_id"], $arRow["r_password"] ) );
			}
			else
			{
				OnLogginProc( $db, '5003', sprintf( "UserId => %s\\nPassword => %s", $user_id, $password ) );
			}
		}
	}
}


function fnAccessGroupCode1( $hDb, $sNowLevel ) {

	$sQuery = sprintf( "SELECT r_program_src, r_access_level FROM rs_access_list WHERE r_program_src IN ( 'Search & Play', 'Real time call monitoring' ) AND r_level_code = '%s' "
				, $sNowLevel );
	$hDb->ExecSql( $sQuery, "S" );

	$aReturn = '';

	if ( $hDb->Num > 0 ) {
		while( $aRow = $hDb->Fetch() ) {
			if ( $aRow['r_program_src'] == 'Search & Play' ) $aReturn['Search'] = $aRow['r_access_level'];
			if ( $aRow['r_program_src'] == 'Real time call monitoring' ) $aReturn['Monitoring'] = $aRow['r_access_level'];
		}
		$hDb->ResultFree();
	}
	return $aReturn;
}

?>
