#!/usr/bin/php -d register_globals=0
<?php
/**
 * 1. 업데이트 파일이 있는지 확인한다.
 * 2.1 업데이트 파일이 없으면 fcmanager 실행
 * 2.2 업데이트 파일이 있다면,
 * 3. 업데이트 전에 기존의 웹/IPCR 파일 백업
 * 4. 데이타베이스 백업 ??
 * 5. 업데이트 파일의 압축을 /를 기준으로 압축해제
 * 6. 폴더 권한에 대해서 처리 
 * 7. 2.2 와 같은 동작 
 */


function OnFcmanagerStart()
{
#	system( '/usr/furence/bin/fcmanager start 1>/dev/null' );
}

function OnUpdateFileCheck()
{
	$szResult = system( '/bin/find /var/www/html/work/update/ -name "update_*.tar.gz" -type f -printf "%f\n"', $retval );
	if ( !empty( $szResult ) )
	{
		$arResult = explode( "\n", $szResult );
		$arResult = array_reverse( $arResult );
		$szResult = array_pop( $arResult );
	}
	return trim( $szResult );
}

function OnBackup()
{
	if ( !is_dir( '/var/www/html/backup') )
	{
		mkdir( '/var/www/html/backup', 0700 );
	}
	
	// 웹 소스 백업
	system( sprintf( '/bin/tar cvfz "/var/www/html/backup/backup_web_%s.tar.gz" --exclude=/var/www/html/work/update /var/www/html/work/*', date('YmdHis') ) );
	// 엔진 백업
	system( sprintf( '/bin/tar cvfz "/var/www/html/backup/backup_ipcr_%s.tar.gz" /usr/furence/bin/*', date('YmdHis') ) );
	// db 백업
	// 비밀번호 백업을 위해서
	$fp = fopen( '/var/lib/pgsql/.pgpass', 'w' );
	fwrite( $fp, '*:*:*:*:postgres012' );
	fclose( $fp );
	chmod( '/var/lib/pgsql/.pgpass', 0600 );
	system( '/bin/chown postgres.postgres /var/lib/pgsql/.pgpass' );
	
	// sleep을 안주면 권한을 가지기 전에 먼저 디비 백업을 함. 주의 필요!!
	sleep( 1 );
	
	$szDBBackupFile = sprintf( "backup_db_%s.sql", date( "YmdHis") );
	system( sprintf( 'su - postgres -c "/usr/bin/pg_dump -a  --inserts --column-inserts recsee --file=%s"', $szDBBackupFile ) );
	rename( sprintf( '/var/lib/pgsql/%s', $szDBBackupFile ), sprintf( '/var/www/html/backup/%s', $szDBBackupFile ) );
	@unlink( '/var/lib/pgsql/.pgpass' );
}

function OnExtract( $szUpdateFile )
{
	system( sprintf( "/bin/tar xvfz /var/www/html/work/update/%s -C /", $szUpdateFile ));
	unlink( sprintf( '/var/www/html/work/update/%s', $szUpdateFile ) );
}

function OnCronProc()
{
	/**
	 * 크론 추가/삭제/변경이 있는 경우
	 */
	if ( file_exists( '/var/www/html/work/tmp/cron.txt' ) ) {
		$cron = file_get_contents( '/var/www/html/work/tmp/cron.txt' );
		$cron = preg_replace( '/[\n|\r]/', '', $cron );
		$arCronRow = preg_split( '/\[eot\]/', $cron );

		// proc type | key | cron contents
		$arUpCron = array();
		foreach( $arCronRow AS $idx => $szItem ) {
			if ( is_null( $szItem ) || strlen( trim( $szItem ) ) < 1 ) continue;
			array_push( $arUpCron, preg_split( '/\t/', $szItem ) );
		}
		if ( file_exists( '/var/spool/cron/root' ) ) {
			@system( "/bin/chmod 777 /var/spool/cron/root" );
			
			$now_cron = file_get_contents( '/var/spool/cron/root' );
			$now_cron = preg_replace( '/\r/', '', $now_cron );
			$arnow_cron = preg_split( '/\n/', $now_cron );

			$arcron = $arnow_cron;
			foreach( $arUpCron AS $idx => $arItem ) {
				
				if ( $arItem['0'] == '[del]' ) {
					continue;
				} else if ( $arItem['0'] == "[edit]" ) {
                    $arresult = preg_grep( '/'.$arItem['1'].'/', $arnow_cron );
                    if ( sizeof( $arresult ) < 1 ) {
						array_push( $arcron, $arItem['2'] );
					} else {
						$arkeys =  array_keys( $arresult );
                		$arcron[ $arkeys['0'] ] = $arItem['2'];
					}
                   	continue;
				} else if ( $arItem['0'] == "[new]" ) {
					$arresult = preg_grep( '/'.$arItem['1'].'/', $arnow_cron );
					if ( sizeof( $arresult ) < 1 ) {
						array_push( $arcron, $arItem['2'] );
					} else {
						$arkeys =  array_keys( $arresult );
						$arcron[ $arkeys['0'] ] = $arItem['2'];
					}
					continue;
				}
			}

			$fp = fopen( '/var/www/html/work/tmp/cron.new.txt', 'w' );
			foreach( $arcron as $idx => $szItem ) {
				if ( is_null( $szItem ) || strlen( trim( $szItem ) )  < 1 ) continue;
				fprintf( $fp, "%s\n", $szItem );
			}
			fclose( $fp );
			
			system( "/usr/bin/crontab /var/www/html/work/tmp/cron.new.txt" );

			unlink( "/var/www/html/work/tmp/cron.new.txt" );
			
		} else {
			$arcron = $arnow_cron;
			foreach( $arUpCron AS $idx => $arItem ) {
				
				if ( $arItem['0'] == '[del]' ) {
					continue;
				} else if ( $arItem['0'] == "[edit]" ) {
                    $arresult = preg_grep( '/'.$arItem['1'].'/', $arnow_cron );
                    if ( sizeof( $arresult ) < 1 ) {
						array_push( $arcron, $arItem['2'] );
					} else {
						$arkeys =  array_keys( $arresult );
                		$arcron[ $arkeys['0'] ] = $arItem['2'];
					}
                   	continue;
				} else if ( $arItem['0'] == "[new]" ) {
					$arresult = preg_grep( '/'.$arItem['1'].'/', $arnow_cron );
					if ( sizeof( $arresult ) < 1 ) {
						array_push( $arcron, $arItem['2'] );
					} else {
						$arkeys =  array_keys( $arresult );
						$arcron[ $arkeys['0'] ] = $arItem['2'];
					}
					continue;
				}
			}

			$fp = fopen( '/var/www/html/work/tmp/cron.new.txt', 'w' );
			foreach( $arcron as $idx => $szItem ) {
				if ( is_null( $szItem ) || strlen( trim( $szItem ) ) < 1 ) continue;
				fprintf( $fp, "%s\n", $szItem );
			}
			fclose( $fp );
			
			system( "/usr/bin/crontab /var/www/html/work/tmp/cron.new.txt" );

			unlink( "/var/www/html/work/tmp/cron.new.txt" );
		}
		@unlink( "/var/www/html/work/tmp/cron.txt" );
	}
}

function OnInit()
{
	if ( !is_dir( '/var/www/html/backup') )
	{
		mkdir( '/var/www/html/backup', 0700 );
	}
	@system( "/sbin/chkconfig --add auto_run_fcmanager" );
	@system( "/sbin/chkconfig --level 0123456 auto_run_fcmanager on" );
	
	if ( file_exists( "/var/www/html/work/tmp/cron.txt" ) ) OnCronProc();
}

OnInit();

$szUpdateFile = OnUpdateFileCheck();

if ( !empty( $szUpdateFile ) )
{
	OnBackup();
	OnExtract( $szUpdateFile );
	//OnCronProc();
}

//OnFcmanagerStart();

?>