 /*
 * I N C L U D E S
 */
#include <time.h>
#include <pcap.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>

#include <sys/socket.h>
#include <sys/types.h>
#include <sys/sysinfo.h>
#include <sys/sysctl.h>
#include <sys/ioctl.h>
#include <sys/utsname.h>
#include <sys/statvfs.h>
#include <sys/vfs.h>

#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/if.h>
#include <net/if_arp.h>
#include <netdb.h>
#include <net/ethernet.h>
#include <netinet/if_ether.h>
#include <netinet/tcp.h>
#include <netinet/ip_icmp.h>
#include <netinet/udp.h>
#include <pwd.h>
#include <grp.h>
#include <signal.h>
#include <string.h>

#include <pthread.h>
#include <iostream>
#include <vector>
#include <dirent.h>
#include <stdarg.h>
#include <fstream>
#include <map>
//#include <openssl/ssl.h>

#include "libpq-fe.h"

//#include "regmap.h"

extern "C"
{
#include "iPECS_API.h"
}
#include "RecSeeConf.h"
#include "RecSeeCodec.h"
#include "RecSeeHeader.h"
#include "dysocket.h"
#include "aria_impl.h"


#include "srtp.h"           
#include "rtp.h"
#include "rtp_priv.h"
//#include "session.h"
//#include "crypto.h"

//#include "g72x.h"

#include "RV_SIP_DEF.h"

#ifndef __USE_GNU
#define __USE_GNU
#endif
#include <fcntl.h>

//#ifndef RV_SIP_PRIMITIVES

#if (RV_OS_TYPE == RV_OS_TYPE_INTEGRITY)
#include <unistd.h>
#endif

#include "rvansi.h"
#include "RvSipStackTypes.h"
#include "RvSipStack.h"
#include "RvSipCallLegTypes.h"
#include "RvSipCallLeg.h"
#include "RvSipRegClientTypes.h"
#include "RvSipRegClient.h"
#include "RvSipPartyHeader.h"
#include "RvSipExpiresHeader.h"
#include "RvSipContactHeader.h"
#include "RvSipAddress.h"
#include "RvSipMid.h"

/* Body files*/
#include "RvSipBody.h"
#include "RvSipContentTypeHeader.h"

/* SDP files*/

#include "rvsdpinit.h"
#include "rvsdpmsg.h"
#include "rvsdpsymb.h"
#include "rvsdpenc.h"
#include "rvsdpprsaux.h"
/*
#include "rvsdpconfig.h"
#include "rvsdpenums.h"
#include "rvalloc.h"
#include "rvsdpdataprivate.h"
#include "rvsdpapiprivate.h"
#include "rvsdplist.h"
#include "rvsdpstrings.h"
#include "rvsdpversion.h"

#include "rvsdpdatastruct.h"
*/
#if (RV_OS_TYPE == RV_OS_TYPE_VXWORKS)
#include <vxWorks.h>
#include <taskLib.h>
#include <time.h>
#endif
#if (RV_OS_TYPE == RV_OS_TYPE_WINCE)
#include "simpleOSUtils.h"
#endif

#ifndef RV_SUPPORT_COMMAND_LINE_PARAMETERS
#define RV_SUPPORT_COMMAND_LINE_PARAMETERS
#endif
#if (RV_OS_TYPE == RV_OS_TYPE_SYMBIAN)
#undef RV_SUPPORT_COMMAND_LINE_PARAMETERS
#endif

#if (RV_OS_TYPE == RV_OS_TYPE_NUCLEUS)
#include <nucleus.h>
#endif
/*internal usage only*/
#ifdef USE_INTERNAL_SAMPLE_DEFS
#include "samplesInternalDefs.h"
#endif
/*-----------------------------------------------------------------------*/
/*                           DEFINITIONS                                 */
/*-----------------------------------------------------------------------*/
/*Define the To and From headers as strings*/

//#ifndef USE_INTERNAL_SAMPLE_DEFS

#define FROM "From:<sip:106@127.0.0.1:5060>"
#define TO   "To:<sip:user2@127.0.0.1:5060>"

#define Sipm_SIP_METHOD_LEN 100
#define Sipm_SIP_RSPNS_REASON_LEN 100
#define Sipm_SIP_CONTENT_TYPE_LEN 100
#define Sipm_SIP_MAX_E164_ID_LEN 100
#define Sipm_SIP_MAX_HEADER_BUF 100
#define Sipm_SIP_MS_CALL_SOURCE_LEN 100
#define Sipm_SIP_MAX_URI_LEN] 100
#define Sipm_SIP_MAX_DISPLAY_NAME 100

#define STRING_SIZE             2048
//#endif /*#ifndef USE_INTERNAL_SAMPLE_DEFS*/

//#ifndef USE_INTERNAL_SAMPLE_DEFS

/*Define the registrar address as string. To run the simpleRegistration
  application you need to change this string to the address of your registrar*/
#define REGISTRAR  "sip:172.16.70.105:4444"

/*Define the To and From as strings. Note that the host in the To header is the
  registrars address. Please update this host with the address of your
  registrar. The From header should contain your local SIP-Url. Please update
  it with your local address.*/
#define REG_FROM "From:<sip:bv@172.16.70.105:5060>"
#define REG_TO   "To:<sip:x@172.16.70.105:4444>"

//#endif

/*Define the Expires header value in delta-seconds*/
#define REG_EXPIRES "Expires:3600"

/*Define the Contact headers as strings. Note that CONTACT1 should contain your
  local SIP-Url. Please update it with your local address.*/
#define CONTACT1 "Contact:<sip:y@172.16.70.105:5060>"
#define CONTACT2 "Contact:<sip:me@another.com>;expires=200"


/* SDP and Body Definitions */
#define BODY_TYPE_STRING            "Application/SDP"
#define SDP_ORIGIN_ADDRESS          "client.atlanta.example.com"
#define SDP_ORIGIN_USER_OFFER       "alice"
#define SDP_ORIGIN_USER_ANSWER      "bob"
#define SDP_ORIGIN_SID_OFFER        "2890844526"
#define SDP_ORIGIN_SID_ANSWER       "2890844527"
#define SDP_ORIGIN_VERSION_OFFER    "2890844526"
#define SDP_ORIGIN_VERSION_ANSWER   "2890844527"
#define SDP_SESSION_NAME            "rv_sample_call"
#define SDP_MD_PORT                 6070
#define SDP_MD_ATTRB_NAME           "ptime"
#define SDP_MD_ATTRB_VALUE          "10"
#define SDP_BODY_SIZE               1024
#define SDP_MD_FORMAT               "0"
#define SDP_CONN_ADDRESS            "127.0.0.1"
#define SDP_RTPMAP_ENC              "PCMU"

/* APPENDIX_A
   -----------
   setting APPENDIX_A to 1, will activate code that will create a call
   and individually set necessary fields to connect that call.
*/
#define APPENDIX_A 0

using namespace std;

#ifdef SEGSIZE
#undef SEGSIZE
#endif
#include <arpa/tftp.h>

/* default snap length */
#define SNAP_LEN 65535
#define MAX_FILENAME 256
#define MAX_PHONE_NUMBER 10
#define MAX_IMSG_PREFIX 10
#define MAX_MESSAGE_AGE 1
#define MAX_LATENCY_BINS 1000
#define BIN_SIZE 1
#define MAX_LATENCY_FILE_SIZE 300*1024
#define SCREEN_REFRESH 1

#define EQUAL(_x,_y) (memcmp(_x,_y, sizeof(_y)) == 0)

#define LATENCY_INV_FILE    "inv.latency.txt"
#define LATENCY_180_FILE	"180.latency.txt"
#define LATENCY_200_FILE	"200.latency.txt"
#define LATENCY_ACK_FILE	"ack.latency.txt"
#define LATENCY_BYE_FILE	"bye.latency.txt"
#define LATENCY_ALL_FILE	"all.latency.txt"

#define EXTRACT_16BITS(p) \
	((u_int16_t)ntohs(*(const u_int16_t *)(p)))

#define SPACES " \t\r\n"  

#define NCPUSTATES 4

#define MONITOR_PORT 5800

#define ENC_ARIA_KEY_BITS 192

#define MASTER_KEY_LEN 30


#define	AUDIO_ENCODING_ULAW	(1)	/* ISDN u-law */
#define	AUDIO_ENCODING_ALAW	(2)	/* ISDN A-law */
#define	AUDIO_ENCODING_LINEAR	(3)	/* PCM 2's-complement (0-center) */

struct g72x_state {
	long yl;	/* Locked or steady state step size multiplier. */
	short yu;	/* Unlocked or non-steady state step size multiplier. */
	short dms;	/* Short term energy estimate. */
	short dml;	/* Long term energy estimate. */
	short ap;	/* Linear weighting coefficient of 'yl' and 'yu'. */

	short a[2];	/* Coefficients of pole portion of prediction filter. */
	short b[6];	/* Coefficients of zero portion of prediction filter. */
	short pk[2];	/*
			 * Signs of previous two samples of a partially
			 * reconstructed signal.
			 */
	short dq[6];	/*
			 * Previous 6 samples of the quantized difference
			 * signal represented in an internal floating point
			 * format.
			 */
	short sr[2];	/*
			 * Previous 2 samples of the quantized difference
			 * signal represented in an internal floating point
			 * format.
			 */
	char td;	/* delayed tone detect, new in 1988 version */
};

typedef enum boolean {
	FALSE, TRUE
} boolean;

typedef enum MessageType {
	SIP_INVITE = 0, SIP_ONE_EIGHTY, SIP_OK, SIP_ACK, SIP_BYE, SIP_ALL
} MessageType;


typedef struct Entry {
	u_int32_t phone_number;
	struct timeval ts;
} message_entry;

typedef struct dlist {
	message_entry element;
	struct dlist *next;
	struct dlist *prev;
} Node;


static long cp_old[NCPUSTATES];
static long cp_time[NCPUSTATES];
static long cp_diff[NCPUSTATES];
static int cpu_states[NCPUSTATES];


static time_t current_time;
struct tm *local; /*Time struct*/
time_t t;

pthread_mutex_t mutex_lock = PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t sync_cond  = PTHREAD_COND_INITIALIZER;

int gpid;
typedef struct _fd_sig
{
    int signum;
    int pid;
} fd_sig;

multimap<int, fd_sig> pool_list;
multimap<int, fd_sig>::iterator mi; 

static float avg_inv_latency = 0;

static float avg_180_latency = 0;

static float avg_200_latency = 0;

static float avg_ack_latency = 0;

static float avg_bye_latency = 0;


static u_int16_t max_inv_latency = 0;

static u_int16_t max_180_latency = 0;

static u_int16_t max_200_latency = 0;

static u_int16_t max_ack_latency = 0;

static u_int16_t max_bye_latency = 0;


static u_int32_t total_num_inv = 0;

static u_int32_t total_num_180 = 0;

static u_int32_t total_num_200 = 0;

static u_int32_t total_num_ack = 0;

static u_int32_t total_num_bye = 0;


static u_int32_t latency_inv_histogram[MAX_LATENCY_BINS];

static u_int32_t latency_180_histogram[MAX_LATENCY_BINS];

static u_int32_t latency_200_histogram[MAX_LATENCY_BINS];

static u_int32_t latency_ack_histogram[MAX_LATENCY_BINS];

static u_int32_t latency_bye_histogram[MAX_LATENCY_BINS];

char *imsg_prefix;

Node *incoming_inv_messages = NULL;

Node *incoming_180_messages = NULL;

Node *incoming_200_messages = NULL;

Node *incoming_ack_messages = NULL;

Node *incoming_bye_messages = NULL;


//char *dev = NULL; /* default capture device */
char dev[10];

char *filter_app = NULL; /* filter expression */

char *file_name = NULL; /*capture file name*/

char *imsg_temp_prefix = NULL; /*IMSG prefix to identify incoming/outgoing messages*/

int MF_COUNT;
/*
char desired_id[5];
char desired_number[5];
char pass[10];
char tot_ch[5];
char mpb[20];
*/

char network_code[10];
char nation_code[10];
char local_code[10];
char lik_version[100];

int STATUS_PING_TIME;

char statEvt[1024];

pthread_t sqlthread;
pthread_t logsqlthread;

pthread_t sockthread;
pthread_t monthread;
pthread_t agthread;

pthread_t initthread;
pthread_t resourcethread;
pthread_t pingthread;
pthread_t presthread;
pthread_t alivethread;
pthread_t recordingthread;

pthread_t sipthread;
pthread_t regthread;

pthread_t dummythread;

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;;

PGconn        *conn;

int InitFileChk=0;

int deleted_old = 0;

bool offline = false;

int sockfd;

static u_int32_t msg_cnt=0;

static char *pghost, *pgport, *pgoptions, *dbname,*pguser, *pgpass;

static short qtab_721[7] = {-124, 80, 178, 246, 300, 349, 400};

static short	_dqlntab[16] = {-2048, 4, 135, 213, 273, 323, 373, 425,
				425, 373, 323, 273, 213, 135, 4, -2048};

static short	_witab[16] = {-12, 18, 41, 64, 112, 198, 355, 1122,
				1122, 355, 198, 112, 64, 41, 18, -12};

static short power2[15] = {1, 2, 4, 8, 0x10, 0x20, 0x40, 0x80,
			0x100, 0x200, 0x400, 0x800, 0x1000, 0x2000, 0x4000};


typedef struct rtp_rcv_ctx_t {
  rtp_msg_t message;
  srtp_ctx_t *srtp_ctx;
} rtp_rcv_ctx_t;
typedef struct rtp_rcv_ctx_t *rtp_rcv_t;
rtp_rcv_ctx_t ch_srtp_ctx[500];

static char base64[64];
static char b2a[256];


/*-----------------------------------------------------------------------*/
/*                        GLOBAL VARIABLES                               */
/*-----------------------------------------------------------------------*/

typedef struct s_gvStack
{
	RvSipStackHandle      g_hStackMgr;

	RvSipRegClientMgrHandle g_hRegClientMgr;
	RvSipRegClientHandle     hRegClient;
	RvSipCallLegMgrHandle g_hCallLegMgr;
	RV_LOG_Handle         g_hLog;
	//HRPOOL                g_appPool;
	RvUint16 g_port;
	RvChar g_pFrom[STRING_SIZE];
	RvChar g_pTo[STRING_SIZE];
	RvChar g_pRegFrom[STRING_SIZE];
	RvChar g_pRegTo[STRING_SIZE];
	RvChar g_pRegistrar[STRING_SIZE];
	RvChar g_pContact1[STRING_SIZE];

	char desired_id[5];
	char desired_number[5];
	char pass[10];
	char tot_ch[5];
	char mpb[20];
	int	SYSTEM_ID;

} s_gvStack;
s_gvStack gvStack[10];

/*
static RvSipRegClientMgrHandle g_hRegClientMgr  = NULL;

static RvSipRegClientHandle     hRegClient = NULL;

static RvSipCallLegMgrHandle g_hCallLegMgr  = NULL;

static RV_LOG_Handle         g_hLog         = NULL;
*/
static HRPOOL                g_appPool      = NULL;
/*
static RvUint16 g_port = 5060;

static RvChar g_pFrom[STRING_SIZE]  = FROM;
static RvChar g_pTo[STRING_SIZE]    = TO;


static RvChar g_pRegFrom[STRING_SIZE]       = REG_FROM;
static RvChar g_pRegTo[STRING_SIZE]         = REG_TO;
static RvChar g_pRegistrar[STRING_SIZE]  = REGISTRAR;
static RvChar g_pContact1[STRING_SIZE]   = CONTACT1;

*/

//static RvUint16 g_SdpMdPort = SDP_MD_PORT;

//#endif /*#ifndef RV_SIP_PRIMITIVES*/

static void base64_init(void)
{
	int x;
	memset(b2a, -1, sizeof(b2a));
	/* Initialize base-64 Conversion table */
	for (x=0;x<26;x++) {
		/* A-Z */
		base64[x] = 'A' + x;
		b2a['A' + x] = x;
		/* a-z */
		base64[x + 26] = 'a' + x;
		b2a['a' + x] = x + 26;
		/* 0-9 */
		if (x < 10) {
			base64[x + 52] = '0' + x;
			b2a['0' + x] = x + 52;
		}
	}
	base64[62] = '+';
	base64[63] = '/';
	b2a[(int)'+'] = 62;
	b2a[(int)'/'] = 63;
#if 0
	for (x=0;x<64;x++) {
		if (b2a[(int)base64[x]] != x) {
			fprintf(stderr, "!!! %d failed\n", x);
		} else
			fprintf(stderr, "--- %d passed\n", x);
	}
#endif
}


int ast_base64decode	(	unsigned char * 	dst,
char * 	src,
int 	max	 
)	
{
    int cnt = 0;
    unsigned int byte = 0;
    unsigned int bits = 0;
    int incnt = 0;
 #if 0
    unsigned char *odst = dst;
 #endif
    while(*src && (cnt < max)) {
       /* Shift in 6 bits of input */
       byte <<= 6;
       byte |= (b2a[(int)(*src)]) & 0x3f;
       bits += 6;
 #if 0
       printf("Add: %c %s\n", *src, binary(b2a[(int)(*src)] & 0x3f, 6));
 #endif
       src++;
       incnt++;
       /* If we have at least 8 bits left over, take that character 
          off the top */
       if (bits >= 8)  {
          bits -= 8;
          *dst = (byte >> bits) & 0xff;
 #if 0
          printf("Remove: %02x %s\n", *dst, binary(*dst, 8));
 #endif
          dst++;
          cnt++;
       }
    }
 #if 0
    dump(odst, cnt);
 #endif
    /* Dont worry about left over bits, they're extra anyway */
    return cnt;
}

static void hexdump(const char* title, const unsigned char *s, int l) {
    int n=0;

    if (s == NULL) return;

    fprintf(stderr, "%s",title);
    for( ; n < l ; ++n)
    {
        if((n%16) == 0)
            fprintf(stderr, "\n%04x",n);
        fprintf(stderr, " %02x",s[n]);
    }
    fprintf(stderr, "\n");
}

inline int hex_char_to_nibble(uint8_t c) {
    switch(c) {
    case ('0'): return 0x0;
    case ('1'): return 0x1;
    case ('2'): return 0x2;
    case ('3'): return 0x3;
    case ('4'): return 0x4;
    case ('5'): return 0x5;
    case ('6'): return 0x6;
    case ('7'): return 0x7;
    case ('8'): return 0x8;
    case ('9'): return 0x9;
    case ('a'): return 0xa;
    case ('A'): return 0xa;
    case ('b'): return 0xb;
    case ('B'): return 0xb;
    case ('c'): return 0xc;
    case ('C'): return 0xc;
    case ('d'): return 0xd;
    case ('D'): return 0xd;
    case ('e'): return 0xe;
    case ('E'): return 0xe;
    case ('f'): return 0xf;
    case ('F'): return 0xf;
    default: return -1;   /* this flags an error */
    }
    /* NOTREACHED */
    return -1;  /* this keeps compilers from complaining */
}

/*
 * hex_string_to_octet_string converts a hexadecimal string
 * of length 2 * len to a raw octet string of length len
 */
/*
int
hex_string_to_octet_string(char *raw, char *hex, int len) {
    unsigned int x;
    int tmp;
    int hex_len;

    hex_len = 0;
    while (hex_len < len) {
	tmp = hex_char_to_nibble(hex[0]);
	if (tmp == -1)
	    return hex_len;
	x = (tmp << 4);
	hex_len++;
	tmp = hex_char_to_nibble(hex[1]);
	if (tmp == -1)
	    return hex_len;
	x |= (tmp & 0xff);
	hex_len++;
	*raw++ = x;
	hex += 2;
    }
    return hex_len;
}
*/



//////////////////////////// FUNCTIONS /////////////////////////////////////


void got_packet(u_char *args, const struct pcap_pkthdr *header,
		const u_char *packet);
void udp_print(register const u_char *bp, u_int length,
		register const u_char *bp2, int fragmented);
void safeputchar(int c);
void sip_print(register const u_char *pptr, register u_int len);
message_entry get_data_entry_from_message(const u_char *message,
		const struct pcap_pkthdr *header, MessageType messageType, int len);
u_int32_t extract_phone_number(const u_char *message, int len);
Node *createNode(message_entry item);
Node *insertNodeTail(Node *head, message_entry item);
Node *deleteNode(Node *head, message_entry item, message_entry * found);
void displayNode(Node *head);
message_entry get_matching_entry_from_list(message_entry e, Node **l);
void message_latency_histogram(u_int16_t latency, MessageType type);
u_int16_t calculate_latency(message_entry *first, message_entry *second);
void print_latency_stats();
void exit_program(int sig);
boolean write_latency_to_file(MessageType type, char * file_name);
void message_latency_dump(char *buf, MessageType type);
void print_message_latency_hisogram(char *buf, size_t len, int max_len,
		MessageType type);
void print_latency_hisogram_all(char *buf, size_t len, int max_len);
static void print_help();
void parse_user_input();

//void RecSee_SignalPacketSIP(int chdev,char *bufx,int caplen,int len);
void RecSee_SignalPacketLG(int chdev,char *bufx,int caplen,int len);
void RecSee_RtpPacketSIP(int chdev, char *bufx,int caplen,char *ip);
int RecSee_TSC(int flag, char *IP_Addr, int PORT, char *RTP_DATA, int RTP_LENGTH);

int DBGetChannelInfo();
int DBGetUserInfo();
int MatchingChannelInfo();
int RecSeeChinit(int chdev);
int FindSGCode(char *Code1, char *Code2, char *Code3, int Index);
int FindMGCode(char *Code1, char *Code2, int Index);
int FindBGCode(char *Code, int Index);
string QueueWriteRead(int Type, char *SQlData);
string LogQueueWriteRead(int Type, char *SQlData);
int RecSee_New_Record_Start(int Channel);
int RecSee_New_Record_Stop(int Channel);
int RecSee_New_Record_Stop2(int Channel);
int RecSee_StartSeting(int Channel);
int InitRecordingInfo(int Channel);
int MakeQuery(int Channel);
int RecSee_CfileWrite(int Channel, char * buf, int length);
int RecSee_Mixing(unsigned char* cpFILEBUF_F,unsigned char* cpFILEBUF_S,unsigned char* cpRESULTBUF,int RTP_LENGTH,int Type);
int SetFolder(int IDX, char *DrvFolder,char *PartName, char *DateFolder, char *TimeFolder);
string getInline(char *fHead, char *Tag);
string getHeader(char *fHead, char *Tag);
string getPhoneNo(char *Msg);
char* getSRTPKey(char *fHead, char *Tag);
int FindChannelByDN(char *Extension);
int FindChannelByDN2(char *Extension);
int FindChannelByAgent(char *AgentID);
int FindChannelByPortNo(int PortNo);
int FindChannelByIndex(char *index);
short RecSee_Amplification(short buf,double val);
int HexaFind(int dest_size,unsigned char *dest_char ,int src_size,unsigned char *src_char);
int GetResource();
int ConvertG711ToG721(char *filename);
int SendRegUserInfo();
int UpdateAgentInfomation(char *Extension, char* AgentID);

///////////////////////////////  RADVISION SIP ///////////////////////////////////
#ifdef RV_SUPPORT_COMMAND_LINE_PARAMETERS
static int mainFunc(int argc, char *argv[]);
#else
static int mainFunc();
#endif

//#ifndef RV_SIP_PRIMITIVES

static void AppStackInitialize(int m_index);

static void AppSetCallBackFunctions(int m_index);

static void AppSimpleRegister(int m_index);

//#if (1) /* change to if (1) to use */
//static void AppRegister();
//#endif

static RvStatus AppAddSdpBodyToCall(int chdev, IN RvSipCallLegHandle hCallLeg, IN RvBool bIsSdpOffer);

static RvStatus AppRetrieveSDPBodyFromCall(IN RvSipCallLegHandle hCallLeg, IN RvBool bIsSdpOffer);

static RvStatus AppBuildSdpMessageNegitiation(int chdev, IN RvSdpMsg* pSdpMsg, IN RvBool bIsSdpOffer);

static RvStatus AppViewSDPMessage(IN RvSdpMsg* pSdpMsg, IN RvBool bIsSdpOffer);

//static void AppPrintMessage(IN RvSipMsgHandle hMsg);
static RvChar* AppPrintMessage(IN RvSipMsgHandle hMsg, int bShow, OUT RvChar *sRTPKey, OUT RvChar *cseq, OUT int SEC_TYPE);

#ifdef RV_SUPPORT_COMMAND_LINE_PARAMETERS
static int AppAnalyzeCommandLineArguments(int argc, char *argv[]);
#endif

static int Sipm_SipConnProcInviteInd(RvSipMsgHandle* msg, int calltype, char* AssertId, char *MasterKey, char *SaltKey);

/*---- E V E N T    H A N D L E R S   I M P L M E N T A T I O N ----------*/
static void RVCALLCONV AppCallLegCreatedEvHandler(
                           IN  RvSipCallLegHandle            hCallLeg,
                           OUT RvSipAppCallLegHandle         *phAppCallLeg);

static void RVCALLCONV AppCallLegStateChangedEvHandler(
                           IN  RvSipCallLegHandle            hCallLeg,
                           IN  RvSipAppCallLegHandle         hAppCallLeg,
                           IN  RvSipCallLegState             eState,
                           IN  RvSipCallLegStateChangeReason eReason);

void RVCALLCONV AppReInviteCreatedEvHandler(IN  RvSipCallLegHandle      hCallLeg,
            IN  RvSipAppCallLegHandle     hAppCall,
            IN  RvSipCallLegInviteHandle    hReInvite,
            OUT RvSipAppCallLegInviteHandle   *phAppReInvite,
            OUT RvUint16        *pResponseCode);

void RVCALLCONV AppReInviteStateChangedEvHandler(IN  RvSipCallLegHandle     hCallLeg,
           IN  RvSipAppCallLegHandle    hAppCall,
           IN  RvSipCallLegInviteHandle   hReInvite,
           IN  RvSipAppCallLegInviteHandle   hAppReInvite,
           IN  RvSipCallLegModifyState    eModifyState,
           IN  RvSipCallLegStateChangeReason eReason);

static RvStatus RVCALLCONV AppCallLegMsgReceivedEvHandler(
                           IN  RvSipCallLegHandle            hCallLeg,
                           IN  RvSipAppCallLegHandle         hAppCallLeg,
                           IN  RvSipMsgHandle                hMsg);

static RvStatus RVCALLCONV AppCallLegMsgToSendEvHandler(
                           IN  RvSipCallLegHandle            hCallLeg,
                           IN  RvSipAppCallLegHandle         hAppCallLeg,
                           IN  RvSipMsgHandle                hMsg);

static void RVCALLCONV AppRegClientStateChangedEvHandler(
                           IN  RvSipRegClientHandle            hRegClient,
                           IN  RvSipAppRegClientHandle         hAppRegClient,
                           IN  RvSipRegClientState             eState,
                           IN  RvSipRegClientStateChangeReason eReason);

static RvStatus RVCALLCONV AppRegClientMsgReceivedEvHandler(
                           IN  RvSipRegClientHandle          hRegClient,
                           IN  RvSipAppRegClientHandle       hAppRegClient,
                           IN  RvSipMsgHandle                hMsg);

static RvStatus RVCALLCONV AppRegClientMsgToSendEvHandler(
                           IN  RvSipRegClientHandle          hRegClient,
                           IN  RvSipAppRegClientHandle       hAppRegClient,
                           IN  RvSipMsgHandle                hMsg);

/*--------------------U T I L I T Y   F U N C T I O N S -------------------*/
static const RvChar*  AppGetRegClientStateName (
                                    IN  RvSipRegClientState  eState);

static const RvChar*  AppGetCallLegStateName (IN  RvSipCallLegState  eState);

static const RvChar*  AppGetDirectionName(IN RvSipCallLegDirection eDirection);

static void AppExitOnError(RvChar* str);
//#endif /*#ifndef RV_SIP_PRIMITIVES*/

#if (RV_OS_TYPE == RV_OS_TYPE_SYMBIAN)
extern int  SymbVprintFormat(const char* aFormat,... );
extern void  SymbThreadSleep();
#define OSPrintf  SymbVprintFormat
#else
static int  OSPrintf(IN const char *format,... );
#endif

#if (RV_OS_TYPE == RV_OS_TYPE_SYMBIAN)
#define os_exit(_n) SymbThreadSleep()
#elif (RV_OS_TYPE == RV_OS_TYPE_NUCLEUS)
void os_exit(int n)
{
   RV_UNUSED_ARG(n);
   for (;;)
   {
      NU_Sleep(1000);
   }
}
#else
#define os_exit(_n) exit(_n)
#endif

const double div4giga(1024*1024*1024);



int getBase64IntValue(char letter) {
    switch (letter) {
      case 'A': return 0;  case 'B': return 1;  case 'C': return 2;
      case 'D': return 3;  case 'E': return 4;  case 'F': return 5;
      case 'G': return 6;  case 'H': return 7;  case 'I': return 8;
      case 'J': return 9;  case 'K': return 10; case 'L': return 11;
      case 'M': return 12; case 'N': return 13; case 'O': return 14;
      case 'P': return 15; case 'Q': return 16; case 'R': return 17;
      case 'S': return 18; case 'T': return 19; case 'U': return 20;      
      case 'V': return 21; case 'W': return 22; case 'X': return 23;      
      case 'Y': return 24; case 'Z': return 25; case 'a': return 26;      
      case 'b': return 27; case 'c': return 28; case 'd': return 29;      
      case 'e': return 30; case 'f': return 31; case 'g': return 32;      
      case 'h': return 33; case 'i': return 34; case 'j': return 35;
      case 'k': return 36; case 'l': return 37; case 'm': return 38;      
      case 'n': return 39; case 'o': return 40; case 'p': return 41;      
      case 'q': return 42; case 'r': return 43; case 's': return 44;      
      case 't': return 45; case 'u': return 46; case 'v': return 47;      
      case 'w': return 48; case 'x': return 49; case 'y': return 50;      
      case 'z': return 51; case '0': return 52; case '1': return 53;      
      case '2': return 54; case '3': return 55; case '4': return 56;      
      case '5': return 57; case '6': return 58; case '7': return 59;      
      case '8': return 60; case '9': return 61; case '+': return 62;      
      case '/': return 63; case '=': return 64;
    }
    return -1;
 }


string intToBinary(int number) {
  int remainder(0);
  string answer("");

  while (number > 0) {
    int remainder = number % 2;
    answer = (char)(remainder + (int)'0') + answer;
    number /= 2;
  }

  return answer;
}

int binaryToInt(string binary) {
  int power(1), answer = 0, num(0);
  
  for (int loop = binary.length(); loop > 0; --loop) {
    num = binary.at(loop - 1) - '0';
    answer += (num * power);
    power *= 2;
  }
  
  return answer;
}

 string getBinaryValue(string str) {
    string binaryValue = "";
    string testValue = "";
    int intValue = 0;
    
    for (int loop = 0; loop < str.length(); loop++) {
      intValue = getBase64IntValue(str.at(loop));
      
      if (intValue == -1) {
        cout << "Bad Input Data";
        return "";
      }
      
      string binValue = intToBinary(intValue);
      
      while (binValue.length() < 6) {
        binValue = "0" + binValue;
      }
      
      binaryValue = binaryValue + binValue;
    }
    
    return binaryValue;
}

string binToString(string binary) {
    string returnStr = "";
    
    for (int loop = 0; loop < binary.length(); loop += 8) {
      returnStr += (char)binaryToInt(binary.substr(loop, 8));
    }
    
    return returnStr;
}

/////////////////////////////////////////////////////
long percentages(int cnt, int *out, register long *_new, register long *old, long *diffs)

{
 
	register int i;
 
	register long change;
 
	register long total_change;
 
	register long *dp;
 
	long half_total;
 
	
	total_change = 0;
 
	dp = diffs;
 
	for (i = 0; i < cnt; i++)
 {
  
		if ((change = *_new - *old) < 0)
  {
   
			change = (int)((unsigned long)*_new-(unsigned long)*old);
  
		}
  
		total_change += (*dp++ = change);
  
		*old++ = *_new++;
 
	}
 
	
	if (total_change == 0)
 {
  
		total_change = 1;

	}
 
	
	half_total = total_change / 2l;
 
	for (i = 0; i < cnt; i++)
  *out++ = (int)((*diffs++ * 1000 + half_total) / total_change);
 
	
	return total_change;

}


/*****************************************************************************
 * FUNCTION : 
 *  skip_token()
 * DESCRIPTION :
 *  °ø¹éÀ» skip ÇÏ°í tokenÀ» ¸®ÅÏ
 * PARAMETER :
 *  const char *p : string¿¡ ´ëÇÑ Æ÷ÀÎÅÍ 
 * RETURN VALUE : 
 *  token¿¡ ´ëÇÑ Æ÷ÀÎÅÍ 
 ****************************************************************************/


static char* skip_token(const char *p)

{
 
	while(isspace(*p)) 
  
	p++;
 
	while(*p && !isspace(*p)) 
  
		p++;
 
 
	return (char *)p;

}


/*****************************************************************************
 * FUNCTION : 
 *  get_sys_status()
 * DESCRIPTION :
 *  /proc/statÀ» ÀÐ¾î¼­ cpu »ç¿ë·®À» ¾ò¾î¿À°í
 *  sysinfo() ÇÔ¼ö¸¦ ÀÌ¿ëÇÏ¿© ¸Þ¸ð¸® »ç¿ë·®À» ¾ò¾î¿À´Â ÇÔ¼ö
 * PARAMETER :
 *  float *cpu :  cpu »ç¿ë·® 
 *  float *mem :  memory »ç¿ë·® 
 * RETURN VALUE : 
 *  ¼º°ø½Ã 1 ¸®ÅÏ 
 ****************************************************************************/


int get_sys_status(float *cpu, float *mem)

{
 
	struct sysinfo sys_info;
 
	char buffer[256]; 
 
	int len;
 
	int fd;
 
	const char *file_name ="/proc/stat";
 
	char *p;
 
	long tmp;
 
	memset(&sys_info, 0, sizeof(sys_info));
 
	if(sysinfo(&sys_info) != 0)
	perror("sysinfo error");
 
 

	fd = open(file_name, O_RDONLY);
 
	len = read(fd, buffer, sizeof(buffer));
 
	close(fd);
 
	buffer[len]='\0';
 

	p = skip_token(buffer);
 
	cp_time[0]=strtoul(p, &p, 0);
 
	cp_time[1] = strtoul(p, &p, 0);
 
	cp_time[2] = strtoul(p, &p, 0);
 
	cp_time[3] = strtoul(p, &p, 0);
 
 
	percentages(4, cpu_states, cp_time, cp_old, cp_diff);
 
 
	tmp = cpu_states[0] + cpu_states[1] + cpu_states[2];
 
	*cpu = (tmp/(float)(cpu_states[3]+tmp))*100;
 
	*mem = (((sys_info.totalram/1024 - sys_info.freeram/1024)) / (float)((sys_info.totalram/1024))*100);
 
 
	
	return 1;

}

  


inline string trim_right (const string & s, const string & t = SPACES)  
  
{   
  
	string d (s);   
  
	string::size_type i (d.find_last_not_of (t));  
  
	if (i == string::npos)	return "";  
  
	else  
   return d.erase (d.find_last_not_of (t) + 1) ;   
  
}  // end of trim_right  
  


inline string trim_left (const string & s, const string & t = SPACES)   
  
{   
  
	string d (s);   
  
	return d.erase (0, s.find_first_not_of (t)) ;   
  
}  // end of trim_left  
  


inline string trim (const string & s, const string & t = SPACES)  
  
{   
  
	string d (s);   
  
	return trim_left (trim_right (d, t), t) ;   
  
}  // end of trim  
  
unsigned char dectohex(int dec)
{
	switch(dec)
	{
		case 1: return 0x01;
		case 2: return 0x02;
		case 3: return 0x03;
		case 4: return 0x04;
		case 5: return 0x05;
		case 6: return 0x06;
		case 7: return 0x07;
		case 8: return 0x08;
		case 9: return 0x09;
		case 10: return 0x0a;
		case 11: return 0x0b;
		case 12: return 0x0c;
		case 13: return 0x0d;
		case 14: return 0x0e;
		case 15: return 0x0f;
	}	
}


int Convert_Dec2Hex(int decimal)
{
 int Remainder, tempValue, s, i = 0;
 char Output;
 char hexa;
 char hexPosition[100];

 if(16 < decimal)
 {
  tempValue = decimal;
  //printf("Converting Hexagonal number : ");
  for(i=0; tempValue > 16; i++)
  {
   Remainder = tempValue % 16;
   tempValue = (tempValue / 16);

   if (Remainder > 9)
   {
    hexPosition[i] = Remainder + 55;

   }
   else
   {
    hexPosition[i] = Remainder + 48;
   }
  }
  if (tempValue > 9)
  {
   hexPosition[i] = tempValue + 55;
  }
  else
  {
   hexPosition[i] = tempValue + 48;
  }
  for(s = i; s >= 0 ; s--)
  {
   Output = hexPosition[s];
   //printf("%c", Output);
  }
  //printf("\n");
 }
 else
 {
  Remainder = decimal % 16;
  if (Remainder > 9)
  {
   hexa = Remainder + 55;
  }
  else
  {
   hexa = Remainder + 48;
  }
  printf("Converting Hexagonal number : %c \n", hexa);

 }
 return 1;
}

void HexaEnc(char *hexStr)
{
	int decVal = 0;
	char ch;

	for(int i=0; hexStr[i]; i++) {
                ch = hexStr[i];
                decVal = decVal * 16;   // 자리수가 늘때마다 16을 곱함
                if (ch>='0' && ch<='9') // 0 - 9 사이의 값
                        decVal += ch - '0';
                else {                  // A - F 사이의 값
                        ch = ch & 0xdf; // 소문자를 대문자로 변환
                        decVal += ch - 'A' + 10;
                }
        }
        printf("Hex %s = Dec %d\n",hexStr,decVal);
}

char hexToAscii(char first, char second)
{
	char hex[5], *stop;
	hex[0] = '0';
	hex[1] = 'x';
	hex[2] = first;
	hex[3] = second;
	hex[4] = 0;
	return strtol(hex, &stop, 16);
}

int hexToDec(char first, char second)
{
	char hex[2];
	hex[0] = first;
	hex[1] = second;
	return (int)strtoul(hex, NULL, 16);	
}

int HexaFind(int dest_size,unsigned char *dest_char ,int src_size,unsigned char *src_char)

{
	
	int find_cnt=0;
	
	int find_size = dest_size-src_size;

	
	for (find_cnt=0;find_cnt<find_size;find_cnt++)
	{
		
		if (&dest_char[find_cnt]==0x00) continue;
		
		if(memcmp((char *)&dest_char[find_cnt],(char *)&src_char[0],src_size)==0) return find_cnt;
	
	}
	
	
	return -1;

}

char **my_addrs(int *addrtype)
{    
	struct hostent  *hptr;    
	struct utsname  myname;    
	if (uname(&myname) < 0)	return NULL;    
	if ((hptr = gethostbyname(myname.nodename)) == NULL)	return NULL;    
	*addrtype = hptr->h_addrtype;    
	return (hptr->h_addr_list);
}


int make_mgscnt()
{
  ++msg_cnt;
  return msg_cnt;
}

int hextoint(
	const char *str,
	u_long *ival
	)
{
	register u_long u;
	register const char *cp;

	cp = str;

	if (*cp == '\0')
	    return 0;

	u = 0;
	while (*cp != '\0') {
		if (!isxdigit((int)*cp))
		    return 0;
		if (u >= 0x10000000)
		    return 0;	/* overflow */
		u <<= 4;
		if (*cp <= '9')		/* very ascii dependent */
		    u += *cp++ - '0';
		else if (*cp >= 'a')
		    u += *cp++ - 'a' + 10;
		else
		    u += *cp++ - 'A' + 10;
	}
	*ival = u;
	return 1;
}

int strcnt(char *desk ,char *string)
{
	
	int desk_len;
	int str_len;
	int cmp_cnt=0;
	desk_len=strlen(desk);
	str_len=strlen(string);

	if(desk_len ==0 || str_len ==0){ return -1;}

	for (cmp_cnt=0;cmp_cnt<desk_len;cmp_cnt++)
	{
		if(strncmp(&desk[cmp_cnt],&string[0],str_len)==0) return cmp_cnt+1;
	}
	return -1;
}


unsigned int GetTick(){
	timeval tick;
    gettimeofday (&tick, 0);
    return (tick.tv_sec*1000 + tick.tv_usec/1000);
}


void do_sigio(int signo)
{
    printf("SIGIO : RTS signal queue overflow\n");    
}

void init_signal_handler()
{
    struct sigaction sigact;
    sigemptyset(&sigact.sa_mask);
    sigact.sa_flags        = SA_SIGINFO;
    sigact.sa_restorer    = NULL;
    sigact.sa_handler    = do_sigio;
    if (sigaction(SIGIO, &sigact, NULL) < 0)
    {
        perror("sigaction SIGIO ");
        exit(0);
    }

    return ;
}

int setup_sigio(int fd, int sig_num, int pid)
{
    if (fcntl(fd, F_SETFL, O_RDWR|O_NONBLOCK|O_ASYNC) < 0)
    {
        perror("fcntl NONBLOCK ");
        return -1;
    }
    if (fcntl(fd, F_SETSIG, SIGRTMIN+sig_num) < 0)
    {
        perror("fcntl SETSIG "); 
        return -1;
    }

    if (fcntl(fd, F_SETOWN, pid) < 0)
    {
        perror("fcntl SETOWN ");
        return -1;
    }
    return 0;
}


void *accept_listener(void *data)
{
    int server_sockfd, cli_sockfd;    
    fd_sig lfd_sig;
    int count;
    sigset_t set;
    int client_sockfd;
    socklen_t clilen;
    int ret;

    int signum = *((int *)data);
    struct sockaddr_in serveraddr, clientaddr;
    struct siginfo si;

    if ((server_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    {
        perror("socket error ");
        exit(0);
    }

    bzero(&serveraddr, sizeof(serveraddr));
    serveraddr.sin_family        = AF_INET;
    serveraddr.sin_addr.s_addr    = htonl(INADDR_ANY);
    serveraddr.sin_port            = htons(15000);

    if (bind (server_sockfd, (struct sockaddr *)&serveraddr, 
            sizeof(serveraddr)) == -1)
    {
        perror("bind error ");
        exit(0);
    }

    if (listen(server_sockfd, 5) == -1)
    {
        perror("listen error ");
        exit(0);
    }
    if (setup_sigio(server_sockfd, signum, getpid()) == -1) 
    {
        printf("sigio error\n");
        exit(0);
    }

    sigemptyset(&set);
    sigaddset(&set, SIGRTMIN+signum);
    sigprocmask(SIG_BLOCK, &set, NULL);

    pthread_mutex_lock(&mutex_lock);
    pthread_cond_signal(&sync_cond);
    pthread_mutex_unlock(&mutex_lock);

    while(1)
    {
        int ret;
        ret = sigwaitinfo(&set, &si);
        if (ret == SIGRTMIN+signum)
        {
            if (si.si_fd == server_sockfd) 
            {
                cli_sockfd = accept(server_sockfd, 
                                (struct sockaddr *)&clientaddr,
                                &clilen);
                if(cli_sockfd < 0)
                {
                    printf("Accept error\n");
                    continue;
                }
                mi = pool_list.begin();
                lfd_sig = mi->second;
                count = mi->first+1;

                cout << "Accept " << cli_sockfd << " : " 
                    << mi->second.signum << " : " 
                    << mi->second.pid << endl;
                setup_sigio(cli_sockfd, mi->second.signum, mi->second.pid);
                pool_list.erase(mi);
                pool_list.insert(pair<int, fd_sig>(count, lfd_sig));
            }
            else
            {
            }
        }
    }
}


void *ProcessDo(void *rts_num)
{
    int signum = *((int *)rts_num);
    int ret; 
    socklen_t clen;
    char buf[256];
    struct sockaddr_in cname;
    int n;
    char GubunStr[2];
    char CodeStr[5];
    char ReturnStr[2048];
    char TmpStr[128];

    gpid = getpid(); 

    sigset_t set;

    sigemptyset(&set);
    sigaddset(&set, SIGRTMIN+signum);
    pthread_sigmask(SIG_BLOCK, &set, NULL);

    pthread_mutex_lock(&mutex_lock);
    pthread_cond_signal(&sync_cond);
    pthread_mutex_unlock(&mutex_lock);

    struct siginfo si;
    fd_sig lfd_sig;
    int count;
    int lpid;

    while(1)
    {
        clen = sizeof(cname);
        ret = sigwaitinfo(&set, &si);
        memset(buf,0x00, 256); 
        if (ret == SIGRTMIN+signum)
        {
            if ((n = read (si.si_fd, buf, 255)) <= 0)
            {
                printf("read error \n");
                close(si.si_fd);
                mi = pool_list.begin();
                while(mi != pool_list.end())
                {
                    if (mi->second.signum == signum)
                    {
                        lfd_sig = mi->second;
                        count = mi->first - 1;
                        pool_list.erase(mi);
                        pool_list.insert(pair<int, fd_sig>(count, lfd_sig));
                    }
                    *mi++;
                }
            }    
            else
            {
		/*
                getsockname(si.si_fd, (struct sockaddr *)&cname, &clen);
                printf("%s(%d) : %s", inet_ntoa(cname.sin_addr), signum, buf);
                write(si.si_fd, buf, strlen(buf));
		*/

		getsockname(si.si_fd, (struct sockaddr *)&cname, &clen);
		printf("%s(%d) : %s", inet_ntoa(cname.sin_addr), signum, buf);

		if (strstr(buf, "RECSEE")!=NULL)
		{
			memset(GubunStr,0,sizeof GubunStr);
			memcpy(GubunStr, &buf[7], 1);
			memset(CodeStr,0,sizeof CodeStr);
			memcpy(CodeStr, &buf[9],4);

			memset(TmpStr,0,sizeof TmpStr);
			sprintf(ReturnStr, "/RECSEE/M");

			for (int i=0;i<TOTAL_LINE;i++)
			{
				RecSeeCH[i].STATUS_ING_TIME = (GetTick()/1000) - RecSeeCH[i].STATUS_START_TIME;
				if(RecSeeCH[i].STATUS_ING_TIME>99999){ 
					RecSeeCH[i].STATUS_ING_TIME=99999; 
					RecSeeCH[i].STATUS_START_TIME = (GetTick()/1000);
				}

				if (strcmp(GubunStr,"A")==0)
				{
					sprintf(TmpStr,"|/%-15s/%5s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, 
							RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
					sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
				}
				else if (strcmp(GubunStr,"B")==0)
				{
					if(strcnt((char *)(const char *)CodeStr,RecSeeCH[i].BG_CODE)>0)
					{
						sprintf(TmpStr,"|/%-15s/%5s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, 
							RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
						sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
					}
				}
				else if (strcmp(GubunStr,"M")==0)
				{
					if(strcnt((char *)(const char *)CodeStr,RecSeeCH[i].MG_CODE)>0)
					{
						sprintf(TmpStr,"|/%-15s/%5s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, 
							RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
						sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
					}
				}
				else if (strcmp(GubunStr,"S")==0)
				{
					if(strcnt((char *)(const char *)CodeStr,RecSeeCH[i].SG_CODE)>0)
					{
						sprintf(TmpStr,"|/%-15s/%5s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, 
							RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
						sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
					}
				} 
			}

			
			write(si.si_fd, ReturnStr, strlen(ReturnStr));
			
			//printf("[MON] %s\n", ReturnStr);

		}
            }
        }
        else
        {
        }
    }
}
///////////////////////////////////////////////////////



void sig_int(int sig)
{
    
	printf("Bye!!\n");
    //pcap_close(pd);
    
	close(sockfd);
    
	exit(0);

}



int getMacAddr(const char* szInfName, char* szMac)  
{  
    char* mac_addr = NULL;  
    struct ifreq  ifrq;  
    int fd = socket(AF_INET, SOCK_DGRAM, 0);  
    struct sockaddr *sa = NULL;  
    char raw_mac[6];
    
    static char mac[18];

    memset(&ifrq, 0, sizeof(ifrq));  
    strcpy(ifrq.ifr_name , szInfName);  
  
    if (ioctl(fd, SIOCGIFHWADDR, &ifrq) < 0) {  
        close(fd);  
        fprintf(stderr, "%s:%d> ERROR getMacAddr", __FILE__, __LINE__);  
        return 1;  
    }  
  
    memcpy(raw_mac, &ifrq.ifr_hwaddr.sa_data, 6);
   
    sprintf(szMac, "%02x%02x%02x%02x%02x%02x", raw_mac[0] & 0xff, raw_mac[1] & 0xff, raw_mac[2] & 0xff, raw_mac[3] & 0xff, raw_mac[4] & 0xff, raw_mac[5] & 0xff);

    /* 
    sa = &(ifrq.ifr_hwaddr);  
    mac_addr = (char*) ether_ntoa((struct ether_addr*) sa->sa_data );  
    if (mac_addr == NULL) {  
        printf(stderr, "%s:%d> ERROR getMacAddr", __FILE__, __LINE__);  
        return 1;  
    }  
  
    memset(szMac, 0, sizeof(szMac));  
    sprintf(szMac, "%s", mac_addr);  
    *nLen = strlen(szMac);  
    */

    close(fd);  

    return 0;    
}  

/*
char* char_to_hex( const unsigned char* p_array, unsigned int p_array_len, char** hex2ascii) 
{
    
	unsigned char *str = malloc(p_array_len*2+1);
    
	const unsigned char* p_end = p_array + p_array_len;
    
	size_t pos=0;
    
	const unsigned char* p;
    
	for( p = p_array; p != p_end; p++, pos+=2 ) 
	{
       
		str[pos] = hex2ascii[*p][0];
       
		str[pos+1] = hex2ascii[*p][1];
    
	}
    
	return (char*)str;

}
*/

char *StrToHexStr(char *str)
{
	char *newstr = new char[(strlen(str)*2)+1];
	char *cpold = str;
	char *cpnew = newstr;

	while('\0' != *cpold) {
		sprintf(cpnew, "%02X", (char)(*cpold++));
		cpnew+=2;
	}
	*(cpnew) = '\0';
	return(newstr);
} 

int MakeLogDB(int Code, char *Extension, char *Log)
{
	string Query;
	char QuerySQL[3000];
	char QuerySQL1[1000];
	char QuerySQL2[2000];
	time_t t;
	struct tm *tm;
	struct timeval mytime;
	char CurrDate[10];
	char CurrTime[10];
	int chdev=0;

	time(&t);
	tm=localtime(&t);
    	gettimeofday(&mytime, NULL);
    	
	memset(CurrDate,0x00, sizeof CurrDate);
	memset(CurrTime,0x00, sizeof CurrTime);	
	sprintf(CurrDate,"%04d%02d%02d",tm->tm_year+1900,tm->tm_mon+1,tm->tm_mday);
	sprintf(CurrTime,"%02d%02d%02d",tm->tm_hour,tm->tm_min,tm->tm_sec,mytime);
	
	memset(QuerySQL2, 0x00, sizeof QuerySQL2);

	Query="INSERT INTO rs_log_info(";
	Query = Query + "r_log_date, r_log_time, r_log_type, r_log_ext, r_log_contents";
	Query = Query + ") ";

	sprintf(QuerySQL1,"%s",(char*)Query.c_str());

	sprintf(QuerySQL2,"VALUES('%s','%s','%d','%s','%s')",
			CurrDate,CurrTime,Code,Extension,Log);
	
	sprintf(QuerySQL,"%s%s",QuerySQL1,QuerySQL2);
	//printf("[LOG] %s\n",QuerySQL);
	if (strlen(Extension)>0)
	{
		chdev = FindChannelByDN(Extension);
		if (chdev>0)
		{
			if (RecSeeCH[chdev].LOG_YN==0) return 0;
		}
	}
	
	LogQueueWriteRead(1, QuerySQL);	

	return 1;
}

int SendRegUserInfo()
{
	///////////////////////////////////////////
	/*
	[Agent Index(nibble : 2byte) + length(nibble : 1byte) + Agent ID(string : length 길이만큼 <  20)]가 반복됨.
	*/
	////////////////////////////////////////////
	
	char sendbuf[1024];
	char tmpbuf[100];
	char login[1024];
	unsigned int idx=0;
	int i,j,k,m,n,size;
	char len[4];
	char tmpdec[2];
	char extnum[10];
	char cRecvData[100];

	size=0;
	for (i=1;i<=TOTAL_LINE;i++)
	{
		size+=(4+strlen(RecSeeCH[i].EXT_NUM));
	}
	sprintf(len,"%04x",size);

	memset(sendbuf,0,sizeof sendbuf);
	sprintf(sendbuf, "010b000000000d38%s",len);

	memset(login,0,sizeof login);
	for (j=0,m=0;j<strlen(sendbuf); j+=2,m++)
	{
		login[m] = hexToAscii(sendbuf[j],sendbuf[j+1]);
	}	

	size = 0;
	for (i=1;i<=TOTAL_LINE;i++)
	{
		memset(tmpbuf,0,sizeof tmpbuf);
		//sprintf(tmpbuf,"%02d",i);
		sprintf(tmpbuf,"%04x",i);
		for (j=0;j<strlen(tmpbuf);j+=2)
		{
			login[m++] = hexToAscii(tmpbuf[j],tmpbuf[j+1]);
		}
		// 20100519 sim
		/*
		login[m++] = hex_char_to_nibble(tmpbuf[0]);
		login[m++] = hex_char_to_nibble(tmpbuf[1]);
		*/
		size+=2;

		memset(extnum,0,sizeof extnum);
		sprintf(extnum, "%s", RecSeeCH[i].EXT_NUM);

		sprintf(tmpdec,"%d",strlen(extnum));
		login[m++] = hex_char_to_nibble(tmpdec[0]);
		size++;

		for (k=0;k<strlen(extnum);k++)
		{
			login[m++] = extnum[k];
			size++;
		}
		if (RecSeeCH[i].AUTO_REC==1)
		{
			login[m++] = 0x00;
		}
		else
		{
			login[m++] = 0x01;
		}
		size++;
	}
	for (i = 0; i < m; i++)
	{
		printf("%02x",login[i]);
		
	}
	idx = size+10;
	printf("\nREGISTERED USER -> %s\n", sendbuf);	
	
	for (int k=0; k<MF_COUNT; k++)
	{
		//iPECS_SndDataToSystemEx(login, idx, dectohex(k+1));
	}
	

	MakeLogDB(1160,"",sendbuf);

	return 0;
}

void CallbackFuncCR(char* pszRcvData, unsigned long dwLength, unsigned char ucSysID)
//void CallbackFuncCR(char* pszRcvData, unsigned long dwLength)
{
	string sRecvData;
	char cRecvData[2048];
	char HexCode[3];
	string cmd;
	int i;
	time_t t;
	struct tm *tm;
	struct timeval mytime;
	char rfield[5];
	char rlen[5];
	char result[5];
	int len=0;
	int offset=0;
	char rdata[1024];
	char index[10];
	char station[10];
	char extension[10];
	char status[5];
	int chdev=0;
	u_long *flag;
	char sendbuf[10];
	unsigned int idx=0;
	char tmp[100];
	int m,j;

	memset(cRecvData,0,sizeof cRecvData);
	for (i = 0; i < dwLength; i++)
	{
		//printf("%02x",(unsigned char)pszRcvData[i]);
		sprintf(cRecvData+strlen(cRecvData),"%02x",(unsigned char)pszRcvData[i]);
	}

	sRecvData = cRecvData;
	cmd = sRecvData.substr(0,4);
//printf("stat evt [%s]\n", cRecvData);
	if (cmd == "0106")   //LOGIN IND
	{
		memset(result,0,sizeof result);
		memcpy(result,&cRecvData[20],4);
		//if (strcmp(result,"1007")==0)
		//{
			offset = 24;
			for (i=0;i<strlen(cRecvData);i+=(offset-24))
			{ 
				memset(rfield,0,sizeof rfield);
				memset(rlen,0,sizeof rlen);
				memset(rdata,0,sizeof rdata);
				memcpy(rfield, &cRecvData[offset],4);
				offset+=4;
				memcpy(rlen, &cRecvData[offset],4);
				len = atoi(rlen);
				offset+=4;
				if (len>0)
				{
					memcpy(rdata,&cRecvData[offset],len*2);
					offset+=(len*2);
				}
				if (strcmp(rfield,"0418")==0)  //capacity
				{	
					TOTAL_CHANNEL = (int)strtoul(rdata, NULL, 16);
					
					printf("MAXIMUM CHANNEL : %d\r\n", TOTAL_CHANNEL);
				}
				else if (strcmp(rfield,"0d2f")==0) //network code
				{
					memset(tmp,0,sizeof tmp);
					for (int j=0,m=0;j<strlen(rdata);j+=2,m++)
					{
						tmp[m] = hexToAscii(rdata[j],rdata[j+1]);
					}
					memset(network_code,0,sizeof network_code);
					sprintf(network_code,"%s",tmp);
					
					printf("NETWORK CODE : %s\r\n", network_code);
				}
				else if (strcmp(rfield,"0d30")==0)  //nation code
				{
					memset(tmp,0,sizeof tmp);
					for (int j=0,m=0;j<strlen(rdata);j+=2,m++)
					{
						tmp[m] = hexToAscii(rdata[j],rdata[j+1]);
					}
					memset(nation_code,0,sizeof nation_code);
					sprintf(nation_code,"%s",tmp);

					printf("NATION CODE : %s\r\n", nation_code);
				}
				else if (strcmp(rfield,"0d31")==0)  //local code
				{
					memset(tmp,0,sizeof tmp);
					for (int j=0,m=0;j<strlen(rdata);j+=2,m++)
					{
						tmp[m] = hexToAscii(rdata[j],rdata[j+1]);
					}
					memset(local_code,0,sizeof local_code);
					sprintf(local_code,"%s",tmp);
					printf("LOCAL CODE : %s\r\n", local_code);
				}
				else if (strcmp(rfield,"0d32")==0)  //version
				{
					memset(tmp,0,sizeof tmp);
					for (int j=0,m=0;j<strlen(rdata);j+=2,m++)
					{
						tmp[m] = hexToAscii(rdata[j],rdata[j+1]);
					}
					memset(lik_version,0,sizeof lik_version);
					sprintf(lik_version,"%s",tmp);
					printf("VERSION : %s\r\n", lik_version);
				}
			}
			MakeLogDB(1121,"",cRecvData);	
			
			SendRegUserInfo();

			memset(sendbuf,0,sizeof sendbuf);	
			sendbuf = {0X03, 0X08, 0X00, 0X00, 0X00, 0X00};
			idx = 6;
			//iPECS_SndDataToSystemEx(sendbuf, idx, ucSysID);
			MakeLogDB(1130,"","PRESENCE START REQUEST");	
		//}	
		//else {
		//	printf("LOGIN FAIL...Try again!!!\r\n");
		//	MakeLogDB(1122,"",cRecvData);	
		//}
	}
	else if (cmd == "0108")  //LOGOUT IND
	{
		MakeLogDB(1125,"",cRecvData);
		if (sRecvData.substr(20,4)=="0000"){
			printf("LIK LOGOUT Comlete...\r\n");
		}
		else{
			printf("LIK LOGOUT Fail...\r\n");
		}
	}
	else if (cmd == "010a")  // PING IND
 	{
		MakeLogDB(1141,"",cRecvData);
		if (sRecvData.substr(20,4)=="0000"){
			STATUS_PING_TIME = GetTick()/1000;
			printf("MFIM is alived...\n");
		}
	}
	else if (cmd == "0309") // PRES START IND
	{
		if (sRecvData.substr(20,4)=="0000"){
			MakeLogDB(1131,"",cRecvData);
			printf("LIK Presence Ind Complete...\r\n");
		}
		else{
			MakeLogDB(1132,"",cRecvData);
			printf("LIK Presence Ind Fail...\r\n");
		}

	}
	else if (cmd == "030a") // STATUS EVENT
	{
/*
		if (strlen(cRecvData)<(TOTAL_CHANNEL*8)+16)
		{
			printf("status1 = %s\n", cRecvData);
			sprintf(statEvt+strlen(statEvt),"%s",cRecvData);
		}
		else
		{
			if (strlen(statEvt)==0) memcpy(statEvt,cRecvData,strlen(cRecvData));
					
			MakeLogDB(1151,"",cRecvData);
			memset(result,0,sizeof result);
			memcpy(result,&statEvt[12],4);
			if (strcmp(result,"041c")==0)
			{
				offset = 16;
				//printf("status2 = %s\n", statEvt);
				memcpy(rlen, &statEvt[offset],4);
				len = (int)strtoul(rlen, NULL, 16);
//printf("len=%d\n",len);
				offset+=4;				
				for (i=0;i<(len/4);i++)
				{
					memset(index,0,sizeof index);
					memset(station,0,sizeof station);
					memcpy(index, &statEvt[offset],4);
					offset+=4;
					memcpy(station, &statEvt[offset],4);
					memset(extension,0,sizeof extension);
					for (j=0,m=0;j<strlen(station);j++,m++)
					{
						if (station[j] == '0')
						{
							m--;
						}
						else if (station[j] == 'a')
						{
							extension[m] = '0';
						}
						else
						{
							extension[m] = station[j];
						}
					}
					offset+=4;
					chdev = FindChannelByDN(extension);
					if (chdev>0) {
						memset(RecSeeCH[chdev].IndexCode,0,sizeof RecSeeCH[chdev].IndexCode);
						sprintf(RecSeeCH[chdev].IndexCode,"%s",index);
					}
					printf("[INDEX %d] %s [STATION] %s\r\n", i+1, index, extension);
				}
				
			}

			memset(statEvt,0,sizeof statEvt);
		}
*/
	}
	else if (cmd == "030b")  // PRES EVENT
	{
		MakeLogDB(1152,"",cRecvData);
/*
		memset(result,0,sizeof result);
		memcpy(result,&cRecvData[12],4);
		if (strcmp(result,"041d")==0)
		{
			offset = 16;
			//printf("status2 = %s\n", statEvt);
			memcpy(rlen, &cRecvData[offset],4);
			len = (int)strtoul(rlen, NULL, 16);
			offset+=4;				
			for (i=0;i<(len/4);i++)
			{
				memset(index,0,sizeof index);
				memset(status,0,sizeof status);
				memcpy(index, &cRecvData[offset],4);
				offset+=4;
				memcpy(status, &cRecvData[offset],2);
				offset+=2;
				chdev = FindChannelByIndex(index);
				if (chdev>0) {
					//memset(RecSeeCH[chdev].IndexCode,0,sizeof RecSeeCH[chdev].IndexCode);
					//sprintf(RecSeeCH[chdev].IndexCode,"%s",index);
				}
				printf("[INDEX %d] %s [STATUS] %s\r\n", i+1, index, status);
			}
			printf("PRES evt [%s]\n", cRecvData);
		}
*/
	}
	else if (cmd=="010d")
	{
		memset(result,0,sizeof result);
		memcpy(result,&cRecvData[12],4);
		if (strcmp(result,"0d38")==0)
		{
			offset = 20;
			memset(index,0,sizeof index);
			memset(status,0,sizeof status);
			memcpy(index, &cRecvData[offset],4);
			offset+=4;
			memcpy(status, &cRecvData[offset],2);
			//chdev = FindChannelByIndex(index);
			chdev = (int)strtoul(index,NULL,16);// atoi(index);
			if (chdev>0)
			{
				if (RecSeeCH[chdev].AUTO_REC==0)
				{
					if (RecSeeCH[chdev].IPCR_REC == 0)
					{
						RecSeeCH[chdev].BLOCK_YN=atoi(status);
						printf("ODR[%s] AUTO=%d, BLOCK=%d\n",RecSeeCH[chdev].EXT_NUM,RecSeeCH[chdev].AUTO_REC,RecSeeCH[chdev].BLOCK_YN);
					}
					else
					{
						printf("ODR[%s] proceeding now!\n",RecSeeCH[chdev].EXT_NUM);
					}
				}
			}
		}
		printf("ODR Record [%s]\n", cRecvData);

	}
	else if (cmd == "030d")  // PRES STOP
	{
		MakeLogDB(1136,"",cRecvData);
		if (sRecvData.substr(20,4)=="0000"){
			printf("LIK Presence Stop Complete...\r\n");
		}
		else{
			printf("LIK Presence Stop Fail...\r\n");
		}
	}
	else if (cmd == "0311")  // START RECORDING IND
	{
		
	}
	else if (cmd == "0312")  // SMDI EVENT
	{

	}
	else if (cmd == "010e")
{
		if (sRecvData.substr(20,4)=="0000")
		{
			printf("LIK RESTART!!!\n");
				exit(0);
		}
}
}


static short search(short val,short *table, short size)
{
	short i;

	for (i = 0; i < size; i++) {
		if (val <= *table++)
		{
			return  (i);
		}
	}

	return (size);
}

int ulaw2linear(unsigned char	u_val)
{
	int		t;

	/* Complement to obtain normal u-law value. */
	u_val = ~u_val;

	/*
	 * Extract and bias the quantization bits. Then
	 * shift up by the segment number and subtract out the bias.
	 */
	t = ((u_val & QUANT_MASK) << 3) + BIAS;
	t <<= ((unsigned)u_val & SEG_MASK) >> SEG_SHIFT;

	return ((u_val & SIGN_BIT) ? (BIAS - t) : (t - BIAS));
}

// this funtion is import share library
unsigned char linear2ulaw(short pcm_val) /* 2's complement (16-bit range) */
{
	short mask;
	short seg;
	unsigned char uval;

/* Get the sign and the magnitude of the value. */
	pcm_val = pcm_val >> 2;
	if (pcm_val < 0) {
		pcm_val = -pcm_val;
		mask = 0x7F;
	} 
	else {
		mask = 0xFF;
	}
	if ( pcm_val > CLIP ) pcm_val = CLIP; /* clip the magnitude */
	pcm_val += (BIAS >> 2);

	/* Convert the scaled magnitude to segment number. */
	seg = search(pcm_val, seg_uend, 8);

	/*
	* Combine the sign, segment, quantization bits;
	* and complement the code word.
	*/
	if (seg >= 8) /* out of range, return maximum value. */
		return (unsigned char) (0x7F ^ mask);
	else {
		uval = (unsigned char) (seg << 4) | ((pcm_val >> (seg + 1)) & 0xF);
		return (uval ^ mask);
	}
}

int FindChannelByDN(char *Extension)
{
	int Channel;
	char ExtNum[10];
//printf("TOTAL_LINE=%d\n",TOTAL_LINE);
	for(int chdev =1; chdev <= TOTAL_LINE; chdev++)
	{
		memset(ExtNum,0,sizeof ExtNum);
		memcpy(ExtNum,RecSeeCH[chdev].EXT_NUM,strlen(RecSeeCH[chdev].EXT_NUM));

		if(strcmp(Extension,ExtNum)==0)
		{
			Channel = chdev;
			return Channel;
		}
	}

	return 0;
}

int FindChannelByDN2(char *Extension)
{
	int Channel;
	char ExtNum[10];
//printf("TOTAL_LINE=%d\n",TOTAL_LINE);
	for(int chdev =1; chdev <= TOTAL_LINE; chdev++)
	{

		if(strcmp(Extension,RecSeeEX[chdev].EXT_NUM)==0)
		{
//printf("find2 channel === > %s\n", RecSeeEX[chdev].EXT_NUM);
			//Channel = atoi(RecSeeCH[chdev].CH_NUM);
			Channel = chdev;
			return Channel;
		}
	}

	return 0;
}

int FindChannelByAgent(char *AgentID)
{
	int Channel;
	
	for(int chdev=1; chdev <= TOTAL_LINE; chdev++)
	{
		if(strcmp(RecSeeCH[chdev].USER_ID,AgentID)==0)
		{
			Channel = chdev;
			return Channel;
		}
	}

	return -1;
}

int FindChannelByPortNo(int PortNo)
{
	int Channel;

	for(int chdev =1; chdev <= TOTAL_LINE; chdev ++)
	{
		if (RecSeeCH[chdev].PortNo==PortNo)
		{
			//Channel = atoi(RecSeeCH[chdev].CH_NUM);
			Channel = chdev;
			return Channel;
		}
	}

	return -1;
}

int FindChannelByIndex(char *index)
{
	int Channel;

	for(int chdev =1; chdev <= TOTAL_LINE; chdev ++)
	{
		if(strcmp(index,RecSeeCH[chdev].IndexCode)==0)
		{
			Channel = chdev;
			return Channel;
		}
	}

	return -1;	
}

string QueueWriteRead(int Type, char *SQlData)
{
	int i;
	string SqlFormat="";

	if(Type==1)
	{
		if(SQLIndex==999)
		{
			SQLIndex=0;
		}else{
			SQLIndex= SQLIndex+1;
		}

		memset(SQLLOG[SQLIndex].SQL,0,sizeof SQLLOG[SQLIndex].SQL);
		sprintf(SQLLOG[SQLIndex].SQL, "%s", SQlData);
		SQLLOG[SQLIndex].UsingYN = 1;
		
		SQLYN=1;
	}else{
		
		for(i=0; i<1000; i++)
		{
			if(SQLLOG[i].UsingYN==1)
			{
				SqlFormat = SQLLOG[i].SQL;
				//SqlFormat.Format("%s",SQLLOG[i].SQL);
				memset(SQLLOG[i].SQL,0,sizeof SQLLOG[i].SQL);
				SQLLOG[i].UsingYN = 0;
				return SqlFormat;
			}

		}
		SQLYN =0;
	}

	return SqlFormat;
}

string LogQueueWriteRead(int Type, char *SQlData)
{
	int i;
	string SqlFormat="";

	if(Type==1)
	{
		if(SQLMIndex==999)
		{
			SQLMIndex=0;
		}else{
			SQLMIndex= SQLMIndex+1;
		}

		memset(SQLMLOG[SQLMIndex].SQL,0,sizeof SQLMLOG[SQLMIndex].SQL);
		sprintf(SQLMLOG[SQLMIndex].SQL, "%s", SQlData);
		SQLMLOG[SQLMIndex].UsingYN = 1;
		
		SQLMYN=1;
	}else{
		
		for(i=0; i<1000; i++)
		{
			if(SQLMLOG[i].UsingYN==1)
			{
				SqlFormat = SQLMLOG[i].SQL;
				//SqlFormat.Format("%s",SQLMLOG[i].SQL);
				memset(SQLMLOG[i].SQL,0,sizeof SQLMLOG[i].SQL);
				SQLMLOG[i].UsingYN = 0;
				return SqlFormat;
			}

		}
		SQLMYN =0;
	}

	return SqlFormat;
}

void *RTSocketThread(void *arg){

	char tempbuf[100];
	int len_out;
	char ext_num[6];
	char SEOption[2];
	char NullChar[1];
	int Channel;

	int EXTNUM;
	
	int cnt;
	
	string SEOPtion2;
	string RemoteIP;
	string rstr;	
	
	string Command;
	
	char RTPacket[100];
	sockaddr_in clientfd;
	
	char clientip[20];


	int server_sockfd, client_sockfd, sockfd;

    // select 를 통해서 넘어오는 fd 의 갯수
    int fd_num;    

    int state, client_len;
    int i, maxi, maxfd;
    char rbuf[255];
    char line[255];
    int client[FD_SETSIZE];

    struct sockaddr_in clientaddr, serveraddr;
    fd_set readfds, allfds;

    fd_num = 0;

    if ((server_sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0)
    {
        perror("socket error : ");
        exit(0);
    }
    bzero(&serveraddr, sizeof(serveraddr));
    serveraddr.sin_family = AF_INET;
    serveraddr.sin_addr.s_addr = htonl(INADDR_ANY);
    serveraddr.sin_port = htons(10050);

    state = bind (server_sockfd, (struct sockaddr *)&serveraddr, 
                  sizeof(serveraddr));            
    if (state == -1)
    {
        perror("bind error : ");
        exit(0);
    }    
    state = listen(server_sockfd, 5);
    if (state == -1)
    {
        perror("listen error : ");                
        exit(0);
    }
    // INET 소켓작성 끝

    client_sockfd = server_sockfd;

    maxi = -1;

    // 현재 fd 의 최대값을 maxfd 에 입력한다. 
    maxfd = server_sockfd;

    // fd 배열을 -1 로 초기화 한다. 
    // 후에 accept 를 성공하면 해당 fd 로 배열을 채운다. 

    for (i = 0; i < FD_SETSIZE; i++)
    {
        client[i] = -1;
    }

    // INET 소켓 fd 에 대하여, fd_set 에 등록한다. 
    FD_ZERO(&readfds);
    FD_SET(server_sockfd, &readfds);

    memset(line, 0x00, 255);
    while(1)
    {
        
        allfds = readfds;

        fd_num = select(maxfd + 1 , &allfds, (fd_set *)0, 
                      (fd_set *)0, NULL);

        // 만약 소켓 파일지사자에 연결(읽기)이 들어온다면
        // accept 한다. 
        if (FD_ISSET(server_sockfd, &allfds))
        {
            client_len = sizeof(clientaddr);
            // accept 한다. 
            client_sockfd = accept(server_sockfd, (struct sockaddr *)&clientaddr, (socklen_t*)&client_len);                
			//client_sockfd = accept(server_sockfd, (struct sockaddr *)&clientaddr, sizeof(clientaddr));                
		sprintf(clientip, inet_ntoa(clientaddr.sin_addr));

            // client 배열에 현재 연결된 client_sockfd 를 
            // 입력한다. 
            for (i = 0; i < FD_SETSIZE; i++)
            {
                if (client[i] < 0)
                {
                    client[i] = client_sockfd;
                    printf("%d : %d\n", i, client_sockfd);
                    break;
                }
            }

            // FD_SETSIZE 를 초과해서 client 가 접근할경우 
            // 연결을 종료한다. 
	    if (i == FD_SETSIZE)
            {
                close(sockfd);
                client[i] = -1;
            }

            // fd_set 에 등록한다.
            FD_SET(client_sockfd,&readfds);

            if (client_sockfd > maxfd)
                maxfd = client_sockfd;

            if (i > maxi)
                maxi = i;

            if (--fd_num <= 0)
                continue;
        }

        // client 배열에 입력된 fd 중 
        // 연결이된 (-1 이아닌) fd 에 대해서 
        // 읽을 데이타가 있는지 검사한후 
        // 읽을 데이타가 있으면 처리한다. 
        for (i = 0; i <= maxi; i++)
        {
            if ((sockfd = client[i]) < 0)
            {
                continue;    
            }

            printf("maxi %d\n", maxi);
            if (FD_ISSET(sockfd, &allfds))
            {
                memset(rbuf, 0x00, 255);
                if (read(sockfd, rbuf, 255) <= 0)
                {
                    close(sockfd);
                    FD_CLR(sockfd, &readfds);    
                    client[i] = -1;
                }
                else
                {
					memset(NullChar, 0x00, sizeof NullChar);
		
					if (strstr(rbuf, "policy")!=NULL){
						memset(RTPacket, 0, sizeof RTPacket);
						sprintf(RTPacket,"%s%s","<cross-domain-policy><allow-access-from domain=\"*\" to-ports=\"*\" /></cross-domain-policy>\0",NullChar);
						write(sockfd, RTPacket, strlen(RTPacket));
					}

					if (strstr(rbuf, "RECSEE")!=NULL)
					{
						
						rstr=rbuf;

						EXTNUM = atoi(trim(rstr.substr(8,6)).c_str());
						
						printf("Realtime request extension [%d]\n",EXTNUM);		
						
						Channel = PHONE_LINE[EXTNUM];
						
						Command = rstr.substr(15,1);
						
						MakeLogDB(3301,RecSeeEX[Channel].EXT_NUM,tempbuf);	
						//printf("CH : [%d]\n", Channel);
						
						if (Command == "R")
						{
							
							SEOPtion2 = rstr.substr(17,1);
							//RemoteIP = trim(rstr.substr(18,20));

							if (SEOPtion2 == "S")
							{
								
								if (Channel > 0)
								{
									
									if(1000 < RECSEE_CH[Channel].kcnt)
									{
										
										cnt = 0;
										
										for (int j=0;j<5;j++)
										{
											
											if (RecSeeCH[Channel].monclient[j].MonFlag == 1)
												
												cnt++;
										
										}
										
										if (cnt>4)
										{	
											
											sprintf(RTPacket,"/RECSEE/%6s/R/S/4/", RecSeeEX[Channel].EXT_NUM);
											
											write(sockfd, RTPacket, strlen(RTPacket));
										
										}
										
										else
										{
											
											sprintf(RTPacket,"/RECSEE/%6s/R/S/1/", RecSeeEX[Channel].EXT_NUM);
											
											write(sockfd, RTPacket, strlen(RTPacket));
											
											for (int k=0;k<5;k++)
											{
												
												if (RecSeeCH[Channel].monclient[k].MonFlag==0) 
												{
													
													memset(RecSeeCH[Channel].monclient[k].IPAddress, 0, sizeof RecSeeCH[Channel].monclient[k].IPAddress);
													
													sprintf(RecSeeCH[Channel].monclient[k].IPAddress, "%s", clientip);
													
													RecSeeCH[Channel].monclient[k].MonFlag = 1;
													
													break;
												
												}
											
											}
										
										}
										MakeLogDB(3302,RecSeeEX[Channel].EXT_NUM,RTPacket);
									}
									
									else
									
									{
										
										sprintf(RTPacket,"/RECSEE/%6s/R/S/3/", RecSeeEX[Channel].EXT_NUM);
											
										write(sockfd, RTPacket, strlen(RTPacket));
										
										//PacketRTMakeSending(Channel, sc, 3);
									
									}
								
								}
								
								else
								{	
									
									sprintf(RTPacket,"/RECSEE/%6s/R/S/2/", RecSeeEX[Channel].EXT_NUM);
											
									write(sockfd, RTPacket, strlen(RTPacket));
									
									MakeLogDB(3302,RecSeeEX[Channel].EXT_NUM,RTPacket);	
									//PacketRTMakeSending(Channel, sc, 2);
								
								}
							
								printf("RT SEND==> %s\n", RTPacket);
							}							
							else
							{
								
									for (int i=0;i<5;i++)
									{
										if (strcmp(RecSeeCH[Channel].monclient[i].IPAddress , clientip)==0)
										{
										
											RecSeeCH[Channel].monclient[i].MonFlag = 0;
										
											memset(RecSeeCH[Channel].monclient[i].IPAddress,0,sizeof RecSeeCH[Channel].monclient[i].IPAddress);
										
										    sprintf(RTPacket,"/RECSEE/%6s/R/E/1/", RecSeeEX[Channel].EXT_NUM);
											
											write(sockfd, RTPacket, strlen(RTPacket));

											break;
									
										}
								
									}
							
							}
						
						}
					
					}

					/*
                    if (strncmp(buf, "quit", 4) ==0)            
                    {
                        write(sockfd, "bye bye\n", 8);
                        close(sockfd);
                        FD_CLR(sockfd, &readfds);    
                        client[i] = -1;
                        break;
                    }
					*/
                }
                if (--fd_num <= 0)
                    break;
            }
        }
    }
/*
	CDYSOCKET cServer;			// Create Server Class
	char rbuf[100];
	
	char tempbuf[100];
	int len_out;
	char ext_num[6];
	char SEOption[2];
	char NullChar[1];
	int Channel;

	int EXTNUM;
	
	int cnt;
	
	string SEOPtion2;
	string RemoteIP;
	string rstr;	
	
	string Command;
	
	char RTPacket[100];
	sockaddr_in clientfd;
	
	char clientip[20];


	if( cServer.CreateServerSocket( 10050 ) == FALSE )
	{
		MakeLogDB(3007,"","REALTIME SOCKET LISTEN FAIL");
		cServer.PrintErrMessage( cServer.GetErrCode() );
		return NULL;
	
	}
	while( 1 )
	{
		printf("RealTime Listening Waiting...\n");

		if( cServer.Accept() < 0 )
		{
			MakeLogDB(3006,"","REALTIME SOCKET ACCEPT FAIL");
			printf("Accept fail.\n");
			
			break;
		}
		//struct sockaddr_in	
		
		clientfd = cServer.GetClientAddr();
		
		sprintf(clientip, inet_ntoa(clientfd.sin_addr));
		printf("Client Connect : %s\n", clientip);
		len_out = cServer.Read( rbuf, sizeof( rbuf ) );
		//cServer.Write( rbuf, len_out );
		
		rbuf[ len_out ] = '\0';
		printf("RealTime Message : %s\n", rbuf );

		memset(tempbuf,0,sizeof tempbuf);
		sprintf(tempbuf,"%s",rbuf);
		//memcpy(tempbuf,rbuf,strlen(rbuf));
		
		memset(NullChar, 0x00, sizeof NullChar);
		
		if (strstr(rbuf, "policy")!=NULL){
			memset(RTPacket, 0, sizeof RTPacket);
			sprintf(RTPacket,"%s%s","<cross-domain-policy><allow-access-from domain=\"*\" to-ports=\"*\" /></cross-domain-policy>\0",NullChar);
			cServer.Write(RTPacket, strlen(RTPacket)); 
		}

		if (strstr(rbuf, "RECSEE")!=NULL)
		{
			
			rstr=tempbuf;

			EXTNUM = atoi(trim(rstr.substr(8,5)).c_str());
			
			printf("Realtime request extension [%d]\n",EXTNUM);		
			
			Channel = PHONE_LINE[EXTNUM];
			
			Command = rstr.substr(14,1);
			
			MakeLogDB(3301,RecSeeEX[Channel].EXT_NUM,tempbuf);	
			//printf("CH : [%d]\n", Channel);
			
			if (Command == "R")
			{
				
				SEOPtion2 = rstr.substr(16,1);
				//RemoteIP = trim(rstr.substr(18,20));

				if (SEOPtion2 == "S")
				{
					
					if (Channel > 0)
					{
						
						if(1000 < RECSEE_CH[Channel].kcnt)
						{
							
							cnt = 0;
							
							for (int j=0;j<5;j++)
							{
								
								if (RecSeeCH[Channel].monclient[j].MonFlag == 1)
									
									cnt++;
							
							}
							
							if (cnt>4)
							{	
								
								sprintf(RTPacket,"/RECSEE/%5s/R/S/4/", RecSeeEX[Channel].EXT_NUM);
								
								cServer.Write(RTPacket, strlen(RTPacket)); 
								
									//PacketRTMakeSending(Channel, sc, 4);
							
							}
							
							else
							{
								
								sprintf(RTPacket,"/RECSEE/%5s/R/S/1/", RecSeeEX[Channel].EXT_NUM);
								
								cServer.Write(RTPacket, strlen(RTPacket)); 

								
								//PacketRTMakeSending(Channel, sc, 1);
								
								for (int k=0;k<5;k++)
								{
									
									if (RecSeeCH[Channel].monclient[k].MonFlag==0) 
									{
										
										memset(RecSeeCH[Channel].monclient[k].IPAddress, 0, sizeof RecSeeCH[Channel].monclient[k].IPAddress);
										
										sprintf(RecSeeCH[Channel].monclient[k].IPAddress, "%s", clientip);
										
										RecSeeCH[Channel].monclient[k].MonFlag = 1;
										
										break;
									
									}
								
								}
							
							}
							MakeLogDB(3302,RecSeeEX[Channel].EXT_NUM,RTPacket);
						}
						
						else
						
						{
							
							sprintf(RTPacket,"/RECSEE/%5s/R/S/3/", RecSeeEX[Channel].EXT_NUM);
								
							cServer.Write(RTPacket, strlen(RTPacket)); 
							
							//PacketRTMakeSending(Channel, sc, 3);
						
						}
					
					}
					
					else
					{	
						
						sprintf(RTPacket,"/RECSEE/%5s/R/S/2/", RecSeeEX[Channel].EXT_NUM);
								
						cServer.Write(RTPacket, strlen(RTPacket)); 
						
						MakeLogDB(3302,RecSeeEX[Channel].EXT_NUM,RTPacket);	
						//PacketRTMakeSending(Channel, sc, 2);
					
					}
				
					printf("RT SEND==> %s\n", RTPacket);
				}
				
				else
				
				{
					
						for (int i=0;i<5;i++)
						{
						
							if (strcmp(RecSeeCH[Channel].monclient[i].IPAddress , clientip)==0)
						
							{
							
								RecSeeCH[Channel].monclient[i].MonFlag = 0;
							
								memset(RecSeeCH[Channel].monclient[i].IPAddress,0,sizeof RecSeeCH[Channel].monclient[i].IPAddress);
							
								break;
						
							}
					
						}
				
				}
			
			}
		
		}

		
		cServer.CloseClientFD();
		printf("REAL Client close.\n");
	}
	cServer.CloseSocket();
*/	
	
	return NULL;


}



		
	
	
void *monSocketThread(void *arg){

	CDYSOCKET cServer;			// Create Server Class
	//char rbuf[100];
	
	char tempbuf[100];
	int len_out;
	char ext_num[6];
	char SEOption[2];
	char NullChar[1];
	int Channel;

	
	int EXTNUM;
	
	int cnt;
	
	string SEOPtion2;
	
	string rstr;	
	
	string Command;
	
	char RTPacket[100];
	struct sockaddr_in clientfd;
	
	char clientip[20];

	
	char buf[256];
   	struct sockaddr_in cname;
    	int n;
    	char GubunStr[2];
    	char CodeStr[5];
    	char ReturnStr[2048];
    	char TmpStr[128];



	if( cServer.CreateServerSocket( 19000 ) == FALSE )
	{
		MakeLogDB(3002,"","MONITORING SOCKET OPEN FAIL");
		cServer.PrintErrMessage( cServer.GetErrCode() );
		return NULL;
	
	}
	MakeLogDB(3301,"","MONITORING SOCKET OPEN OK");
	
	while( 1 )
	{
		printf("Monitoring Waiting...\n");

		
		if( cServer.Accept() < 0 )
{
			MakeLogDB(3303,"","MONITORING SOCKET ACCEPT FAIL");
			printf("Accept fail.\n");
			
			break;
		
		}
		//struct sockaddr_in	
		
		clientfd = cServer.GetClientAddr();
		
		sprintf(clientip, "%s", inet_ntoa(clientfd.sin_addr));
		printf("Monitoring Clinet Connect : %s\n", clientip);
		len_out = cServer.Read( buf, sizeof( buf ) );
		//cServer.Write( rbuf, len_out );
		
		buf[ len_out ] = '\0';
		printf("Monitoring Request Message : %s\n", buf );

		
		memset(tempbuf,0,sizeof tempbuf);
		sprintf(tempbuf,"%s",buf);
		//memcpy(tempbuf,buf,strlen(buf));
		
		
		memset(NullChar, 0x00, sizeof NullChar);
		
		if (strstr(buf, "policy")!=NULL){
			memset(ReturnStr, 0, sizeof ReturnStr);
			sprintf(ReturnStr,"%s%s","<cross-domain-policy><allow-access-from domain=\"*\" to-ports=\"*\" /></cross-domain-policy>\0",NullChar);
			cServer.Write(ReturnStr, strlen(ReturnStr)); 
		}
		
	
		if (strstr(buf, "RECSEE")!=NULL)///RECSEE/M/A/    /
		{
			rstr=tempbuf;

			MakeLogDB(3101,"",tempbuf);

			memset(GubunStr,0,sizeof GubunStr);
			memcpy(GubunStr, &buf[10], 1);
			memset(CodeStr,0,sizeof CodeStr);
			memcpy(CodeStr, &buf[12],4);

			memset(TmpStr,0,sizeof TmpStr);
			sprintf(ReturnStr, "/RECSEE/M");

			for (int i=1;i<=TOTAL_LINE;i++)
			{
				RecSeeCH[i].STATUS_ING_TIME = (GetTick()/1000) - RecSeeCH[i].STATUS_START_TIME;
				if(RecSeeCH[i].STATUS_ING_TIME>99999){ 
					RecSeeCH[i].STATUS_ING_TIME=99999; 
					RecSeeCH[i].STATUS_START_TIME = (GetTick()/1000);
				}

				if (strcmp(GubunStr,"A")==0)
				{
					sprintf(TmpStr,"|/%-15s/%6s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
					sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
				}
				else if (strcmp(GubunStr,"B")==0)
				{
					if(strcnt((char *)(const char *)CodeStr,RecSeeCH[i].BG_CODE)>0)
					{
						sprintf(TmpStr,"|/%-15s/%6s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
						sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
					}
				}
				else if (strcmp(GubunStr,"M")==0)
				{
					if(strcnt((char *)(const char *)CodeStr,RecSeeCH[i].MG_CODE)>0)
					{
						sprintf(TmpStr,"|/%-15s/%6s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
						sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
					}
				}
				else if (strcmp(GubunStr,"S")==0)
				{
					if(strcnt((char *)(const char *)CodeStr,RecSeeCH[i].SG_CODE)>0)
					{
						sprintf(TmpStr,"|/%-15s/%6s/%1s/%5d/%15s/%1s/", RecSeeCH[i].USER_ID, RecSeeEX[i].EXT_NUM, RecSeeCH[i].NOW_STATUS,RecSeeCH[i].STATUS_ING_TIME,RecSeeCH[i].CUST_PHONE1,RecSeeCH[i].CALL_KIND1);
						sprintf(ReturnStr+strlen(ReturnStr), "%s", TmpStr);
					}
				} 
			}  // for

		
//printf("send=%s\n",ReturnStr);			
			if (cServer.Write(ReturnStr, strlen(ReturnStr))<0)
			{
				printf("MON WRITE ERROR");
			} 
			
			printf("[MON] response ==> %s\n",ReturnStr);
			MakeLogDB(3302,"",ReturnStr);

		} //if

		cServer.CloseClientFD();
		printf("MON Client close.\n");
	}  // while
	
	
	cServer.CloseSocket();
	return NULL;

}
	



void *ODRecordThread(void *arg){

	CDYSOCKET cServer;            // Create Server Class  
    char tempbuf[100]; 
    int len_out; 
    char ext_num[6]; 
    char SEOption[2]; 
    char NullChar[1]; 
    int Channel; 
 
    int EXTNUM; 
     
    int cnt; 
     
    string SEOPtion2; 
     
    string rstr;     
     
    string Command; 
     
    char RTPacket[100]; 
    sockaddr_in clientfd; 
     
    char clientip[20]; 
     
    char buf[256]; 
	struct sockaddr_in cname; 
	int n; 
	char GubunStr[2]; 
	char CodeStr[5]; 
	char ReturnStr[2048]; 
	char TmpStr[128]; 
 
    if( cServer.CreateServerSocket( 15000 ) == FALSE ) 
    { 
		MakeLogDB(3005,"","ONDEMAND SOCKET OPEN FAIL");
        cServer.PrintErrMessage( cServer.GetErrCode() ); 
        return NULL;     
    } 
 
    MakeLogDB(3004,"","ONDEMAND SOCKET OPEN OK");

    while( 1 ) 
    {         
        printf("OnDemand Recording Waiting...\n"); 
 
        if( cServer.Accept() < 0 ) 
        {     
	    	MakeLogDB(3006,"","ONDEMAND SOCKET ACCEPT FAIL");	
            printf("OnDemand Recording Accept fail.\n");     
            break;     
        } 
      
        clientfd = cServer.GetClientAddr(); 
         
        sprintf(clientip, inet_ntoa(clientfd.sin_addr)); 
        //printf("Monitoring Clinet Connect : %s\n", clientip); 
        len_out = cServer.Read( buf, sizeof( buf ) ); 
        
        buf[ len_out ] = '\0'; 
        printf("OnDemand Client Message : %s\n", buf ); 
         
        memset(tempbuf,0,sizeof tempbuf); 
        sprintf(tempbuf,"%s",buf); 
        //memcpy(tempbuf,buf,strlen(buf)); 
	        
        memset(NullChar, 0x00, sizeof NullChar); 
         
        if (strstr(buf, "policy")!=NULL){ 
            memset(ReturnStr, 0, sizeof ReturnStr); 
            sprintf(ReturnStr,"%s%s","<cross-domain-policy><allow-access-from domain=\"*\" to-ports=\"*\" /></cross-domain-policy>\0",NullChar); 
            cServer.Write(ReturnStr, strlen(ReturnStr));  
        } 
         
         
        if (strstr(buf, "RECSEE")!=NULL) 
        { 
            rstr=tempbuf; 
             
            EXTNUM = atoi(trim(rstr.substr(23,5)).c_str());
             
            printf("OnDemand request extension [%d]\n",EXTNUM);            
             
            Channel = PHONE_LINE[EXTNUM];
             
            Command = rstr.substr(21,1); 
            
			MakeLogDB(3201,RecSeeEX[Channel].EXT_NUM,tempbuf);

			if (Command=="S")
			{
				if (RecSeeCH[Channel].AUTO_REC==0)
				{
					// WRITE TIME
					RecSeeCH[Channel].BLOCK_YN = 1;
					RecSeeCH[Channel].IPCR_REC = 1;
				}
			}
			else if(Command=="E")
			{
				//RecSee_New_Record_Stop2(Channel);
				if (RecSeeCH[Channel].AUTO_REC==0)
				{
					RecSeeCH[Channel].BLOCK_YN = 0;
				}
			}
             
        } //if 
         
        cServer.CloseClientFD(); 
        printf("OD Client close.\n"); 
    }  // while 
     
     
    cServer.CloseSocket(); 
    return NULL; 

}


void *AgentThread(void *arg){

	CDYSOCKET cServer;            // Create Server Class  
    char tempbuf[100]; 
    int len_out; 
    char ext_num[10];
	  char AgentID[10]; 
    char SEOption[2]; 
    char NullChar[1]; 
    int Channel; 
 
    int EXTNUM; 
     
    int cnt; 
     
    string SEOPtion2; 
     
    string rstr;     
     
    string Command; 
     
    char RTPacket[100]; 
    sockaddr_in clientfd; 
     
    char clientip[20]; 
     
    char buf[256]; 
	struct sockaddr_in cname; 
	int n; 
	char GubunStr[2]; 
	char CodeStr[5]; 
	char ReturnStr[2048]; 
	char TmpStr[128]; 

	char sendbuf[1024];
	char tmpbuf[100];
	char login[1024];
	unsigned int idx=0;
	int i,j,k,m,size;
	char len[4];
	char tmpdec[2];
	char extnum[10];
	char cRecvData[100];
	char Ext[10];

    if( cServer.CreateServerSocket( 20000 ) == FALSE ) 
    { 
		//MakeLogDB(3005,"","AGENT SOCKET OPEN FAIL");
        cServer.PrintErrMessage( cServer.GetErrCode() ); 
        return NULL;     
    } 
 
    //MakeLogDB(3004,"","AGENT SOCKET OPEN OK");

    while( 1 ) 
    {         
        printf("AGENT Recording Waiting...\n"); 
 
        if( cServer.Accept() < 0 ) 
			{     
	    	//MakeLogDB(3006,"","AGENT SOCKET ACCEPT FAIL");	
            printf("AGENT Recording Accept fail.\n");     
            break;     
        		} 
      
        clientfd = cServer.GetClientAddr(); 
         
        sprintf(clientip, inet_ntoa(clientfd.sin_addr)); 
        //printf("AGENT Clinet Connect : %s\n", clientip); 
        len_out = cServer.Read( buf, sizeof( buf ) ); 
        
        buf[ len_out ] = '\0'; 
        printf("AGENT Client Message : %s\n", buf ); 
         
        memset(tempbuf,0,sizeof tempbuf); 
        sprintf(tempbuf,"%s",buf);  
	        
        memset(NullChar, 0x00, sizeof NullChar); 
         
        if (strstr(buf, "policy")!=NULL){ 
            memset(ReturnStr, 0, sizeof ReturnStr); 
            sprintf(ReturnStr,"%s%s","<cross-domain-policy><allow-access-from domain=\"*\" to-ports=\"*\" /></cross-domain-policy>\0",NullChar); 
            cServer.Write(ReturnStr, strlen(ReturnStr));  
        } 
               
        if (strstr(buf, "RECSEE")!=NULL) 
        { 
            rstr=tempbuf; 
				
			Command = rstr.substr(8,1); 
         
			memset(Ext,0,sizeof Ext);
			sprintf(Ext,"%s",(char*)trim(rstr.substr(10,8)).c_str());
			EXTNUM = atoi(Ext);
    
            printf("AGENT request extension [%d]\n",EXTNUM);            
    
			if (Command=="C")
			{
				DBGetChannelInfo();
				DBGetUserInfo();
				MatchingChannelInfo();

				SendRegUserInfo();
			}
			else if(Command=="D")
			{
				DBGetChannelInfo();
				DBGetUserInfo();
				MatchingChannelInfo();
				SendRegUserInfo();
			}
        } //if 
         
        cServer.CloseClientFD(); 
        printf("AGENT Client close.\n"); 
    }  // while 
     
     
    cServer.CloseSocket(); 
    return NULL; 

}


void *SipProcessThread(void *arg){
	
	char errbuf[PCAP_ERRBUF_SIZE]; /* error buffer */
	pcap_t *descr; /* sniff handler */
	struct bpf_program fp; /* compiled program */
	bpf_u_int32 maskp; /* subnet mask */
	bpf_u_int32 netp; /* ip */
	int numOfPackets = 0; /* number of packets to capture, 0 infinite */
	pcap_if_t *alldevs, *d;
	u_int inum, i = 0;

	/*Open interface for live capture*/
	/* Open the device */
	if ((descr = pcap_open_live(dev, SNAP_LEN, 1, 20, errbuf)) == NULL) {
		printf("pcap_open_live failed: %s\n", errbuf);
		exit(EXIT_FAILURE);
	}

	/* print capture info */
	printf("Device: [%s]\n", dev);
	
	/* apply the rules */
	//if (pcap_compile(descr, &fp, filter_app, 0, netp) == -1) {
	if (pcap_compile(descr, &fp, " ip", 0, 0xffffff) == -1) {	
		printf("pcap_compile failed\n");
		exit(EXIT_FAILURE);
	}
	if (pcap_setfilter(descr, &fp) == -1) {
		printf("pcap_setfilter failed\n");
		exit(EXIT_FAILURE);
	}
	//	Get start time
	t = time(NULL);
	local = localtime(&t);

	pcap_loop(descr, 0, got_packet, NULL);
	
	printf("Bye sip process thread\n");

	return NULL;
}


void *SQLProcessingThread(void *arg){

	string str;
	char	LoginStr[1024];
	PGresult *res;
	char query[2048];
	struct timespec stTime;

	while(1)
	{
		if(SQLYN==1)
		{
			 str = QueueWriteRead(2,"");		
	
			 if(str!="")
			 {
				memset(query,0,sizeof query);
				sprintf(query,"%s",(char*)str.c_str());
//printf("query: %s\n",query);
				res = PQexec(conn, query);	 
				//LogSave2("", (char *)(const char *)str, "SQL");
			 }
		}

		//stTime.tv_nsec=500*10000*1000*250;	// 20 m
		
//nanosleep(&stTime,NULL);
		sleep(1);
	}
	return NULL;
}


void *LogSQLProcessingThread(void *arg){

	string str;
	PGresult *res;
	char query[10000];
	struct timespec stTime;
	FILE *fp;
	char fname[30];
	char currDate[10];
	time_t t;
	struct tm *tm;
	struct timeval mytime;

	time(&t);
	tm=localtime(&t);
   gettimeofday(&mytime, NULL);
  	
	memset(currDate,0,sizeof currDate);
	sprintf(currDate,"%04d%02d%02d", tm->tm_year+1900,tm->tm_mon+1,tm->tm_mday);
	
	while(1)
	{
		if(SQLMYN==1)
		{
			 str = LogQueueWriteRead(2,"");		
	
			 if(str!="")
			 {
				memset(query,0,sizeof query);
				sprintf(query,"%s\r\n",(char*)str.c_str());

				res = PQexec(conn, query);
				if (res<0)
				{
					memset(fname,0,sizeof fname);
					sprintf(fname,"/usr/furence/log/%s.log",currDate);
					fp = fopen(fname, "a+");
					fwrite(query, strlen(query), 1, fp);
					fclose(fp);
				}	 
			 }
		}

		//stTime.tv_nsec=500*10000*1000*250;	// 20 m
		//nanosleep(&stTime,NULL);
		sleep(1);
	}
	return NULL;
}


void *GetResourceThread(void *arg){
	
	time_t t;
	struct tm *tm;
	struct timeval mytime;
	char currTime[3];

	while(1)
	{
		time(&t);
		tm=localtime(&t);
	   gettimeofday(&mytime, NULL);
	  
		memset(currTime,0,sizeof currTime);
		sprintf(currTime,"02d",tm->tm_min);

		if (strcmp(currTime,"00")==0)
		{
			GetResource();
		}
		//stTime.tv_nsec=500*1000*1000*25;	// 20 m
		
		sleep(60);

	}
	return NULL;
}
void *InitializeThread(void *arg){
	time_t t;
	struct tm *tm;
	struct timeval mytime;
	char currTime[3];
	
	while(1)
	{
		time(&t);
		tm=localtime(&t);
		gettimeofday(&mytime,NULL);
		memset(currTime,0,sizeof currTime);
		sprintf(currTime,"%02d",tm->tm_hour);
		if (strcmp(currTime,"04")==0)
		{
			DBGetChannelInfo();
			DBGetUserInfo();
			MatchingChannelInfo();
			SendRegUserInfo();
		}
		sleep(3500);
	}
	return NULL;
}

void *RegistarThread(void *arg)
{
	RvStatus	rv;

	while (1)
	{
		sleep(1000);
		
		for (int i=0;i<MF_COUNT;i++)
		{
			if (gvStack[i].hRegClient==NULL)
			{
				continue;
			}
			rv = RvSipRegClientTerminate(gvStack[i].hRegClient);
			if(rv != RV_OK)
			{
				//AppExitOnError("Failed to terminate the register-client");
				printf("Failed to terminate the register-client\n");
				continue;
			}

			AppSimpleRegister(i);
		}
		
	}
	return NULL;
}

void *PingSendThread(void *arg){
	int idx;
	char sendbuf[20];
	
	while(1)
	{
		//fflush(stdout);
		//memset(sendbuf,0,sizeof sendbuf);	
		sendbuf = {0X01, 0X09, 0X00, 0X00, 0X00, 0X00};
		
		printf("Ping REQ Message\n");
		
		idx = 6;//strlen(sendbuf);
		
		for (int i=0;i<MF_COUNT;i++)
		{
			//iPECS_SndDataToSystemEx(sendbuf, idx, dectohex(i+1));
		}
	
		MakeLogDB(1140,"","PING REQUEST");

		sleep(60);

	}
	return NULL;
}

void *PresSendThread(void *arg){
	int idx;
	char sendbuf[20];
	
	fflush(stdout);
	memset(sendbuf,0,sizeof sendbuf);	
	sendbuf = {0X03, 0X08, 0X00, 0X00, 0X00, 0X00};
	idx = 6;
	
	for (int i=0;i<MF_COUNT;i++)
	{
		//iPECS_SndDataToSystemEx(sendbuf, idx, dectohex(i+1));
	}

	return NULL;
}

void *AliveCheckThread(void *arg){
	int idx;
	char sendbuf[20];
	int currTime;
	
	while(1)
	{
		currTime = GetTick()/1000;
		
		if (currTime-STATUS_PING_TIME>300)
		{
			MakeLogDB(1180,"","MFIM DEAD");
			printf("Dead LIK Communication\r\n");

			// MFIM, SIP ReRegistar
			exit(0);

		}
		

		sleep(60);

	}
	return NULL;
}


void *DummyProcessThread(void *arg){
	PGresult *res;
	char query[100];

	sprintf(query, "select to_char(current_timestamp, 'HH12:MI:SS')");
	
	while(1)
	{
		if(SQLMYN==1)
		{
			res = PQexec(conn, query);	 
			
		}

		sleep(10);
	}
}



int main(int argc, char *argv[])
/*
#ifdef RV_SUPPORT_COMMAND_LINE_PARAMETERS
static int mainFunc(int argc, char *argv[])
#else
static int mainFunc()
#endif
*/
{
//#ifndef RV_SIP_PRIMITIVES
#ifdef RV_SUPPORT_COMMAND_LINE_PARAMETERS
    int rc;
#endif
    OSPrintf("Executing IPCR Session\n");
/*
#ifdef RV_SUPPORT_COMMAND_LINE_PARAMETERS
    rc = AppAnalyzeCommandLineArguments(argc, argv);
    if (rc != 0)
        return rc;
#endif
*/
	char errbuf[PCAP_ERRBUF_SIZE]; /* error buffer */
	pcap_t *descr; /* sniff handler */
	struct bpf_program fp; /* compiled program */
	bpf_u_int32 maskp; /* subnet mask */
	bpf_u_int32 netp; /* ip */
	int numOfPackets = 0; /* number of packets to capture, 0 infinite */
	pcap_if_t *alldevs, *d;
	u_int inum, i = 0;
	int ret;
	struct timespec stTime;
	struct in_addr host_ip;
	char sMacAddr[64] = {0,};  
	int nLength = 0;  
	int ip1,ip2,ip3,ip4;
	
	char hexmpb[9];
	unsigned long hmpb;
	
	CDYSOCKET cServer;			// Create Server Class
	char rbuf[100];
	
	char tempbuf[100];
	int len_out;
	char ext_num[6];
	char SEOption[2];
	int Channel;
	unsigned long idx;
	
	int EXTNUM;
	
	int cnt;
	
	string SEOPtion2;
	string rstr;	
	string Command;
	
	char RTPacket[100];
	sockaddr_in clientfd;
	
	char clientip[20];

	struct siginfo si;
	int status;
	int k,m,n;
	fd_sig lfd_sig;
	sigset_t set;

	char sendbuf[100];
	char presbuf[10];
	char SPLIT2[50][30];
	char *CHECK2;
	char myip[10];
	char tempip[20];
	long unsigned int result = 0;
	int j;
	char login[100];
	char pid[10];
	string sVersion;
	char cVersion[5];
	//CRegMap uReg;
	char query[100];
	
	//uReg.SetFile("/usr/furence/conf/IPCR.conf");
	//uReg.ReadRegistry();

	FILE	*pidFile;

	pid_t p_pid, sid;
         
        p_pid = fork();
	if (p_pid < 0) {
			exit(EXIT_FAILURE);
	}
	
	if (p_pid > 0) {
			exit(EXIT_SUCCESS);
	}

	umask(0);
	
	sid = setsid();
	if (sid < 0) {
			exit(EXIT_FAILURE);
	}
	
	if ((chdir("/")) < 0) {
			exit(EXIT_FAILURE);
	}

	//close(STDIN_FILENO);
	//close(STDOUT_FILENO);
//	close(STDERR_FILENO);
	
	sprintf(pid,"%d",getpid());
	printf("pid=%s\n", pid);
	
	pidFile = fopen("/usr/furence/pid/IPCR.pid", "wb");
	fwrite(pid, strlen(pid), 1, pidFile);
	fclose(pidFile);

//	Catch CTRL+C siganl
	(void) signal(SIGINT, exit_program);

    pghost = "localhost";
    pgport = "5432";
    pgoptions = NULL;
    dbname = "recsee";

    pguser = "postgres"; 
    pgpass = "postgres012";

    // psql ����Ÿ ���̽��� �����Ѵ�.
    conn = PQsetdbLogin(pghost, pgport, pgoptions, NULL, 
                        dbname, pguser, pgpass);

    if (PQstatus(conn) == CONNECTION_BAD)
    {
		MakeLogDB(1301,"","DATABASE OPEN FAIL");
        fprintf(stderr, "%s", PQerrorMessage(conn));
        exit(0);
    }
	printf("DB Start\n");


	MakeLogDB(1000,"","SYSTEM START");
	MakeLogDB(1300,"","DATABASE OPEN OK");

	parse_user_input();

	DBGetChannelInfo();
	
	DBGetUserInfo();
	MatchingChannelInfo();

	base64_init();
	srtp_init();

	if (pthread_create(&sqlthread,NULL,SQLProcessingThread,NULL))
	{
		printf("Error Creating SQL Thread!...\n");
		abort();
	}

	if (pthread_create(&logsqlthread,NULL,LogSQLProcessingThread,NULL))
	{
		printf("Error Creating LOG SQL Thread!...\n");
		abort();
	}
	
	if (pthread_create(&sockthread,NULL,RTSocketThread,NULL))
	{
		printf("Error Creating RT Socket Thread!...\n");
		abort();
	}
	
	if (pthread_create(&monthread,NULL, monSocketThread,NULL))
	{
		printf("Error Creating Monitoring Socket Thread!...\n");
		abort();
	}
	
	if (pthread_create(&resourcethread,NULL, GetResourceThread,NULL))
	{
		printf("Error Creating Resource Thread!...\n");
		abort();
	}		
	if (pthread_create(&initthread,NULL,InitializeThread,NULL))
	{
		printf("Error Creating Init Thread!...\n");
		abort();
	}

	if (pthread_create(&recordingthread,NULL,ODRecordThread,NULL))
	{
		printf("Error Creating OnDemand Recording Thread!...\n");
		abort();
	}

	if (pthread_create(&agthread,NULL,AgentThread,NULL))
	{
		printf("Error Creating Agent Thread!...\n");
		abort();
	}


	if (pcap_lookupnet(dev, &netp, &maskp, errbuf) == -1) {
		printf("pcap_lookupnet failed: %s\n", errbuf);
	}

	getMacAddr(dev, sMacAddr);

	memset(tempip,0,sizeof tempip);
	sprintf(tempip,"%s",SYSTEM_IP);
	memset(SPLIT2,0,sizeof SPLIT2);
	CHECK2 = strtok( tempip, "." );

	for (j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
	{
		if(CHECK2!=NULL){
			sprintf(SPLIT2[j],(char*)CHECK2);
		}else{
			break;
		}
	}

	sprintf(myip, "%x%x%x%x", atoi(SPLIT2[0]),atoi(SPLIT2[1]),atoi(SPLIT2[2]),atoi(SPLIT2[3]));

	printf("my ip address = [%s]%s\n", SYSTEM_IP, myip);

	for (int mc=0;mc<MF_COUNT;mc++)
	{
		memset(tempip,0,sizeof tempip);
		sprintf(tempip,"%s",gvStack[mc].mpb);
		memset(SPLIT2,0,sizeof SPLIT2);
		CHECK2 = strtok( tempip, "." );

		for (j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
		{
			if(CHECK2!=NULL){
				sprintf(SPLIT2[j],(char*)CHECK2);
			}else{
				break;
			}
		}
		hmpb = (atoi(SPLIT2[0]) << 24) + (atoi(SPLIT2[1]) << 16) + (atoi(SPLIT2[2]) << 8) + atoi(SPLIT2[3]);
		printf("MFIM = [%s]%0lx\n", gvStack[mc].mpb,hmpb);

		char *hexdid = StrToHexStr( gvStack[mc].desired_id);
		char *hexdno = StrToHexStr( gvStack[mc].desired_number);
		char *hexpass = StrToHexStr( gvStack[mc].pass);
		memset(gvStack[mc].tot_ch,0,sizeof gvStack[mc].tot_ch);
		sprintf(gvStack[mc].tot_ch,"%s","255");
		char *hexch = StrToHexStr(gvStack[mc].tot_ch);
	  
		int idlen, nolen, passlen, chlen;
		idlen = strlen( gvStack[mc].desired_id);
		nolen = strlen( gvStack[mc].desired_number);
		passlen = strlen( gvStack[mc].pass);
		chlen = strlen(gvStack[mc].tot_ch);
		
		printf("desired_id [SYSTEM %d] : %s\n", mc, hexdid);
		
		printf("desired_number [SYSTEM %d] : %s\n",mc, hexdno);
		
		printf("Password [SYSTEM %d] : %s\n", mc, hexpass);
		
		printf("Channel [SYSTEM %d] : %s\n", mc, hexch);
		
		printf("MAC Addr [SYSTEM %d] : %s\n", mc, sMacAddr);
		
		// create
		memset(statEvt,0,sizeof statEvt);

		iPECS_CreateConnectionEx(CallbackFuncCR, hmpb, APP_ID_RECORDING, dectohex(mc+1));
		MakeLogDB(1111,"","MFIM AIM CREATE");
		
		printf("MFIM %d Initializing ....\n", mc);

		sleep(2);
		// login
		memset(sendbuf,0,sizeof sendbuf);	
		sprintf(sendbuf, "0105000000000e010006%s0e020004%s0d36000%d%s0d06000%d%s0d37000%d%s0e06000%d%s0d320004",sMacAddr,myip,idlen,hexdid,nolen,hexdno,passlen,hexpass,chlen,hexch);
		
		memset(login,0,sizeof login);

		for (j=0,m=0;j<strlen(sendbuf);j+=2,m++)
		{
				login[m] = hexToAscii(sendbuf[j],sendbuf[j+1]);
				n=m;
		}

		login[++n] = 'A';
		login[++n] = '0';
		login[++n] = 'A';
		login[++n] = 'd';
		
		idx = (strlen(sendbuf)/2)+4;
		//iPECS_SndDataToSystemEx(login, idx, dectohex(gvStack[mc].SYSTEM_ID));
		MakeLogDB(1120,"",sendbuf);

	}
	
	memset(query,0,sizeof query);
	sprintf(query,"update rs_etc_config set r_config_value='A0Ad' where r_group_key='IPCR' and r_config_key='VERSION'");
	PQexec(conn, query);
/*
	memset(tempip,0,sizeof tempip);
	sprintf(tempip,"%s",mpb);
	memset(SPLIT2,0,sizeof SPLIT2);
	CHECK2 = strtok( tempip, "." );

	for (j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
	{
		if(CHECK2!=NULL){
			sprintf(SPLIT2[j],(char*)CHECK2);
		}else{
			break;
		}
	}
	hmpb = (atoi(SPLIT2[0]) << 24) + (atoi(SPLIT2[1]) << 16) + (atoi(SPLIT2[2]) << 8) + atoi(SPLIT2[3]);
	printf("hmpb = [%s]%0lx\n", mpb,hmpb);

	//hmpb = 0xc0a8966d;
	memset(tempip,0,sizeof tempip);
	sprintf(tempip,"%s",SYSTEM_IP);
	memset(SPLIT2,0,sizeof SPLIT2);
	CHECK2 = strtok( tempip, "." );

	for (j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
	{
		if(CHECK2!=NULL){
			sprintf(SPLIT2[j],(char*)CHECK2);
		}else{
			break;
		}
	}

	sprintf(myip, "%x%x%x%x", atoi(SPLIT2[0]),atoi(SPLIT2[1]),atoi(SPLIT2[2]),atoi(SPLIT2[3]));

	printf("my ip address = [%s]%s\n", SYSTEM_IP, myip);

	char *hexdid = StrToHexStr(desired_id);
	char *hexdno = StrToHexStr(desired_number);
	char *hexpass = StrToHexStr(pass);
	memset(tot_ch,0,sizeof tot_ch);
	sprintf(tot_ch,"%s","255");
	char *hexch = StrToHexStr(tot_ch);
  
	int idlen, nolen, passlen, chlen;
	idlen = strlen(desired_id);
	nolen = strlen(desired_number);
	passlen = strlen(pass);
	chlen = strlen(tot_ch);
	
	printf("desired_id : %s\n", hexdid);
	
	printf("desired_number : %s\n",hexdno);
	
	printf("Password : %s\n", hexpass);
	
	printf("Channel : %s\n", hexch);
	
	printf("MAC Addr : %s\n", sMacAddr);
	
	// create
	memset(statEvt,0,sizeof statEvt);

	iPECS_CreateConnection(CallbackFuncCR, hmpb, APP_ID_RECORDING);
	MakeLogDB(1111,"","MFIM AIM CREATE");
	
	printf("MPB Initializing ....\n");

	sleep(2);
	// login
	memset(sendbuf,0,sizeof sendbuf);	
	
	memset(query,0,sizeof query);
	sprintf(query,"update rs_etc_config set r_config_value='A0Ad' where r_group_key='IPCR' and r_config_key='VERSION'");
	PQexec(conn, query);
	
	sprintf(sendbuf, "0105000000000e010006%s0e020004%s0d36000%d%s0d06000%d%s0d37000%d%s0e06000%d%s0d320004",sMacAddr,myip,idlen,hexdid,nolen,hexdno,passlen,hexpass,chlen,hexch);
	
	memset(login,0,sizeof login);

	for (j=0,m=0;j<strlen(sendbuf);j+=2,m++)
	{
			login[m] = hexToAscii(sendbuf[j],sendbuf[j+1]);
			n=m;
	}

	login[++n] = 'A';
	login[++n] = '0';
	login[++n] = 'A';
	login[++n] = 'c';
	

	idx = (strlen(sendbuf)/2)+4;
	iPECS_SndDataToSystem(login, idx);
	MakeLogDB(1120,"",sendbuf);
*/
	STATUS_PING_TIME = GetTick()/1000;

	if (pthread_create(&dummythread,NULL,DummyProcessThread,NULL))
	{
		printf("Error Creating DUMMY PROCESS Thread!...\n");
		abort();
	}

	if (pthread_create(&sipthread,NULL,SipProcessThread,NULL))
	{
		printf("Error Creating SIP PROCESS Thread!...\n");
		abort();
	}

	if (pthread_create(&pingthread,NULL,PingSendThread,NULL))
	{
		printf("Error Creating LIK PING Thread!...\n");
		abort();
	}

	if (pthread_create(&alivethread,NULL,AliveCheckThread,NULL))
	{
		printf("Error Creating Alive Check Thread!...\n");
		abort();
	}


	if (pthread_create(&regthread,NULL,RegistarThread,NULL))
	{
		printf("Error Creating Registar Thread!...\n");
		abort;
	}

	for (int mf=0; mf<MF_COUNT; mf++)
	{
		sprintf(gvStack[mf].g_pRegistrar, "sip:%s", gvStack[mf].mpb);
		sprintf(gvStack[mf].g_pRegFrom, "From:<sip:%s@%s>", gvStack[mf].desired_id, gvStack[mf].mpb);
		sprintf(gvStack[mf].g_pRegTo, "To:<sip:%s@%s>", gvStack[mf].desired_id, gvStack[mf].mpb);
		sprintf(gvStack[mf].g_pContact1, "Contact:<sip:%s@%s:40696>", gvStack[mf].desired_id, SYSTEM_IP);

	
		AppStackInitialize(mf);
	
		g_appPool = RPOOL_Construct(4096,30,NULL,RV_TRUE,"IPCR");

		AppSetCallBackFunctions(mf);
	
		AppSimpleRegister(mf);
	}
	/*
	sprintf(g_pRegistrar, "sip:%s", mpb);
	sprintf(g_pRegFrom, "From:<sip:%s@%s>", desired_id, mpb);
	sprintf(g_pRegTo, "To:<sip:%s@%s>", desired_id, mpb);
	sprintf(g_pContact1, "Contact:<sip:%s@%s:40696>", desired_id, SYSTEM_IP);

	
	AppStackInitialize();
	
	AppSetCallBackFunctions();
	
	AppSimpleRegister();
	*/
	RvSipStackProcessEvents();


	pcap_close(descr);
	printf("\nCapture complete.\n");

	// pres stop
	/*
	memset(sendbuf,0,sizeof sendbuf);	
	sendbuf = {0X03, 0X0c, 0X00, 0X00, 0X00, 0X00};
	idx = 6;
	
	iPECS_SndDataToSystem(sendbuf, idx);
	MakeLogDB(1135,"","PRESENCE STOP REQUEST");

	stTime.tv_sec=0;
	stTime.tv_nsec=20*1000*1000;	// 20 m
	nanosleep(&stTime,NULL);
	
	memset(sendbuf,0,sizeof sendbuf);	

	sendbuf = {0X01, 0X06, 0X00, 0X00, 0X00, 0X00};
	
	idx = 6;
	
	iPECS_SndDataToSystem(sendbuf, idx);

	stTime.tv_sec=0;
	stTime.tv_nsec=20*1000*1000;	// 20 m
	nanosleep(&stTime,NULL);

	iPECS_DestroyConnection();
	MakeLogDB(1170,"","MFIM DESTROY");
	*/
	if (pthread_join(sqlthread, NULL))
	{
		printf("Error Join SQL Thread!...\n");
		abort();
	}
	
	if (pthread_join(logsqlthread, NULL))
	{
		printf("Error Join LOG SQL Thread!...\n");
		abort();
	}
	
	if (pthread_join(sockthread, NULL))
	{
		printf("Error Join RT Socket Thread!...\n");
		abort();
	}

	if (pthread_join(monthread, NULL))
	{
		printf("Error Join Monitoring Thread!...\n");
		abort();
	}

	if (pthread_join(recordingthread, NULL))
	{
		printf("Error Join recording Thread!...\n");
		abort();
	}

   if (pthread_join(agthread, NULL))
	{
		printf("Error Join Agent Thread!...\n");
		abort();
	}

	
	if (pthread_join(resourcethread, NULL))
	{
		printf("Error Join Resource Thread!...\n");
		abort();
	}
	if (pthread_join(alivethread, NULL))
	{
		printf("Error Join Alive Check Thread!...\n");
		abort();
	}
	if (pthread_join(pingthread, NULL))
	{
		printf("Error Join PING Thread!...\n");
		abort();
	}
	if (pthread_join(presthread, NULL))
	{
		printf("Error Join PING Thread!...\n");
		abort();
	}
	if (pthread_join(sipthread, NULL))
	{
		printf("Error Join SIP Thread!...\n");
		abort();
	}
	if (pthread_join(dummythread, NULL))
	{
		printf("Error Join DUMMY Thread!...\n");
		abort();
	}

	exit_program(0);

	return 0;

//#else /* RV_SIP_PRIMITIVES */
//	OSPrintf("This Sample requires that flag RV_SIP_PRIMITIVES NOT be defined.\nAborting.\n");
//	return 1;
//#endif /* RV_SIP_PRIMITIVES */

}


///////////////////////////////////////////////////////////////////////////
//////////////////// IMPLEMENTATION ///////////////////////////////////////
///////////////////////////////////////////////////////////////////////////

/***************************************************************************
 * AppStackInitialize
 * ------------------------------------------------------------------------
 * General: Initializing the stack and allocating the application memory pool.
 *          When initializing we first set the configuration struct to the
 *          default values and then change some of the configuration parameters.
 *          We then use RvSipStackConstruct to initialize the stack.
 ***************************************************************************/
static void AppStackInitialize(int m_index)
{
    RvStatus rv;
    RvSipStackCfg stackCfg;
    RvSdpStackCfg sdpCfg;

    RvSipMidInit();

    RvSipStackInitCfg(sizeof(stackCfg),&stackCfg);

    stackCfg.maxCallLegs = TOTAL_LINE;
    stackCfg.maxTransactions = TOTAL_LINE*2;
    stackCfg.tcpEnabled = RV_TRUE;
    stackCfg.localUdpPort = 5060;//gvStack[m_index].g_port;
    stackCfg.localTcpPort = 5060;//gvStack[m_index].g_port;

    /* Disable most of log for embedded systems */
#if (RV_OS_TYPE == RV_OS_TYPE_NUCLEUS)  ||(RV_OS_TYPE == RV_OS_TYPE_VXWORKS)||\
    (RV_OS_TYPE == RV_OS_TYPE_PSOS)     ||(RV_OS_TYPE == RV_OS_TYPE_SYMBIAN)||\
    (RV_OS_TYPE == RV_OS_TYPE_INTEGRITY)
    stackCfg.defaultLogFilters = RVSIP_LOG_ERROR_FILTER|RVSIP_LOG_EXCEP_FILTER;
#endif

    
    rv = RvSipStackConstruct(sizeof(stackCfg),&stackCfg,&gvStack[m_index].g_hStackMgr);
    if(rv != RV_OK)
    {
        AppExitOnError("Application failed to construct the stack\n");
    }

    
    RvSipStackGetRegClientMgrHandle(gvStack[m_index].g_hStackMgr,&gvStack[m_index].g_hRegClientMgr);

    
    RvSipStackGetCallLegMgrHandle(gvStack[m_index].g_hStackMgr,&gvStack[m_index].g_hCallLegMgr);
    RvSipStackGetLogHandle(gvStack[m_index].g_hStackMgr,&gvStack[m_index].g_hLog);

    memset(&sdpCfg,0, sizeof(sdpCfg));
    sdpCfg.logManagerPtr = (void*)gvStack[m_index].g_hLog;

    rvSdpConstruct(&sdpCfg);

    OSPrintf("The RADVISION SIP stack was constructed successfully. Version - %s\n",
                RvSipStackGetVersion());

    //gvStack[m_index].g_appPool = RPOOL_Construct(2048,30,gvStack[m_index].g_hLog,RV_FALSE,"IPCR");

    RvSipMidEnd();
}

/***************************************************************************
 * AppSetCallBackFunctions
 * ------------------------------------------------------------------------
 * General: Set application call back functions in the call-leg manager.
 ***************************************************************************/
static void AppSetCallBackFunctions(int m_index)
{
    RvStatus rv;
    RvSipCallLegEvHandlers appEvHandlers;
    RvSipRegClientEvHandlers appRegEvHandlers;

    memset(&appRegEvHandlers,0,sizeof(RvSipRegClientEvHandlers));

    /*Set application callbacks in the structure*/
    appRegEvHandlers.pfnStateChangedEvHandler   = AppRegClientStateChangedEvHandler;
    appRegEvHandlers.pfnMsgReceivedEvHandler    = AppRegClientMsgReceivedEvHandler;
    appRegEvHandlers.pfnMsgToSendEvHandler      = AppRegClientMsgToSendEvHandler;
   
    /*Set the structure in the register-client manager*/
    rv = RvSipRegClientMgrSetEvHandlers(gvStack[m_index].g_hRegClientMgr,
                                        &appRegEvHandlers,
                                        sizeof(RvSipRegClientEvHandlers));
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to set Registar application callbacks");
    }


    /*Reset the appEvHandlers since not all callbacks are set by this sample*/
    memset(&appEvHandlers,0,sizeof(RvSipCallLegEvHandlers));

    /*Set application callbacks in the structure*/
    appEvHandlers.pfnCallLegCreatedEvHandler = AppCallLegCreatedEvHandler;
    appEvHandlers.pfnStateChangedEvHandler   = AppCallLegStateChangedEvHandler;
    appEvHandlers.pfnReInviteCreatedEvHandler = AppReInviteCreatedEvHandler;
    appEvHandlers.pfnReInviteStateChangedEvHandler = AppReInviteStateChangedEvHandler;    

    appEvHandlers.pfnMsgReceivedEvHandler    = AppCallLegMsgReceivedEvHandler;
    appEvHandlers.pfnMsgToSendEvHandler      = AppCallLegMsgToSendEvHandler;

    /*Set the structure in the call-leg manager*/
    rv = RvSipCallLegMgrSetEvHandlers(gvStack[m_index].g_hCallLegMgr,
                                      &appEvHandlers,
                                      sizeof(RvSipCallLegEvHandlers));
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to set application callbacks");
    }
    
}


/***************************************************************************
 * AppSimpleRegister
 * ------------------------------------------------------------------------
 * General: This functions shows the most simple way to register to a
 *          registrar using the RvSipRegClientMake function.
 *          The RvSipRegClientMake function receives all the registration
 *          information as strings,set the strings to reg-client and register
 *          with the given information.
 *          The application should follow the below steps:
 *          1. create a new register-client object using
 *             RvSipRegClientMgrCreateRegClient().
 *          2. Call the RvSipRegClientMake() function with all needed information
 ***************************************************************************/
static void AppSimpleRegister(int m_index)
{
    //RvSipRegClientHandle     hRegClient;/*handle to the register-client*/
    RvStatus                rv;
	RvBool					b_persist;
    /*--------------------------
      1. creating a new register-client
    ----------------------------*/
    rv = RvSipRegClientMgrCreateRegClient(gvStack[m_index].g_hRegClientMgr,NULL,&gvStack[m_index].hRegClient);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to create new register-client");
    }
    OSPrintf("\nRegister-client %p was created\n\n",gvStack[m_index].hRegClient);


	RvSipRegClientGetPersistency(gvStack[m_index].hRegClient,&b_persist);
	if (b_persist==RV_TRUE)
	{
		printf("PERSISTENCY OK\n");
	}
	else
	{
		printf("PERSISTENCY NO\n");
	}
    /*-----------------------------
       2. register to the registrar
     -----------------------------*/
    rv = RvSipRegClientMake(gvStack[m_index].hRegClient,gvStack[m_index].g_pRegFrom,gvStack[m_index].g_pRegTo,gvStack[m_index].g_pRegistrar,gvStack[m_index].g_pContact1);
    if(rv != RV_OK)
    {
        AppExitOnError("Register request failed for register-client");
    }

}

static RvStatus AppBuildSdpMessageNegitiation(int chdev, IN RvSdpMsg* pSdpMsg, IN RvBool bIsSdpOffer)
{
    RvSdpStatus         rvsdp       = RV_SDPSTATUS_OK;
    RvSdpMediaDescr*    pMediaDesc  = NULL;
    RvSdpSessionTime*   pSTime      = NULL;
    RvSdpRtpMap*        pRtpMap     = NULL;
	RvUint16 g_SdpMdPort;

    /* Building the SDP message */
    /* ------------------------ */

    /* Setting origin to the sdp message */
    if (RV_TRUE == bIsSdpOffer)
    {
        rvsdp = rvSdpMsgSetOrigin(pSdpMsg,
                                  SDP_ORIGIN_USER_OFFER,
                                  SDP_ORIGIN_SID_OFFER,
                                  SDP_ORIGIN_VERSION_OFFER,
                                  RV_SDPNETTYPE_IN,
                                  RV_SDPADDRTYPE_IP4,
                                  SDP_ORIGIN_ADDRESS);
    }
    else
    {
        rvsdp = rvSdpMsgSetOrigin(pSdpMsg,
                                  SDP_ORIGIN_USER_ANSWER,
                                  SDP_ORIGIN_SID_ANSWER,
                                  SDP_ORIGIN_VERSION_ANSWER,
                                  RV_SDPNETTYPE_IN,
                                  RV_SDPADDRTYPE_IP4,
                                  SDP_ORIGIN_ADDRESS);
    }
    if (RV_SDPSTATUS_OK != rvsdp)
    {
        AppExitOnError("Failed to set origin to SDP message");
    }

    /* Setting session name to the sdp message */
    rvsdp = rvSdpMsgSetSessionName(pSdpMsg,SDP_SESSION_NAME);
    if (RV_SDPSTATUS_OK != rvsdp)
    {
        AppExitOnError("Failed to set session name to SDP message");
    }

    /* Setting connection to the sdp message */
    rvsdp = rvSdpMsgSetConnection(pSdpMsg,RV_SDPNETTYPE_IN,RV_SDPADDRTYPE_IP4,SYSTEM_IP);
    if (RV_SDPSTATUS_OK != rvsdp)
    {
        AppExitOnError("Failed to set connection to SDP message");
    }

	/*
	g_SdpMdPort+=2;
    if (g_SdpMdPort>7000)
	{
		g_SdpMdPort=6070;
	}
*/
	g_SdpMdPort = 6070+(chdev*2);

    /* Adding 1 media descriptor to the sdp message */
    pMediaDesc = rvSdpMsgAddMediaDescr(pSdpMsg,RV_SDPMEDIATYPE_AUDIO,g_SdpMdPort,RV_SDPPROTOCOL_RTP);
    if (NULL == pMediaDesc)
    {
        AppExitOnError("Failed to set construct media descriptor");
    }

    /* Building the media descriptor inside the SDP message */
    /* ---------------------------------------------------- */
    pSTime = rvSdpMsgAddSessionTime(pSdpMsg,0,0);
    if (NULL == pSTime)
    {
        AppExitOnError("Failed to set session time to media descriptor");
    }
    if (RV_TRUE == bIsSdpOffer)
    {
        pRtpMap = rvSdpMediaDescrAddRtpMap(pMediaDesc,0,SDP_RTPMAP_ENC,8000);
        if (NULL == pRtpMap)
        {
            AppExitOnError("Failed to set rtp map to media descriptor");
        }
    }
    /* Adding 1 format to the media descriptor */
    rvSdpMediaDescrAddFormat(pMediaDesc,SDP_MD_FORMAT);
    if (RV_SDPSTATUS_OK != rvsdp)
    {
        AppExitOnError("Failed to set format to connection");
    }

    return RV_OK;
}

/***************************************************************************
 * AppViewSDPMessage
 * ------------------------------------------------------------------------
 * General: Get the SDP body from the call.
 *          Getting some of the parameters from the incoming SDP body
 *          and printing them to the screen. Enumerations are printed as
 *          numbers.
 *          In this sample code the fields are knows, we can print them with
 *          out checking. It is important to consider the possibility that
 *          some of the fields might be absent from the message, and each
 *          field should be check before it is printed.
 * Return Value: RV_OK
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   pSdpMsg -    Pointer to  SDP message
  *          bIsSdpOffer - True if the SDP is "Offer SDP", false if SDP is "Answer SDP"
 ***************************************************************************/
static RvStatus AppViewSDPMessage(IN RvSdpMsg* pSdpMsg, IN RvBool bIsSdpOffer)
{
    RvSdpOrigin*        pOrigin             = rvSdpMsgGetOrigin(pSdpMsg);
    RvSdpConnection*    pConnection         = rvSdpMsgGetConnection(pSdpMsg);
    RvSdpMediaDescr*    pMediaDesc          = NULL;
	RvSdpCryptoAttr*    pCrypto          	= NULL;

    RvInt              numofMediaDescr     	= 0;
    RvInt              numofFormats        	= 0;
    RvInt              numofSessionTime    	= 0;
	RvInt              numofCrypto     	   	= 0;
	RvInt              numofKey        		= 0;
	RvInt              numofSession        	= 0;

    RvInt              i,j;

//return RV_OK;

    if (RV_TRUE == bIsSdpOffer)
    {
        OSPrintf("---------------------------------\nSome fields from offer SDP message:\n---------------------------------\n");
    }
    else
    {
        OSPrintf("---------------------------------\nSome fields from answer SDP message:\n---------------------------------\n");
    }

    
    OSPrintf("version field     : %s\n",rvSdpMsgGetVersion(pSdpMsg));
    OSPrintf("session           : %s\n",rvSdpMsgGetSessionName(pSdpMsg));

    
    OSPrintf("origin  field:\n");
    OSPrintf(" username         : %s\n", rvSdpOriginGetUsername(pOrigin));
    OSPrintf(" session id       : %s\n", rvSdpOriginGetSessionId(pOrigin));
    OSPrintf(" version          : %s\n", rvSdpOriginGetVersion(pOrigin));
    OSPrintf(" address          : %s\n", rvSdpOriginGetAddress(pOrigin));

   
    OSPrintf("connection field:\n");
    OSPrintf(" nettype enum     : %d\n", rvSdpConnectionGetNetType(pConnection));
    OSPrintf(" addr type enum   : %d\n", rvSdpConnectionGetAddrType(pConnection));
    OSPrintf(" address          : %s\n", rvSdpConnectionGetAddress(pConnection));

    numofSessionTime = rvSdpMsgGetNumOfSessionTime(pSdpMsg);
    for (i=0;i<numofSessionTime;i++)
    {
        RvSdpSessionTime*  pSessionTime = NULL;
        OSPrintf("Session Time %d:\n", i);
        pSessionTime = rvSdpMsgGetSessionTime(pSdpMsg,i);
        OSPrintf(" start            : %d\n", rvSdpSessionTimeGetStart(pSessionTime));
        OSPrintf(" end              : %d\n", rvSdpSessionTimeGetEnd(pSessionTime));
    }

    numofMediaDescr = rvSdpMsgGetNumOfMediaDescr(pSdpMsg);
    for (i=0;i<numofMediaDescr;i++)
    {
        OSPrintf("Media Descr %d:\n", i);

       
        pMediaDesc = rvSdpMsgGetMediaDescr(pSdpMsg,i);

     
        OSPrintf(" media type enum  : %d\n", rvSdpMediaDescrGetMediaType(pMediaDesc));
       
        OSPrintf(" protocol enum    : %d\n", rvSdpMediaDescrGetProtocol(pMediaDesc));

        numofFormats = rvSdpMediaDescrGetNumOfFormats(pMediaDesc);
        for (j=0;j<numofFormats;j++)
        {
            OSPrintf(" format %d         : %s\n",j,rvSdpMediaDescrGetFormat(pMediaDesc,j));
        }

    }

	numofCrypto = rvSdpMsgGetNumOfCrypto(pSdpMsg);

    for (i=0;i<numofCrypto;i++)
    {
        OSPrintf("Crypto count %d:\n", i);

        pCrypto = rvSdpMsgGetCrypto(pSdpMsg,i);

        OSPrintf(" Crypto Tag  		: %d\n", rvSdpCryptoGetTag(pCrypto));
        OSPrintf(" Crypto suite     : %s\n", rvSdpCryptoGetSuite(pCrypto));
        //OSPrintf(" protocol enum    : %d\n", rvSdpCryptoGetProtocol(pCrypto));

        numofKey = rvSdpCryptoGetNumOfKeyParams(pCrypto);
        for (j=0;j<numofKey;j++)
        {
            OSPrintf(" method %d         : %s\n",j,rvSdpCryptoGetKeyMethod(pCrypto,j));
			OSPrintf(" info   %d         : %s\n",j,rvSdpCryptoGetKeyInfo(pCrypto,j));
        }

		numofSession = rvSdpCryptoGetNumOfSessionParams(pCrypto);
        for (j=0;j<numofSession;j++)
        {
            OSPrintf(" session %d         : %s\n",j,rvSdpCryptoGetSessionParam(pCrypto,j));
        }
    }

    return RV_OK;
}

/***************************************************************************
 * AppRetrieveSDPBodyFromCall
 * ------------------------------------------------------------------------
 * General: Get the SDP body from the call
 * Return Value: RV_OK
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hCallLeg -    The sip stack call-leg handle
 *          bIsSdpOffer - True if the SDP is "Offer SDP", false if SDP is "Answer SDP"
 ***************************************************************************/
static RvStatus AppRetrieveSDPBodyFromCall(IN RvSipCallLegHandle hCallLeg, IN RvBool bIsSdpOffer)
{
    RvStatus                       rv                  = RV_OK;
    RvSipMsgHandle                  hMsg                = NULL;
    RvSipBodyHandle                 hBody               = NULL;
    RvChar                         szBody[SDP_BODY_SIZE] = {'\0'};
    RvUint32                       len                 = SDP_BODY_SIZE;
    RvSdpMsg                        sdpMsg;
    RvSdpParseStatus                eParseStatus        = RV_SDPPARSER_STOP_ZERO;
    RvAlloc                         sdpAllocator;

	printf("START AppRetrieveSDPBodyFromCall\n");
    /* Building an allocator that will be used for space allocations in the SDP message */
    rv = RvSdpAllocConstruct(g_appPool,&sdpAllocator);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to build allocator");
    }

    /* Retrieving the message from the call leg */
    rv = RvSipCallLegGetReceivedMsg(hCallLeg,&hMsg);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to get received message from the call");
    }

    /* Obtaining the body from the message. The body contains the SDP message */
    hBody = RvSipMsgGetBodyObject(hMsg);
    if(hBody == NULL)
    {
        AppExitOnError("Failed to get received body from message");
    }

    /* Getting the body of the message as string */
    rv = RvSipBodyGetBodyStr(hBody,szBody,len,&len);

    /* Parding the string into an SDP message */
    rvSdpMsgConstructParseA(&sdpMsg,szBody,(RvInt32*)&len,&eParseStatus,&sdpAllocator);
    if (RV_SDPSTATUS_OK != eParseStatus)
    {
        AppExitOnError("failed to parse body");
    }

    /* Handleing the received message */
    AppViewSDPMessage(&sdpMsg, bIsSdpOffer);

    /* We no longer need the allocator, so we can free resources*/
    RvSdpAllocDestruct(&sdpAllocator);
    return rv;
}


/***************************************************************************
 * AppAddSdpBodyToCall
 * ------------------------------------------------------------------------
 * General: Adds an SDP body to the call
 * Return Value: RV_OK
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hCallLeg -    The sip stack call-leg handle
 *          bIsSdpOffer - True if the SDP is "Offer SDP", false if SDP is "Answer SDP"
 ***************************************************************************/
static RvStatus AppAddSdpBodyToCall(int chdev, IN RvSipCallLegHandle hCallLeg,IN RvBool bIsSdpOffer)
{
    RvStatus                       rv                  = RV_OK;
    RvSipMsgHandle                  hMsg                = NULL;
    RvSdpMsg                        sdpMsg;
    RvSdpMsg*                       pSdpMsg             = NULL;
    RvChar                         szBody[SDP_BODY_SIZE] = {'\0'};
    RvAlloc                         sdpAllocator;
    RvSdpStatus                     rvsdp               = RV_SDPSTATUS_OK;
    RvSipBodyHandle                 hBody               = NULL;
    RvSipContentTypeHeaderHandle    hContentType        = NULL;
    RvSdpMediaDescr*    pMediaDesc          = NULL;
    int	       portno;		
    
    /* Obtaining the message that will be sent by the call */
    rv = RvSipCallLegGetOutboundMsg(hCallLeg,&hMsg);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to get outbound message from the call");
    }

    /* Building an allocator that will be used for space allocations in the SDP message */
    rv = RvSdpAllocConstruct(g_appPool,&sdpAllocator);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to build allocator");
    }

    /* Constructing a new SDP message */
    pSdpMsg = rvSdpMsgConstructA(&sdpMsg,&sdpAllocator);
    if (NULL == pSdpMsg)
    {
        AppExitOnError("Failed to construct SDP message");
    }

    /* Setting parameters to the SDP message */
    AppBuildSdpMessageNegitiation(chdev,&sdpMsg,bIsSdpOffer);

    /* Printing the message to the screen, we need to encode it */
    rvSdpMsgEncodeToBuf(&sdpMsg,szBody,SDP_BODY_SIZE,&rvsdp);
    //OSPrintf("---------------------------------\nSending SDP message:\n---------------------------------\n%s",szBody);

   
    /* We no longer need the allocator, so we can free resources*/
    RvSdpAllocDestruct(&sdpAllocator);
    if (RV_SDPSTATUS_OK != rvsdp)
    {
        AppExitOnError("Failed to set parse SDP message");
        return RV_ERROR_UNKNOWN;
    }

    /* Constructing a new body object to hold the SDP message */
    rv = RvSipBodyConstructInMsg(hMsg,&hBody);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to construct body in message");
    }

    /* Setting the body's string to be the SDP message */
    rv = RvSipBodySetBodyStr(hBody,szBody,(RvUint32)strlen(szBody));
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to set body string");
    }

    /* Constructing a content-type header that will indicate the type of
       the body, Application/sdp in our case */
    rv = RvSipContentTypeHeaderConstructInBody(hBody,&hContentType);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to construct content type header in body");
    }

    /* Setting the type and sub-type for the content-type header */
    rv = RvSipContentTypeHeaderSetMediaType(hContentType,RVSIP_MEDIATYPE_APPLICATION,NULL);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to set media type in body");
    }
    rv = RvSipContentTypeHeaderSetMediaSubType(hContentType,RVSIP_MEDIASUBTYPE_SDP,NULL);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to set body to the message");
    }

    /* Setting the newly built content-type header to the body */
    rv = RvSipBodySetContentType(hBody,hContentType);
    if(rv != RV_OK)
    {
        AppExitOnError("Failed to set body to the message");
    }

    RvSdpOrigin*        pOrigin             = rvSdpMsgGetOrigin(pSdpMsg);
    
    pMediaDesc = rvSdpMsgGetMediaDescr(pSdpMsg,0);
    portno = rvSdpMediaDescrGetPort(pMediaDesc);
printf("portno_pre  ---- %d [%s]\n",portno,RecSeeCH[chdev].EXT_NUM);	
    if(chdev>0)
    {
		if (RecSeeCH[chdev].NOWSTATUS==1)
		{
			RecSeeCH[chdev].PortNo=portno;
			printf("portno  ---- %d [%s]\n",portno,RecSeeCH[chdev].EXT_NUM);
			RecSeeCH[chdev].NOWSTATUS=0;
		}
    }
   
    return rv;
}


/*---- E V E N T    H A N D L E R S   I M P L M E N T A T I O N ----------*/

/***************************************************************************
 * RvSipRegClientStateChangedEv
 * ------------------------------------------------------------------------
 * General: Notifies the application of a register-client state change.
 *          Prints the new state.
 *          If the new state is Failed terminate the register-client using the
 *          RvSipRegClientTerminate() function.
 * Return Value: (-)
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hRegClient -    The sip stack register-client handle
 *          hAppRegClient - The application handle for this register-client.
 *          eState -        The new register-client state
 *          eReason -       The reason for the state change.
 ***************************************************************************/
static void RVCALLCONV AppRegClientStateChangedEvHandler(
                                   IN  RvSipRegClientHandle            hRegClient,
                                   IN  RvSipAppRegClientHandle         hAppRegClient,
                                   IN  RvSipRegClientState             eState,
                                   IN  RvSipRegClientStateChangeReason eReason)
{
    RvStatus             rv;

    /*print the new state on screen*/
    OSPrintf("\nregister-client %p - State changed to %s\n\n",
             hRegClient,AppGetRegClientStateName(eState));

    switch(eState)
    {
    /*----------------------------------------------
      Terminate the register-client when it changes
      state to Failed
      ---------------------------------------------*/
    case RVSIP_REG_CLIENT_STATE_FAILED:
        OSPrintf("Terminate the register-client due to failure\n\n");
        rv = RvSipRegClientTerminate(hRegClient);
        if(rv != RV_OK)
        {
            AppExitOnError("Failed to terminate the register-client");
        }

        break;
    /*------------------------------------------------
      Notify that the registeration succeeded
      ------------------------------------------------*/
    case RVSIP_REG_CLIENT_STATE_REGISTERED:
        OSPrintf("The registration succeeded\n\n");

		//RvSipRegClientSetPersistency(hRegClient,RV_TRUE);

        break;
    /*------------------------------------------------
      Terminate the register-client whne it reaches
      states that are not supported by this application
      ------------------------------------------------*/
    case RVSIP_REG_CLIENT_STATE_UNAUTHENTICATED:
    case RVSIP_REG_CLIENT_STATE_REDIRECTED:
        rv = RvSipRegClientTerminate(hRegClient);
        if(rv != RV_OK)
        {
            AppExitOnError("Failed to terminate the register-client");
        }
    default:
        break;
    }
    RV_UNUSED_ARG(hAppRegClient);
    RV_UNUSED_ARG(eReason);
}

/***************************************************************************
 * AppRegClientMsgReceivedEvHandler
 * ------------------------------------------------------------------------
 * General: Application implementation to the message received event handler.
 *          Here we only print the message that was received.
 * Return Value: RV_OK
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hRegClient -  The sip stack register-client handle
 *          hRegClient -  The application handle for this register-client.
 *          hMsg -        Handle to the outgoing message.
 ***************************************************************************/
static RvStatus RVCALLCONV AppRegClientMsgReceivedEvHandler(
                                    IN  RvSipRegClientHandle          hRegClient,
                                    IN  RvSipAppRegClientHandle       hAppRegClient,
                                    IN  RvSipMsgHandle                hMsg)
{
    //OSPrintf("<-- Message Received (register-client %p)\n",hRegClient);
	RvChar *dummy="";
	RvChar *dummy2="";
	RvChar *dummy3="";
	RvChar *dummy4="";
	int		i;
    AppPrintMessage(hMsg,1,dummy,dummy2,i);
    RV_UNUSED_ARG(hAppRegClient);
    return RV_OK;
}

/***************************************************************************
 * RvSipRegClientMsgToSendEv
 * ------------------------------------------------------------------------
 * General: Application implementation to the message to send event handler.
 *          Here we only print the message that is about to be sent.
 * Return Value: RV_OK
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hRegClient -    The sip stack register-client handle
 *          hAppRegClient - The application handle for this register-client.
 *          hMsg -          Handle to the outgoing message.
 ***************************************************************************/
static RvStatus RVCALLCONV AppRegClientMsgToSendEvHandler(
                                    IN  RvSipRegClientHandle          hRegClient,
                                    IN  RvSipAppRegClientHandle       hAppRegClient,
                                    IN  RvSipMsgHandle                hMsg)
{
    //OSPrintf("--> Message Sent (register-client %p)\n",hRegClient);
	RvChar *dummy="";
	RvChar *dummy2="";
    RvChar *dummy3="";
	RvChar *dummy4="";
	int		i;
    AppPrintMessage(hMsg,1,dummy,dummy2,i);
    RV_UNUSED_ARG(hAppRegClient);
    return RV_OK;
}

/***************************************************************************
 * AppCallLegCreatedEvHandler
 * ------------------------------------------------------------------------
 * General:  Notifies that a new call-leg was created.
 *           This application does not exchange handles with the call-leg.
 * Return Value: (-)
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hCallLeg - The new sip stack call-leg handle
 * Output:  phAppCallLeg - The application handle for this call-leg.
 ***************************************************************************/

static void RVCALLCONV AppCallLegCreatedEvHandler(
                           IN  RvSipCallLegHandle            hCallLeg,
                           OUT RvSipAppCallLegHandle         *phAppCallLeg)
{
    OSPrintf("\nIncoming call-leg %p was created\n\n",hCallLeg);
    *phAppCallLeg = NULL;  /*the application handle is set to NULL*/
}


/***************************************************************************
 * RvSipCallLegStateChangedEv
 * ------------------------------------------------------------------------
 * General: Notifies the application of a call-leg state change.
 *          If the new state is Offering - accept the call with
 *          RvSipCallLegAccept().
 *          If and incoming call-leg reached the Connected state, disconnect
 *          the call with RvSipCallLegDisconnect().
 * Return Value: (-)
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hCallLeg -    The sip stack call-leg handle
 *          hAppCallLeg - The application handle for this call-leg.
 *          eState -      The new call-leg state
 *          eReason -     The reason for the state change.
 ***************************************************************************/
static void RVCALLCONV AppCallLegStateChangedEvHandler(
                                   IN  RvSipCallLegHandle            hCallLeg,
                                   IN  RvSipAppCallLegHandle         hAppCallLeg,
                                   IN  RvSipCallLegState             eState,
                                   IN  RvSipCallLegStateChangeReason eReason)
{
    RvStatus             rv,rv1,rv2;;
    RvSipCallLegDirection eDirection;
    RvSipPartyHeaderHandle  hFrom;    /*handle to the from header*/
    RvSipPartyHeaderHandle  hTo;      /*handle to the to header*/
    int chdev=0;
    RvUint length;
    RvChar *strbuffer;
    RvChar *pFrom; 
    RvChar *pTo;
    string sFrom;
    string sTo;
printf("\ncall-leg %p\n",hCallLeg);

	OSPrintf("\ncall-leg %p - State changed to %s\n\n",
             hCallLeg,AppGetCallLegStateName(eState));

    RvSipCallLegGetDirection(hCallLeg,&eDirection);

    /*print the new state on screen*/
	/*
	OSPrintf("\n%s call-leg %p - State changed to %s\n\n",
             AppGetDirectionName(eDirection),
             hCallLeg,AppGetCallLegStateName(eState));
	*/
    switch(eState)
    {
    /*----------------------------------------------
      Accept incoming calls in the offering state
      ---------------------------------------------*/
    case RVSIP_CALL_LEG_STATE_OFFERING:

	rv1 = RvSipCallLegGetNewMsgElementHandle(hCallLeg, RVSIP_HEADERTYPE_FROM,
                                          RVSIP_ADDRTYPE_UNDEFINED, (void**)&hFrom);
	rv2 = RvSipCallLegGetNewMsgElementHandle(hCallLeg, RVSIP_HEADERTYPE_TO,
                                          RVSIP_ADDRTYPE_UNDEFINED, (void**)&hTo);
        if(rv1 != RV_OK || rv2 != RV_OK)
        {
	    	AppExitOnError("Failed to get party header handled from call-leg");
        }
        /*------------------------------------------------------------
          Initialize the From and to party headers using parse.
        -------------------------------------------------------------*/
        rv1 = RvSipPartyHeaderParse(hFrom,RV_FALSE,pFrom);
        rv2 = RvSipPartyHeaderParse(hTo,RV_TRUE,pTo);

        AppRetrieveSDPBodyFromCall(hCallLeg, RV_TRUE);

        //AppAddSdpBodyToCall(hCallLeg,RV_FALSE);  -> move to rcvmeg

        rv = RvSipCallLegAccept(hCallLeg);
        if(rv != RV_OK)
        {
            AppExitOnError("Failed to accept the call");
        }
	
        break;
    /*------------------------------------------------
      Disconnect incoming calls in the connected state
      ------------------------------------------------*/
    case RVSIP_CALL_LEG_STATE_CONNECTED:
        
        break;
    case RVSIP_CALL_LEG_STATE_ACCEPTED:
       	//rv = RvSipCallLegAckAccept(hCallLeg);
        break;
    /*  default -> automatically send 200 ok
    case RVSIP_CALL_LEG_BYE_REQUEST_RCVD:
	OSPrintf("BYE Accepting the call\n\n");
        rv = RvSipCallLegByeAccept(hCallLeg);
        if(rv != RV_OK)
        {
            AppExitOnError("Failed to bye accept the call");
        }
    */
    case RVSIP_CALL_LEG_STATE_DISCONNECTED:
	//OSPrintf("Disconnecting the call\n\n");

	rv1 = RvSipCallLegGetNewMsgElementHandle(hCallLeg, RVSIP_HEADERTYPE_FROM,
                                          RVSIP_ADDRTYPE_UNDEFINED, (void**)&hFrom);
	rv2 = RvSipCallLegGetNewMsgElementHandle(hCallLeg, RVSIP_HEADERTYPE_TO,
                                          RVSIP_ADDRTYPE_UNDEFINED, (void**)&hTo);
        if(rv1 != RV_OK || rv2 != RV_OK)
        {
	    AppExitOnError("Failed to get party header handled from call-leg");
        }
     
	break;

    default:
        break;
    }
    RV_UNUSED_ARG(hAppCallLeg);
    RV_UNUSED_ARG(eReason);
}

void RVCALLCONV AppReInviteCreatedEvHandler(IN  RvSipCallLegHandle      hCallLeg,
            IN  RvSipAppCallLegHandle     hAppCall,
            IN  RvSipCallLegInviteHandle    hReInvite,
            OUT RvSipAppCallLegInviteHandle   *phAppReInvite,
            OUT RvUint16        *pResponseCode)
{

 //Sipm_SipCallInfo* callInfo = (Sipm_SipCallInfo*)hAppCall;
 printf("[SipEvCallModifyReqRcvd] Req Rcvd\n");
/*
 {
  callInfo->isReinvite = 1;
  callInfo->what_Request = IS_INVITE;
 }
*/
}

void RVCALLCONV AppReInviteStateChangedEvHandler(IN  RvSipCallLegHandle     hCallLeg,
           IN  RvSipAppCallLegHandle    hAppCall,
           IN  RvSipCallLegInviteHandle   hReInvite,
           IN  RvSipAppCallLegInviteHandle   hAppReInvite,
           IN  RvSipCallLegModifyState    eModifyState,
           IN  RvSipCallLegStateChangeReason eReason)
{
 //Sipm_SipCallInfo* callInfo = (Sipm_SipCallInfo*)hAppCall;
 RV_Status rv;

 printf("[AppReInviteStateChangedEvHandler(s:%d)]\n", eModifyState);

 switch (eModifyState)
 {
  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_REMOTE_ACCEPTED:
  {
   
   rv = RvSipCallLegReInviteAck(hCallLeg, hReInvite);
   if (rv != RV_OK)
   {
    printf("[AppReInviteStateChangedEvHandler] can't send a re-invite ack request with reason code (%d)\n", rv);
    return;
   }
  }
  break;

  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_SENT:
  case RVSIP_CALL_LEG_MODIFY_STATE_IDLE:
    break;
  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_RCVD:

  {
   //callInfo->isReinvite = 1;

    rv = RvSipCallLegAccept(hCallLeg);

   break;
  }  
  /* A:LIK MFIM self SIP Extension Process and external DSP, LIK SIP EXT, End */
   
  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_RESPONSE_SENT:
  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_RESPONSE_RCVD:
  {

  }
  break;

  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_CANCELLING:
  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_PROCEEDING:
  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_CANCELLED:
  case RVSIP_CALL_LEG_MODIFY_STATE_REINVITE_PROCEEDING_TIMEOUT:
  {
   
  }
  break;

  case RVSIP_CALL_LEG_MODIFY_STATE_MSG_SEND_FAILURE:
  {
   RvSipCallLegReInviteTerminate (hCallLeg, hReInvite);
  }
  break;

  case RVSIP_CALL_LEG_MODIFY_STATE_ACK_SENT:
  case RVSIP_CALL_LEG_MODIFY_STATE_ACK_RCVD:
  {
   
  }
  break;

  case RVSIP_CALL_LEG_MODIFY_STATE_TERMINATED:
  {
    //callInfo->isReinvite = 0;
  }
  break;
  default:
  {

  }
  break;
 }
}


/***************************************************************************
 * AppCallLegMsgReceivedEvHandler
 * ------------------------------------------------------------------------
 * General: Application implementation to the message received event handler.
 *          Here we only print the message that was received.
 * Return Value: RV_OK
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hCallLeg -    The sip stack call-leg handle
 *          hAppCallLeg - The application handle for this call-leg.
 *          hMsg -        Handle to the outgoing message.
 ***************************************************************************/
static RvStatus RVCALLCONV AppCallLegMsgReceivedEvHandler(
                                    IN  RvSipCallLegHandle            hCallLeg,
                                    IN  RvSipAppCallLegHandle         hAppCallLeg,
                                    IN  RvSipMsgHandle                hMsg)
{
   	RV_INT16	statusCode;
	RV_CHAR		strMethodBuf[Sipm_SIP_METHOD_LEN];
	RV_CHAR		strResponseReasonBuf[Sipm_SIP_RSPNS_REASON_LEN];
	RV_CHAR		strContentType[Sipm_SIP_CONTENT_TYPE_LEN];
	RV_UINT		actualLen;
	RV_CHAR		buf[50];
	RV_CHAR		digit[2];
	RV_UINT		len;
	RV_Status	rv = RV_OK;
	RvSipMsgType	msgTp 	 = RvSipMsgGetMsgType(hMsg);
	RvSipMethodType	methodTp = RVSIP_METHOD_UNDEFINED;
	RV_CHAR		*p_token = NULL;
	int chdev=0;
	string pAssId;
	char master[20];
	char salt[20];	
	char cSeqName[20];
	char RTPKey[100];
	char key[64];
	unsigned char remotekey[MASTER_KEY_LEN];
	srtp_policy_t policy;
	int pSecure;

    pAssId = AppPrintMessage(hMsg,2,RTPKey,cSeqName,pSecure);

	if (msgTp == RVSIP_MSG_REQUEST)
	{
		methodTp = RvSipMsgGetRequestMethod(hMsg);
		
		switch (methodTp)
		{
			case RVSIP_METHOD_INVITE :
			
				if (pAssId!="")
				{
					chdev = Sipm_SipConnProcInviteInd(&hMsg,1,(char*)pAssId.c_str(),master,salt);
				}
				else
				{
					chdev = Sipm_SipConnProcInviteInd(&hMsg,1,"",master,salt);
				}

				if (chdev>0)
				{
					//if ((cSeqName!=NULL)&&((strcmp(cSeqName,"1 INVITE")==0)||(strcmp(cSeqName,"2 INVITE")==0)) )
					if ((cSeqName!=NULL)&&(strcnt(cSeqName,"INVITE")>0))
					{
						//printf("seq=%s\n", cSeqName);
						RecSeeCH[chdev].NOWSTATUS=1;
					}

					if ((RTPKey == NULL) || (strcmp(RTPKey,"")==0))
					{
					}
					else
					{
						//printf("RTP KEY 1=%s\n", RTPKey);
						if ((cSeqName!=NULL)&&(strcmp(cSeqName,"1 INVITE")==0))
						{
							//printf("RTP KEY 2=%s\n", RTPKey);
						
							//int len = hex_string_to_octet_string(key, RTPKey, MASTER_KEY_LEN*2);
							int len = ast_base64decode(remotekey, RTPKey,sizeof(remotekey));
							if (len < MASTER_KEY_LEN) {
							  fprintf(stderr, 
								  "error: too few digits in key/salt "
								  "(should be %d hexadecimal digits, found %d)\n",
								  MASTER_KEY_LEN, len);
							  return RV_OK;    
							} 
							if (strlen(RTPKey) > MASTER_KEY_LEN) {
							  fprintf(stderr, 
								  "error: too many digits in key/salt "
								  "(should be %d hexadecimal digits, found %u)\n",
								  MASTER_KEY_LEN, (unsigned)strlen(RTPKey));
							  return RV_OK;       
							}
    
							printf("set master key/salt to %s/", octet_string_hex_string(remotekey, 16));
							printf("%s\n", octet_string_hex_string(remotekey+16, 14));
    
							/* check that hex string is the right length */
							/*
							if (len < MASTER_KEY_LEN*2) {
							  fprintf(stderr, 
								  "error: too few digits in key/salt "
								  "(should be %d hexadecimal digits, found %d)\n",
								  MASTER_KEY_LEN*2, len);
							  return RV_OK;    
							} 
							if (strlen(RTPKey) > MASTER_KEY_LEN*2) {
							  fprintf(stderr, 
								  "error: too many digits in key/salt "
								  "(should be %d hexadecimal digits, found %u)\n",
								  MASTER_KEY_LEN*2, (unsigned)strlen(RTPKey));
							  return RV_OK;       
							}
    
							printf("set master key/salt to %s/", octet_string_hex_string(key, 16));
							printf("%s\n", octet_string_hex_string(key+16, 14));
							*/

							RecSeeCH[chdev].SRTP_YN = pSecure;

							if (pSecure==1)  //AES
							{
								//policy.key  = (uint8_t *) key;
								policy.key  = (uint8_t *) remotekey;
								policy.next = NULL;
								policy.rtp.sec_serv = sec_serv_conf;
								policy.rtcp.sec_serv = sec_serv_none;  /* we don't do RTCP anyway */
							 
								//ch_srtp_ctx[chdev] = (rtp_rcv_t)malloc(sizeof(rtp_rcv_ctx_t));
								crypto_policy_set_aes_cm_128_hmac_sha1_80(&policy.rtp);
								//crypto_policy_set_aes_cm_128_null_auth(&policy.rtp);
								crypto_policy_set_rtcp_default(&policy.rtcp);

								srtp_create(&ch_srtp_ctx[chdev].srtp_ctx, &policy);
							}
							else if(pSecure==2)  //ARIA
							{
								//int keyBytes = 24;   //ARIA
								//unsigned char* mk = new unsigned char[keyBytes];
								//hex_to_bin(mk, edMasterKey->Text.c_str(), edMasterKey->Text.Length());
								Aria_initialize((unsigned char*)remotekey, ENC_ARIA_KEY_BITS, 0);
								//delete[] mk;
							}
						}
						/*
						RecSeeCH[chdev].sion = 0;
						//memset(RecSeeCH[chdev].sion,0,sizeof RecSeeCH[chdev].sion);

						if (evrb_crypto_init() != 0)
						evrb_cryptokey_set_gen(RecSeeCH[chdev].sion->local.crypto);
						
						if (crypt_key == 0)
						{
						}
						else
						{
							evrb_cryptokey_set(RTPKey,&RecSeeCH[chdev].sion->distant.crypto);
							//sion->distant.ip.s_addr = inet_addr (rtp_ip);
							//sion->distant.port = rtp_port;
							//finalize session
							i = evrb_crypto_keys_compute(RecSeeCH[chdev].sion->local.crypto, RecSeeCH[chdev].sion->distant.crypto, 1);
							if( i != 0)
							{
								return CANNOT_COMPUTE_KEY;
							}
							fprintf(stdout,"---KEY IS OK!!!\n");
						}
						*/
					}
					AppAddSdpBodyToCall(chdev, hCallLeg,RV_FALSE);
				}

				break;
			
			case RVSIP_METHOD_BYE :
			
				chdev = Sipm_SipConnProcInviteInd(&hMsg,2,"",master,salt);
			
				break;
			
		}
	}

    
    RV_UNUSED_ARG(hAppCallLeg);
    return RV_OK;
}


/*!-------------------------------------------------------------------------
  - Module Name  : Sipm_SipConnProcInviteInd
  - Description  :
  - State/event  :
  - Input        :
  - Output       :
  - Return Value : Result Status (1 or 0)
  - Author       :
 .
 -------------------------------------------------------------------------*/
int Sipm_SipConnProcInviteInd(RvSipMsgHandle* msg, int calltype, char* AssertId, char *MasterKey, char *SaltKey)
{
	RvSipPartyHeaderHandle		header;
	RvSipPartyHeaderHandle		Toheader;
	RvSipContactHeaderHandle	hContactHeader;
	RvSipAddressHandle			hContactAddress,  hRequestUri;
	RvSipHeaderListElemHandle	hListElem = NULL;
	RvSipRouteHopHeaderHandle	hRouteHop;
	RvSipViaHeaderHandle		hVia;
	RvSipAddressHandle			addr;
	RvSipCSeqHeaderHandle		hseq;

	RV_CHAR				strCallId[Sipm_SIP_CONTENT_TYPE_LEN];
	RV_UINT				actualLen;
	int chdev=0;

	RV_Status	rv;
	RV_CHAR		str[Sipm_SIP_MAX_DISPLAY_NAME];
	RV_CHAR		rcvsrcAddr[Sipm_SIP_MAX_E164_ID_LEN] = {0};
	RV_CHAR		srcAddrDisplay[Sipm_SIP_MAX_E164_ID_LEN];
	RV_CHAR		rcvdestAddr[Sipm_SIP_MAX_E164_ID_LEN];
	RV_CHAR		destAddrDisplay[Sipm_SIP_MAX_E164_ID_LEN];
	RV_CHAR		strUri[Sipm_SIP_MAX_HEADER_BUF] = {0};
	RV_UINT		len, i;
	unsigned short stn_physical_no, tbl_bin_no, dev_bin_no;
	char	*tr;
	RV_CHAR 	fromUser[Sipm_SIP_MAX_E164_ID_LEN*2] = {0};
	RvSipAddressType	addrType;
	RV_CHAR 	toUser[Sipm_SIP_MAX_E164_ID_LEN*2] = {0};
	RV_CHAR 	rseq[Sipm_SIP_MAX_E164_ID_LEN*2] = {0};
	char extnum[10];
	int Channel;

	// 1 invite -> NOWSTATUS : 1

	header = RvSipMsgGetFromHeader(*msg);
	if (header != NULL)
	{
		addr = RvSipPartyHeaderGetAddrSpec(header);

		// Source User (Telnum or ID)
		rv = RvSipAddrUrlGetUser(addr, fromUser, Sipm_SIP_MAX_E164_ID_LEN*2, &len);
		printf("CLI INFOR [%s]\n", fromUser);

		if (rv != RV_OK)
		{
			return RV_Failure;
		}
	}

/*
		chdev = FindChannelByDN2(fromUser);
		if (chdev>0)
		{
			
			if ((MasterKey==NULL)||(strcmp(MasterKey,"")==0))
			{

			}
			else
			{
				memset(RecSeeCH[chdev].masterKey,0,sizeof RecSeeCH[chdev].masterKey);
				//sprintf(RecSeeCH[chdev].masterKey, "%s", MasterKey);
				memcpy(RecSeeCH[chdev].masterKey,  MasterKey, 16);

				memset(RecSeeCH[chdev].masterSalt,0,sizeof RecSeeCH[chdev].masterSalt);
				//(RecSeeCH[chdev].masterSalt, "%s", SaltKey);
				memcpy(RecSeeCH[chdev].masterSalt,  SaltKey, 164);
			}

			// TO header
			Toheader = RvSipMsgGetToHeader(*msg);
			if (Toheader != NULL)
			{
				addr = RvSipPartyHeaderGetAddrSpec(Toheader);
				addrType = RvSipAddrGetAddrType(addr);
				if (addrType == RVSIP_ADDRTYPE_TEL)
				{

				}
				else
				{
					rv = RvSipAddrUrlGetUser(addr, toUser, Sipm_SIP_MAX_E164_ID_LEN-2, &len);
					if (rv != RV_OK)
					{
						return RV_Failure;
					}

					memset(RecSeeCH[chdev].CUST_PHONE1,0,sizeof RecSeeCH[chdev].CUST_PHONE1);
					sprintf(RecSeeCH[chdev].CUST_PHONE1,"%s",toUser);
					if (strcmp(AssertId,toUser)==0)
					{
						memset(RecSeeCH[chdev].CALL_KIND1,0,sizeof RecSeeCH[chdev].CALL_KIND1);
						sprintf(RecSeeCH[chdev].CALL_KIND1, "O");
					}
					else if (strcmp(AssertId,fromUser)==0)
					{
						memset(RecSeeCH[chdev].CALL_KIND1,0,sizeof RecSeeCH[chdev].CALL_KIND1);
						sprintf(RecSeeCH[chdev].CALL_KIND1, "I");
					}					
				}
			}
			else
			{
				return RV_Failure;
			}

			if (calltype==1)
			{
				RvSipMsgGetCallIdHeader(*msg, strCallId, Sipm_SIP_CONTENT_TYPE_LEN, &actualLen);
				
				memset(RecSeeCH[chdev].CALL_ID1,0,sizeof RecSeeCH[chdev].CALL_ID1);
				sprintf(RecSeeCH[chdev].CALL_ID1,"%s",strCallId);			
				RecSee_New_Record_Start(chdev);

				//RecvPacketTransmission *rx = new RecvPacketTransmission();
								
				
			}
			else
			{
				printf("RECORDING STOP FROM [%s] at CH[%d]\n",fromUser,chdev); 
				RecSee_New_Record_Stop(chdev);
			}
			return chdev;	
		}

	}
	else
	{
		return 0;
	}
*/
	Toheader = RvSipMsgGetToHeader(*msg);
	if (Toheader != NULL)
	{
		addr = RvSipPartyHeaderGetAddrSpec(Toheader);

		// Source User (Telnum or ID)
		rv = RvSipAddrUrlGetUser(addr, toUser, Sipm_SIP_MAX_E164_ID_LEN*2, &len);
		if (rv != RV_OK)
		{
			return RV_Failure;
		}
//printf("to user1=%s\n",toUser);
		/*
		memset(extnum,0,sizeof extnum);
		sprintf(extnum,"%s",toUser);
		chdev = FindChannelByDN2(extnum);
		*/
//printf("to user2=%s\n",toUser);


		chdev = FindChannelByDN2(toUser);
		if (chdev>0)
		{	
			memset(RecSeeCH[chdev].CUST_PHONE1,0,sizeof RecSeeCH[chdev].CUST_PHONE1);
			sprintf(RecSeeCH[chdev].CUST_PHONE1,"%s",fromUser);

/*
			if (strcmp(AssertId,toUser)==0)
			{
				memset(RecSeeCH[chdev].CALL_KIND1,0,sizeof RecSeeCH[chdev].CALL_KIND1);
				sprintf(RecSeeCH[chdev].CALL_KIND1, "O");
			}
			else if (strcmp(AssertId,fromUser)==0)
			{
				memset(RecSeeCH[chdev].CALL_KIND1,0,sizeof RecSeeCH[chdev].CALL_KIND1);
				sprintf(RecSeeCH[chdev].CALL_KIND1, "I");
			}	
*/
			
			if (strlen(AssertId)>0)
			{
				memset(RecSeeCH[chdev].CALL_KIND1,0,sizeof RecSeeCH[chdev].CALL_KIND1);
				sprintf(RecSeeCH[chdev].CALL_KIND1, "%s", AssertId);
			}

			if (calltype==1)
			{
				RvSipMsgGetCallIdHeader(*msg, strCallId, Sipm_SIP_CONTENT_TYPE_LEN, &actualLen);
				printf("NEW CALLID = %s\n", strCallId);
				memset(RecSeeCH[chdev].CALL_ID1,0,sizeof RecSeeCH[chdev].CALL_ID1);
				sprintf(RecSeeCH[chdev].CALL_ID1,"%s",strCallId);
				//printf("RECORDING START FROM USER[%s] at CH[%d]\n",toUser,chdev); 
				RecSee_New_Record_Start(chdev);
			}
			else
			{
				printf("RECORDING STOP FROM [%s] at CH[%d]\n",toUser,chdev); 
				RecSee_New_Record_Stop(chdev);
			}
			
			return chdev;	
		}

	}
	else
	{
		return 0;
	}


	//return RV_OK;
	return 0;
}


/***************************************************************************
 * RvSipCallLegMsgToSendEv
 * ------------------------------------------------------------------------
 * General: Application implementation to the message to send event handler.
 *          Here we only print the message that is about to be sent.
 * Return Value: RV_OK
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hCallLeg -    The sip stack call-leg handle
 *          hAppCallLeg - The application handle for this call-leg.
 *          hMsg -        Handle to the outgoing message.
 ***************************************************************************/
static RvStatus RVCALLCONV AppCallLegMsgToSendEvHandler(
                                    IN  RvSipCallLegHandle            hCallLeg,
                                    IN  RvSipAppCallLegHandle         hAppCallLeg,
                                    IN  RvSipMsgHandle                hMsg)
{
    //OSPrintf("--> Message Sent (call-leg %p)\n",hCallLeg);
    //AppPrintMessage(hMsg,0);
    RV_UNUSED_ARG(hAppCallLeg);
    return RV_OK;
}

/***************************************************************************
 * AppPrintMessage
 * ------------------------------------------------------------------------
 * General: Prints a message on the screen. For doing this we need to
 *          encode the message and then copy the result to a consecutive
 *          buffer.
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   hMsg -  Handle to the message.
 ***************************************************************************/
//static void AppPrintMessage(IN RvSipMsgHandle hMsg)
static RvChar*  AppPrintMessage(IN RvSipMsgHandle hMsg, int bShow, OUT RvChar *sRTPKey, OUT RvChar *cseq, OUT int SEC_TYPE)
{
    RvStatus   rv;
    HPAGE       hPage;
    RvChar     *msgBuf;
    RvUint32   msgSize;
    string pAssId = "";
	//string key1 = "";
	char key1[100];
	string key2 = "";
	string keyValue = "";
	string seqname;
	string binary;
	string decrypted;
	//uint8 binMKeys[16];
	//uint8 binSKeys[14];

    /* getting the encoded message on an rpool page.*/
    rv = RvSipMsgEncode(hMsg, g_appPool, &hPage, &msgSize);
    if (rv != RV_OK)
    {
        OSPrintf("Message encoding failed");
        os_exit(1);
    }
    /*allocate a consecutive buffer - use UTILS since malloc doesn't work on all OS's */
    msgBuf = (RvChar *)RvSipMidMemAlloc(msgSize+1);

    /* copy the encoded message to an external consecutive buffer*/
    rv = RPOOL_CopyToExternal(g_appPool,
                              hPage,
                              0,
                              (void*)msgBuf,
                              msgSize);
    /*terminate the buffer with null*/
    msgBuf[msgSize] = '\0';
    if(rv != RV_OK)
    {
        OSPrintf("Message encoding failed");
        /*free the page the encode function allocated*/
        RPOOL_FreePage(g_appPool, hPage);
        RvSipMidMemFree(msgBuf);
        os_exit(1);
    }
	
    //if (bShow==2)
    //{    
		//OSPrintf("%s",msgBuf);
    //}
	

    if (strcnt(msgBuf, "VMInfo")>0)
    {
		if (strcnt(msgBuf, "outgoing")>0)
		{
			pAssId = "O";
		}
		else if (strcnt(msgBuf, "incoming")>0)
		{
			pAssId = "I";
		}
    }

    MakeLogDB(2001,"", msgBuf);
	
	if (bShow==2)	
	{
		//key1 = getSRTPKey(msgBuf, "a=crypto:1");
		memset(key1,0,sizeof key1);
		sprintf(key1,"%s",getSRTPKey(msgBuf, "a=crypto:1"));
		//printf("key1=%s\n",key1);
		//if (key1!="")
		if (strlen(key1)>0)
		{
			//ARIA_CM_192_HMAC_SHA1_80   AES_CM_128_HMAC_SHA1_80
			//if (strstr((char*)key1.c_str(), "AES")!=NULL)
			if (strstr(key1, "AES")!=NULL)
			{
				//keyValue = getInline((char*)key1.c_str(), "inline");
				keyValue = getInline(key1, "inline");
				
				sprintf(sRTPKey,"%s",(char*)keyValue.c_str());
				printf("SRTPKey=%s\n", sRTPKey);
				SEC_TYPE = 1;
			}
			else if (strstr(key1, "ARIA")!=NULL)
			{
				keyValue = getInline(key1, "inline");
				sprintf(sRTPKey,"%s",(char*)keyValue.c_str());
				printf("SRTPKey=%s\n", sRTPKey);
				SEC_TYPE = 2;
			}
		}	
		seqname = getHeader(msgBuf, "CSeq");
		sprintf(cseq,"%s",(char*)seqname.c_str());
		//printf("seq=%s\n", cseq);
	}
	
    RPOOL_FreePage(g_appPool, hPage);
    RvSipMidMemFree(msgBuf);

    return (char*)pAssId.c_str();
}



/*--------------------U T I L I T Y   F U N C T I O N S -------------------*/



/***************************************************************************
 * AppExitOnError
 * ------------------------------------------------------------------------
 * General: prints an error message and exits.
  ***************************************************************************/
static void AppExitOnError(RvChar* str)
{
    OSPrintf("%s\n",str);
    os_exit(1);
}


/***************************************************************************
 * AppGetRegClientStateName
 * ------------------------------------------------------------------------
 * General: Returns the name of a given state
 * Return Value: The string with the state name.
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   eState - The state as enum
 ***************************************************************************/
static const RvChar*  AppGetRegClientStateName (
                                        IN  RvSipRegClientState  eState)
{
    switch (eState)
    {
    case RVSIP_REG_CLIENT_STATE_IDLE:
        return "Idle";
    case RVSIP_REG_CLIENT_STATE_TERMINATED:
        return "Terminated";
    case RVSIP_REG_CLIENT_STATE_REGISTERING:
        return "Registering";
    case RVSIP_REG_CLIENT_STATE_REDIRECTED:
        return "Redirected";
    case RVSIP_REG_CLIENT_STATE_UNAUTHENTICATED:
        return "Unauthenticated";
    case RVSIP_REG_CLIENT_STATE_REGISTERED:
        return "Registered";
    case RVSIP_REG_CLIENT_STATE_FAILED:
        return "Failed";
    default:
        return "Undefined";
    }
}


/***************************************************************************
 * AppGetCallLegStateName
 * ------------------------------------------------------------------------
 * General: Returns the name of a given state
 * Return Value: The string with the state name.
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   eState - The state as enum
 ***************************************************************************/
static const RvChar*  AppGetCallLegStateName (
                          IN  RvSipCallLegState  eState)
{

    switch(eState)
    {
    case RVSIP_CALL_LEG_STATE_ACCEPTED:
        return "Accepted";
    case RVSIP_CALL_LEG_STATE_CONNECTED:
        return "Connected";
    case RVSIP_CALL_LEG_STATE_DISCONNECTED:
        return "Disconnected";
    case RVSIP_CALL_LEG_STATE_DISCONNECTING:
        return "Disconnecting";
    case RVSIP_CALL_LEG_STATE_IDLE:
        return "Idle";
    case RVSIP_CALL_LEG_STATE_INVITING:
        return "Inviting";
    case RVSIP_CALL_LEG_STATE_OFFERING:
        return "Offering";
    case RVSIP_CALL_LEG_STATE_REDIRECTED:
        return "Redirected";
    case RVSIP_CALL_LEG_STATE_TERMINATED:
        return "Terminated";
    default:
        return "Undefined";
    }
}

/***************************************************************************
 * AppGetDirectionName
 * ------------------------------------------------------------------------
 * General: Returns a call-leg direction as a string.
 * Return Value: The string with the direction name.
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   eState - The direction as enum
 ***************************************************************************/
static const RvChar*  AppGetDirectionName(
                        IN RvSipCallLegDirection eDirection)
{
    switch(eDirection)
    {
    case RVSIP_CALL_LEG_DIRECTION_INCOMING:
        return "INCOMING";
    case RVSIP_CALL_LEG_DIRECTION_OUTGOING:
        return "OUTGOING";
    default:
        return "Undefined";
    }
}

/*===================================================================
                     APPENDIX A
  ===================================================================*/
#if (1 == APPENDIX_A)
/***************************************************************************
 * AppConnectCall2 - A different way to connect a call.
 * ------------------------------------------------------------------------
 * General: Connects a call.
 *          Before calling the RvSipCallLegConnect() function the application
 *          should follow the below steps:
 *          1. create a new call-leg using RvSipCallLegMgrCreateCallLeg().
 *          2. take from the call-leg two new handles to party headers
 *             using RvSipCallLegGetNewMsgElementHandle().
 *          3. initialize the To and From header using the message API.
 *             In this example we use RvSipPartyHeaderParse() to initialize
 *             the party header from a string.
 *          4. set the to and from headers in the call-leg.
 *          5. call RvSipCallLegConnect(). This will cause the invite message
 *             to be sent to the destination.
 ***************************************************************************/
static void AppConnectCall2(void)
{
    RvSipPartyHeaderHandle  hFrom;    /*handle to the from header*/
    RvSipPartyHeaderHandle  hTo;      /*handle to the to header*/
    RvSipCallLegHandle      hCallLeg; /*handle to the call-leg*/
    RvStatus               rv1,rv2;

    /*--------------------------
      creating a new call-leg
    ----------------------------*/
    rv1 = RvSipCallLegMgrCreateCallLeg(g_hCallLegMgr,NULL,&hCallLeg);
    if(rv1 != RV_OK)
    {
        AppExitOnError("Failed to create new call-leg");
    }
    OSPrintf("\nOutgoing call-leg %x was created\n\n",(int)hCallLeg);

    /*------------------------------------------------------------
      get 2 handles for party headers: for the To and From Headers
    -------------------------------------------------------------*/
    rv1 = RvSipCallLegGetNewMsgElementHandle(hCallLeg, RVSIP_HEADERTYPE_FROM,
                                          RVSIP_ADDRTYPE_UNDEFINED, (void**)&hFrom);
    rv2 = RvSipCallLegGetNewMsgElementHandle(hCallLeg, RVSIP_HEADERTYPE_TO,
                                          RVSIP_ADDRTYPE_UNDEFINED, (void**)&hTo);
    if(rv1 != RV_OK || rv2 != RV_OK)
    {
        AppExitOnError("Failed to get party header handled from call-leg");
    }
    /*------------------------------------------------------------
      Initialize the From and to party headers using parse.
    -------------------------------------------------------------*/
    rv1 = RvSipPartyHeaderParse(hFrom,RV_FALSE,g_pRegFrom);
    rv2 = RvSipPartyHeaderParse(hTo,RV_TRUE,g_pRegTo);

    if(rv1 != RV_OK || rv2 != RV_OK)
    {
        AppExitOnError("Failed to initialize party header");
    }

    /*------------------------------------------------------------
      Set the party headers in the call-leg
    -------------------------------------------------------------*/
    rv1 = RvSipCallLegSetFromHeader(hCallLeg,hFrom);
    rv2 = RvSipCallLegSetToHeader(hCallLeg,hTo);
    if(rv1 != RV_OK || rv2 != RV_OK)
    {
        AppExitOnError("Failed to set party header in call-leg");
    }
    /*------------------------------------------------------------
      Call the connect function to connect the call.
    -------------------------------------------------------------*/
    OSPrintf("\nConnecting a call: \n\t%s -> %s\n\n",g_pRegFrom,g_pRegTo);
    rv1 = RvSipCallLegConnect(hCallLeg);
    if(rv1 != RV_OK)
    {
        AppExitOnError("Connect failed for call-leg");
    }
}
#endif /*APPENDIX_A*/

#ifdef RV_SUPPORT_COMMAND_LINE_PARAMETERS
/***************************************************************************
 * AppAnalyzeCommandLineArguments
 * ------------------------------------------------------------------------
 * General: Analyzes the given Command Line Arguments
 * Return Value: None
 * ------------------------------------------------------------------------
 * Arguments:
 * Input:   argc, argv
 ***************************************************************************/
/*
static int AppAnalyzeCommandLineArguments(int argc, char *argv[])
{
    if (argc < 2)
    {
        OSPrintf("Default port %d will be used.\n", g_port);
    }
    else if (argc == 4)
    {
        g_port = (RvUint16)atoi(argv[1]);
        RvSprintf(g_pFrom, "From: <%s>",  argv[2]);
        RvSprintf(g_pTo,   "To: <%s>",    argv[3]);

        OSPrintf("Given port %d will be used.\n", g_port);
    }
    else if (argc == 6)
    {
        g_port = (RvUint16)atoi(argv[1]);
        RvSprintf(g_pRegFrom,            "From: <%s>",       argv[2]);
        RvSprintf(g_pRegTo,              "To: <%s>",         argv[3]);
        RvSprintf(g_pRegistrar,       "%s",               argv[4]);
        RvSprintf(g_pContact1,        "Contact: <%s>",    argv[5]);

        OSPrintf("Given port %d will be used.\n", g_port);
    }
    else
    {
        OSPrintf("Invalid arguments given!\n");
        //OSPrintf("Usage:   simpleSession <port> <from address> <to address>\n\n");
        //OSPrintf("Example: simpleSession 9876 sip:line1@127.0.0.1:9876 sip:line2@127.0.0.1:9876\n");
        return 1;
    }

    return 0;
}
*/
#endif /*#ifdef RV_SUPPORT_COMMAND_LINE_PARAMETERS*/
//#endif /*#ifndef RV_SIP_PRIMITIVES*/

#if (RV_OS_TYPE != RV_OS_TYPE_SYMBIAN)

/***************************************************************************
 * OSPrintf
 * ------------------------------------------------------------------------
 * General: Implementation of printf for different Operating Systems.
 *          (Print formatted output to the standard output stream.)
 * Return Value: The number of characters printed, or a negative value
 *               if an error occurs.
 *-------------------------------------------------------------------------
 * Arguments:
 * Input: format - Format control.
 *        There might be additional parameters according to the format.
 *-------------------------------------------------------------------------
 ***************************************************************************/
static int OSPrintf(IN const char *format,... )
{
    int      charsNo = 0;
    va_list  ap;
#if (RV_OS_TYPE == RV_OS_TYPE_WINCE)
    RvChar  cbuf[MAX_PRINT_LEN];

    /*************************************
     Print message to the buffer first
    **************************************/
    va_start(ap,format);
    charsNo = vsprintf (cbuf, format, ap);
    va_end(ap);

    /************************************************
     Using default output window for printing
    *************************************************/
    charsNo = OSWinCEPrintf(NULL,0,cbuf);
#elif (RV_OS_TYPE == RV_OS_TYPE_NUCLEUS)
	RV_UNUSED_ARG(format);
	RV_UNUSED_ARG(ap);
#else
    va_start(ap,format);
    charsNo = vprintf(format,ap);
    va_end(ap);

#endif

    return charsNo;
}

#endif

int RecSeeChinit(int chdev) {

	memset(RecSeeCH[chdev].REC_DATE,0,sizeof RecSeeCH[chdev].REC_DATE);
	memset(RecSeeCH[chdev].REC_RTIME,0,sizeof RecSeeCH[chdev].REC_RTIME);
	memset(RecSeeCH[chdev].CH_NUM,0,sizeof RecSeeCH[chdev].CH_NUM);
	memset(RecSeeCH[chdev].EXT_NUM,0,sizeof RecSeeCH[chdev].EXT_NUM);
	memset(RecSeeCH[chdev].BG_CODE,0,sizeof RecSeeCH[chdev].BG_CODE);
	memset(RecSeeCH[chdev].MG_CODE,0,sizeof RecSeeCH[chdev].MG_CODE);
	memset(RecSeeCH[chdev].SG_CODE,0,sizeof RecSeeCH[chdev].SG_CODE);
	memset(RecSeeCH[chdev].REC_TIME,0,sizeof RecSeeCH[chdev].REC_TIME);
	memset(RecSeeCH[chdev].USER_ID,0,sizeof RecSeeCH[chdev].USER_ID);
	memset(RecSeeCH[chdev].USER_NAME,0,sizeof RecSeeCH[chdev].USER_NAME);
	memset(RecSeeCH[chdev].CALL_ID1,0,sizeof RecSeeCH[chdev].CALL_ID1);
	memset(RecSeeCH[chdev].CALL_ID2,0,sizeof RecSeeCH[chdev].CALL_ID2);
	memset(RecSeeCH[chdev].CALL_ID3,0,sizeof RecSeeCH[chdev].CALL_ID3);
	memset(RecSeeCH[chdev].CUST_NAME,0,sizeof RecSeeCH[chdev].CUST_NAME);
	memset(RecSeeCH[chdev].CUST_PHONE1,0,sizeof RecSeeCH[chdev].CUST_PHONE1);
	memset(RecSeeCH[chdev].CUST_PHONE2,0,sizeof RecSeeCH[chdev].CUST_PHONE2);
	memset(RecSeeCH[chdev].CUST_PHONE3,0,sizeof RecSeeCH[chdev].CUST_PHONE3);
	memset(RecSeeCH[chdev].CALL_KIND1,0,sizeof RecSeeCH[chdev].CALL_KIND1);
	memset(RecSeeCH[chdev].CALL_KIND2,0,sizeof RecSeeCH[chdev].CALL_KIND2);
	memset(RecSeeCH[chdev].CALL_STIME,0,sizeof RecSeeCH[chdev].CALL_STIME);
	memset(RecSeeCH[chdev].CALL_ETIME,0,sizeof RecSeeCH[chdev].CALL_ETIME);
	memset(RecSeeCH[chdev].CALL_TTIME,0,sizeof RecSeeCH[chdev].CALL_TTIME);
	memset(RecSeeCH[chdev].SELFDIS_YN,0,sizeof RecSeeCH[chdev].SELFDIS_YN);
	memset(RecSeeCH[chdev].V_SYS_CODE,0,sizeof RecSeeCH[chdev].V_SYS_CODE);
	memset(RecSeeCH[chdev].V_HDD_FLAG,0,sizeof RecSeeCH[chdev].V_HDD_FLAG);
	memset(RecSeeCH[chdev].LISTEN_URL,0,sizeof RecSeeCH[chdev].LISTEN_URL);
	
	memset(RecSeeCH[chdev].T_SYS_CODE,0,sizeof RecSeeCH[chdev].T_SYS_CODE);
	memset(RecSeeCH[chdev].T_HDD_FLAG,0,sizeof RecSeeCH[chdev].T_HDD_FLAG);
	memset(RecSeeCH[chdev].TEXT_URL,0,sizeof RecSeeCH[chdev].TEXT_URL);

	memset(RecSeeCH[chdev].V_FILENAME,0,sizeof RecSeeCH[chdev].V_FILENAME);
	memset(RecSeeCH[chdev].S_SYS_CODE,0,sizeof RecSeeCH[chdev].S_SYS_CODE);
	memset(RecSeeCH[chdev].S_HDD_FLAG,0,sizeof RecSeeCH[chdev].S_HDD_FLAG);
	memset(RecSeeCH[chdev].SCREEN_URL,0,sizeof RecSeeCH[chdev].SCREEN_URL);
	memset(RecSeeCH[chdev].REC_VISIBLE,0,sizeof RecSeeCH[chdev].REC_VISIBLE);
	memset(RecSeeCH[chdev].S_FILENAME,0,sizeof RecSeeCH[chdev].S_FILENAME);
	memset(SRecSeeCH[chdev].REC_MEMO,0,sizeof SRecSeeCH[chdev].REC_MEMO);
	memset(RecSeeCH[chdev].EVAL_YN,0,sizeof RecSeeCH[chdev].EVAL_YN);
	memset(RecSeeCH[chdev].LISTEN_YN,0,sizeof RecSeeCH[chdev].LISTEN_YN);
	memset(RecSeeCH[chdev].NOW_EVENT,0,sizeof RecSeeCH[chdev].NOW_EVENT);
//	memset(RecSeeCH[chdev].NOW_RECORD,0,sizeof RecSeeCH[chdev].NOW_RECORD);
	memset(RecSeeCH[chdev].RECORD_YN,0,sizeof RecSeeCH[chdev].RECORD_YN);

	memset(SRecSeeCH[chdev].BUFFER3,0,sizeof SRecSeeCH[chdev].BUFFER3);
	memset(SRecSeeCH[chdev].BUFFER2,0,sizeof SRecSeeCH[chdev].BUFFER2);
	memset(SRecSeeCH[chdev].BUFFER1,0,sizeof SRecSeeCH[chdev].BUFFER1);
	memset(SRecSeeCH[chdev].CUST_ADDRESS,0,sizeof SRecSeeCH[chdev].CUST_ADDRESS);
	memset(SRecSeeCH[chdev].COUNSEL_CONTENT,0,sizeof SRecSeeCH[chdev].COUNSEL_CONTENT);
	memset(SRecSeeCH[chdev].COUNSEL_CODE,0,sizeof SRecSeeCH[chdev].COUNSEL_CODE);
	memset(SRecSeeCH[chdev].CONTRACT_NUM,0,sizeof SRecSeeCH[chdev].CONTRACT_NUM);
	memset(SRecSeeCH[chdev].CUST_SOCIAL_NUM,0,sizeof SRecSeeCH[chdev].CUST_SOCIAL_NUM);

	memset(RecSeeCH[chdev].CLI_FILE_PATH,0,sizeof RecSeeCH[chdev].CLI_FILE_PATH);
	memset(RecSeeCH[chdev].TMP_FILE_PATH,0,sizeof RecSeeCH[chdev].TMP_FILE_PATH);
	memset(RecSeeCH[chdev].REC_KIND,0,sizeof RecSeeCH[chdev].REC_KIND);
	memset(RecSeeCH[chdev].EXT_AGT_IP,0,sizeof RecSeeCH[chdev].EXT_AGT_IP);
	memset(RecSeeCH[chdev].EXT_KEY,0,sizeof RecSeeCH[chdev].EXT_KEY);
	memset(RecSeeCH[chdev].EXT_MAC,0,sizeof RecSeeCH[chdev].EXT_MAC);
	memset(RecSeeCH[chdev].NOW_STATUS,0,sizeof RecSeeCH[chdev].NOW_STATUS);


	memset(RecSeeCH[chdev].RECEIPT_NUM,0,sizeof RecSeeCH[chdev].RECEIPT_NUM);
	memset(RecSeeCH[chdev].REC_KEY,0,sizeof RecSeeCH[chdev].REC_KEY);
	memset(RecSeeCH[chdev].EXT_IP,0,sizeof RecSeeCH[chdev].EXT_IP);
	memset(RecSeeCH[chdev].MAC_ADDR,0,sizeof RecSeeCH[chdev].MAC_ADDR);
	memset(RecSeeCH[chdev].AGENT_IP,0,sizeof RecSeeCH[chdev].AGENT_IP);
	memset(RecSeeCH[chdev].RECORD_YN,0,sizeof RecSeeCH[chdev].RECORD_YN);

	memset(RecSeeCH[chdev].BG_NAME,0,sizeof RecSeeCH[chdev].BG_NAME);
	memset(RecSeeCH[chdev].MG_NAME,0,sizeof RecSeeCH[chdev].MG_NAME);
	memset(RecSeeCH[chdev].SG_NAME,0,sizeof RecSeeCH[chdev].SG_NAME);

	memset(RecSeeCH[chdev].CALL_KIND1,0,sizeof RecSeeCH[chdev].CALL_KIND1);
	memset(RecSeeCH[chdev].CALL_KIND2,0,sizeof RecSeeCH[chdev].CALL_KIND2);

	memset(SRecSeeCH[chdev].R_CUST_ID,0,sizeof SRecSeeCH[chdev].R_CUST_ID);
	memset(SRecSeeCH[chdev].R_REGI_DATE,0,sizeof SRecSeeCH[chdev].R_REGI_DATE);
	memset(SRecSeeCH[chdev].R_MANAGER,0,sizeof SRecSeeCH[chdev].R_MANAGER);

	RecSeeCH[chdev].NOW_RECORD=0;
	// 20090212 sim
	RecSeeCH[chdev].BLOCK_YN = 0;
	RecSeeCH[chdev].IPCR_REC = 0;

	// 20090522 sim
	memset(RecSeeCH[chdev].VDO_FILE_PATH,0,sizeof RecSeeCH[chdev].VDO_FILE_PATH);
	memset(RecSeeCH[chdev].VDO_URL,0,sizeof RecSeeCH[chdev].VDO_URL);

	// 20090719 sim
	RecSeeCH[chdev].RTP_COUNT = 0;

	RecSeeCH[chdev].PortNo = 0;

	return 1;
}


int UpdateAgentInfomation(char *Extension, char* AgentID)
{
	char query[1024];
	PGresult      *res;
	
	int field_num;
	int row_num;
	int i;
	int j,k;
	char SPLIT2[50][30];
	char *CHECK2;
	char SRC_IP[20];   
	char auto_yn[2]; 
	char log_yn[2]; 
	char rec_yn[2]; 
	int chdev=0;
	
	// FINDUSER FROM RECORD -> 0:SELECT->ADD, 1:SELECT->UPDATE
//	sleep(1);

	j = FindChannelByAgent(AgentID);
	if (j>-1)
	{
		printf("FIND AGENT[%d]=%s\n",j,AgentID);
		i = j;	
		memset(query,0,sizeof query);
			sprintf(query, "SELECT r_ch_num, r_sys_code, r_ext_num, coalesce(r_ext_mac,' ') AS r_ext_mac, coalesce(r_ext_key,' ') AS r_ext_key , coalesce(r_ext_ip,' ') AS r_ext_ip, coalesce(r_auto_yn,'Y') AS r_auto_yn, coalesce(r_rec_yn,'Y') AS r_rec_yn, coalesce(r_log_yn,'Y') AS r_log_yn FROM rs_ch_info where r_ext_num='%s'", Extension);
		printf("--------------------------------------\n");
		printf("%s\n",query);
	
			res = PQexec(conn, query);

			if (PQresultStatus(res) != PGRES_TUPLES_OK)
			{
				printf("no record agent\n");
				PQclear(res);
	//			PQfinish(conn);
				return -1;
			}

			printf("AGENT EXT=[%s]\n",RecSeeCH[i].EXT_NUM);
			RecSeeChinit(i);		
			memset(SRC_IP,0x00,sizeof SRC_IP);
			memset(RecSeeCH[i].V_SYS_CODE, 0x00, sizeof RecSeeCH[i].V_SYS_CODE);
			memset(RecSeeCH[i].S_SYS_CODE, 0x00, sizeof RecSeeCH[i].S_SYS_CODE);
			memset(RecSeeCH[i].T_SYS_CODE, 0x00, sizeof RecSeeCH[i].T_SYS_CODE);
			memset(RecSeeCH[i].EXT_NUM, 0x00, sizeof RecSeeCH[i].EXT_NUM);
			memset(RecSeeEX[i].EXT_NUM, 0x00, sizeof RecSeeEX[i].EXT_NUM);
			memset(RecSeeCH[i].EXT_MAC, 0x00, sizeof RecSeeCH[i].EXT_MAC);
			memset(RecSeeCH[i].EXT_KEY, 0x00, sizeof RecSeeCH[i].EXT_KEY);
			memset(RecSeeCH[i].EXT_AGT_IP, 0x00, sizeof RecSeeCH[i].EXT_AGT_IP);
			memset(RecSeeCH[i].EXT_IP, 0x00, sizeof RecSeeCH[i].EXT_IP);
			memset(auto_yn,0,sizeof auto_yn);
			memset(rec_yn,0,sizeof rec_yn);
			memset(log_yn,0,sizeof log_yn);

			sprintf(RecSeeCH[i].CH_NUM, "%s", PQgetvalue(res, 0, 0));
			sprintf(RecSeeCH[i].V_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[i].S_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[i].T_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[i].EXT_NUM,"%s", PQgetvalue(res, 0, 2));
			sprintf(RecSeeEX[i].EXT_NUM,"%s", PQgetvalue(res, 0, 2));
			sprintf(RecSeeCH[i].EXT_MAC, "%s", PQgetvalue(res, 0, 3));	
			sprintf(RecSeeCH[i].EXT_KEY,"%s", PQgetvalue(res, 0, 4));
			sprintf(RecSeeCH[i].EXT_IP,"%s", PQgetvalue(res, 0, 5));
			sprintf(auto_yn,"%s", PQgetvalue(res, 0, 6));	
			sprintf(rec_yn,"%s", PQgetvalue(res, 0, 7));
			sprintf(log_yn,"%s", PQgetvalue(res, 0, 8));
		
			if (strcmp(auto_yn,"ACR")==0)
			{	
				RecSeeCH[i].AUTO_REC=1;
			}
			else
			{
				RecSeeCH[i].AUTO_REC=0;
			}
			if (strcmp(rec_yn,"Y")==0)
			{	
				RecSeeCH[i].REC_YN=1;
			}
			else
			{
				RecSeeCH[i].REC_YN=0;
			}
			if (strcmp(log_yn,"Y")==0)
			{	
				RecSeeCH[i].LOG_YN=1;
			}
			else
			{
				RecSeeCH[i].LOG_YN=0;
			}
			sprintf(RECSEE_CH[i].IPADDR,"%s",PQgetvalue(res, 0, 5));
			sprintf(RECSEE_CH[i].PHONE_NUM,"%s",PQgetvalue(res, 0, 2));
			sprintf(SRC_IP,"%s",RECSEE_CH[i].IPADDR);
			if(InitFileChk==0)
			{ rFileChk[i] = 0;
			  InitFileChk=1;
			}

			PHONE_LINE[atoi(RecSeeCH[i].EXT_NUM)]=i;

			memset(SPLIT2,0,sizeof SPLIT2);
			CHECK2 = strtok( SRC_IP, "." );

			for ( j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
			{
				if(CHECK2!=NULL){
					sprintf(SPLIT2[j],(char*)CHECK2);
				}else{
					break;
				}
			}

			IPPHONE_CHK2[RECSEE_CH[i].HEX_KEY]=i; 

			IPPHONE_CHK[atoi(RECSEE_CH[i].PHONE_NUM)]=i; 
			FURENCE_DC[atoi(SPLIT2[2])][atoi(SPLIT2[3])]=i;

			FURENCE_MAC[i] = RecSeeCH[i].EXT_MAC;
			
			PQclear(res); 
	}
	else
	{
		// get extention information and matching ext & user
		chdev = FindChannelByDN(Extension);
		if (chdev>0)
		{
			printf("FIND EXTENSION[%d]=%s\n", chdev,Extension);

			memset(query,0,sizeof query);
			sprintf(query, "SELECT r_ch_num, r_sys_code, r_ext_num, coalesce(r_ext_mac,' ') AS r_ext_mac, coalesce(r_ext_key,' ') AS r_ext_key , coalesce(r_ext_ip,' ') AS r_ext_ip, coalesce(r_auto_yn,'Y') AS r_auto_yn, coalesce(r_rec_yn,'Y') AS r_rec_yn, coalesce(r_log_yn,'Y') AS r_log_yn FROM rs_ch_info where r_ext_num='%s'", Extension);
printf("-----------------------------------\n");
printf("%s\n",query);
			res = PQexec(conn, query);

			if (PQresultStatus(res) != PGRES_TUPLES_OK)
			{
				PQclear(res);
				printf("no record extension\n");
		//		PQfinish(conn);
				return -1;
			}

			//chdev = TOTAL_LINE+1;

			RecSeeChinit(chdev);		
			memset(SRC_IP,0x00,sizeof SRC_IP);
			memset(RecSeeCH[chdev].V_SYS_CODE, 0x00, sizeof RecSeeCH[chdev].V_SYS_CODE);
			memset(RecSeeCH[chdev].S_SYS_CODE, 0x00, sizeof RecSeeCH[chdev].S_SYS_CODE);
			memset(RecSeeCH[chdev].T_SYS_CODE, 0x00, sizeof RecSeeCH[chdev].T_SYS_CODE);
			memset(RecSeeCH[chdev].EXT_NUM, 0x00, sizeof RecSeeCH[chdev].EXT_NUM);
			memset(RecSeeEX[chdev].EXT_NUM, 0x00, sizeof RecSeeEX[chdev].EXT_NUM);
			memset(RecSeeCH[chdev].EXT_MAC, 0x00, sizeof RecSeeCH[chdev].EXT_MAC);
			memset(RecSeeCH[chdev].EXT_KEY, 0x00, sizeof RecSeeCH[chdev].EXT_KEY);
			memset(RecSeeCH[chdev].EXT_AGT_IP, 0x00, sizeof RecSeeCH[chdev].EXT_AGT_IP);
			memset(RecSeeCH[chdev].EXT_IP, 0x00, sizeof RecSeeCH[chdev].EXT_IP);
			memset(auto_yn,0,sizeof auto_yn);
			memset(rec_yn,0,sizeof rec_yn);
			memset(log_yn,0,sizeof log_yn);

			sprintf(RecSeeCH[chdev].CH_NUM, "%s", PQgetvalue(res, 0, 0));
			sprintf(RecSeeCH[chdev].V_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[chdev].S_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[chdev].T_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[chdev].EXT_NUM,"%s", PQgetvalue(res, 0, 2));
			sprintf(RecSeeEX[chdev].EXT_NUM,"%s", PQgetvalue(res, 0, 2));
			sprintf(RecSeeCH[chdev].EXT_MAC, "%s", PQgetvalue(res, 0, 3));	
			sprintf(RecSeeCH[chdev].EXT_KEY,"%s", PQgetvalue(res, 0, 4));
			sprintf(RecSeeCH[chdev].EXT_IP,"%s", PQgetvalue(res, 0, 5));
			sprintf(auto_yn,"%s", PQgetvalue(res, 0, 6));	
			sprintf(rec_yn,"%s", PQgetvalue(res, 0, 7));
			sprintf(log_yn,"%s", PQgetvalue(res, 0, 8));
		
			if (strcmp(auto_yn,"ACR")==0)
			{	
				RecSeeCH[chdev].AUTO_REC=1;
			}
			else
			{
				RecSeeCH[chdev].AUTO_REC=0;
			}
			if (strcmp(rec_yn,"Y")==0)
			{	
				RecSeeCH[chdev].REC_YN=1;
			}
			else
			{
				RecSeeCH[chdev].REC_YN=0;
			}
			if (strcmp(log_yn,"Y")==0)
			{	
				RecSeeCH[chdev].LOG_YN=1;
			}
			else
			{
				RecSeeCH[chdev].LOG_YN=0;
			}
			sprintf(RECSEE_CH[chdev].IPADDR,"%s",PQgetvalue(res, 0, 5));
			sprintf(RECSEE_CH[chdev].PHONE_NUM,"%s",PQgetvalue(res, 0, 2));
			sprintf(SRC_IP,"%s",RECSEE_CH[chdev].IPADDR);
			
			//printf("ADD Extension %d : [%s]\n", chdev, RecSeeCH[chdev].EXT_NUM);
			
			if(InitFileChk==0)
			{ rFileChk[chdev] = 0;
			  InitFileChk=1;
			}

			PHONE_LINE[atoi(RecSeeCH[chdev].EXT_NUM)]=chdev;

			memset(SPLIT2,0,sizeof SPLIT2);
			CHECK2 = strtok( SRC_IP, "." );

			for ( j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
			{
				if(CHECK2!=NULL){
					sprintf(SPLIT2[j],(char*)CHECK2);
				}else{
					break;
				}
			}

			IPPHONE_CHK2[RECSEE_CH[chdev].HEX_KEY]=chdev; 

			IPPHONE_CHK[atoi(RECSEE_CH[chdev].PHONE_NUM)]=chdev; 
			FURENCE_DC[atoi(SPLIT2[2])][atoi(SPLIT2[3])]=chdev;

			FURENCE_MAC[chdev] = RecSeeCH[chdev].EXT_MAC; 

			PQclear(res);
			
		}
		else
		{
			// insert information
			memset(query,0,sizeof query);
			sprintf(query, "SELECT r_ch_num, r_sys_code, r_ext_num, coalesce(r_ext_mac,' ') AS r_ext_mac, coalesce(r_ext_key,' ') AS r_ext_key , coalesce(r_ext_ip,' ') AS r_ext_ip, coalesce(r_auto_yn,'Y') AS r_auto_yn, coalesce(r_rec_yn,'Y') AS r_rec_yn, coalesce(r_log_yn,'Y') AS r_log_yn FROM rs_ch_info where r_ext_num='%s'", Extension);

			res = PQexec(conn, query);

			if (PQresultStatus(res) != PGRES_TUPLES_OK)
			{
				PQclear(res);
				printf("no record agent\n");
				//PQfinish(conn);
				return -1;
			}

			k = TOTAL_LINE+1;

			RecSeeChinit(k);		
			memset(SRC_IP,0x00,sizeof SRC_IP);
			memset(RecSeeCH[k].V_SYS_CODE, 0x00, sizeof RecSeeCH[k].V_SYS_CODE);
			memset(RecSeeCH[k].S_SYS_CODE, 0x00, sizeof RecSeeCH[k].S_SYS_CODE);
			memset(RecSeeCH[k].T_SYS_CODE, 0x00, sizeof RecSeeCH[k].T_SYS_CODE);
			memset(RecSeeCH[k].EXT_NUM, 0x00, sizeof RecSeeCH[k].EXT_NUM);
			memset(RecSeeEX[k].EXT_NUM, 0x00, sizeof RecSeeEX[k].EXT_NUM);
			memset(RecSeeCH[k].EXT_MAC, 0x00, sizeof RecSeeCH[k].EXT_MAC);
			memset(RecSeeCH[k].EXT_KEY, 0x00, sizeof RecSeeCH[k].EXT_KEY);
			memset(RecSeeCH[k].EXT_AGT_IP, 0x00, sizeof RecSeeCH[k].EXT_AGT_IP);
			memset(RecSeeCH[k].EXT_IP, 0x00, sizeof RecSeeCH[k].EXT_IP);
			memset(auto_yn,0,sizeof auto_yn);
			memset(rec_yn,0,sizeof rec_yn);
			memset(log_yn,0,sizeof log_yn);

			sprintf(RecSeeCH[k].CH_NUM, "%s", PQgetvalue(res, 0, 0));
			sprintf(RecSeeCH[k].V_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[k].S_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[k].T_SYS_CODE,"%s", PQgetvalue(res, 0, 1));
			sprintf(RecSeeCH[k].EXT_NUM,"%s", PQgetvalue(res, 0, 2));
			sprintf(RecSeeEX[k].EXT_NUM,"%s", PQgetvalue(res, 0, 2));
			sprintf(RecSeeCH[k].EXT_MAC, "%s", PQgetvalue(res, 0, 3));	
			sprintf(RecSeeCH[k].EXT_KEY,"%s", PQgetvalue(res, 0, 4));
			sprintf(RecSeeCH[k].EXT_IP,"%s", PQgetvalue(res, 0, 5));
			sprintf(auto_yn,"%s", PQgetvalue(res, 0, 6));	
			sprintf(rec_yn,"%s", PQgetvalue(res, 0, 7));
			sprintf(log_yn,"%s", PQgetvalue(res, 0, 8));
		
			if (strcmp(auto_yn,"ACR")==0)
			{	
				RecSeeCH[k].AUTO_REC=1;
			}
			else
			{
				RecSeeCH[k].AUTO_REC=0;
			}
			if (strcmp(rec_yn,"Y")==0)
			{	
				RecSeeCH[k].REC_YN=1;
			}
			else
			{
				RecSeeCH[k].REC_YN=0;
			}
			if (strcmp(log_yn,"Y")==0)
			{	
				RecSeeCH[k].LOG_YN=1;
			}
			else
			{
				RecSeeCH[k].LOG_YN=0;
			}
			sprintf(RECSEE_CH[k].IPADDR,"%s",PQgetvalue(res, 0, 5));
			sprintf(RECSEE_CH[k].PHONE_NUM,"%s",PQgetvalue(res, 0, 2));
			sprintf(SRC_IP,"%s",RECSEE_CH[k].IPADDR);
			
			printf("ADD Extension %d : [%s]\n", k, RecSeeCH[k].EXT_NUM);
			
			if(InitFileChk==0)
			{ rFileChk[k] = 0;
			  InitFileChk=1;
			}

			PHONE_LINE[atoi(RecSeeCH[k].EXT_NUM)]=k;

			memset(SPLIT2,0,sizeof SPLIT2);
			CHECK2 = strtok( SRC_IP, "." );

			for ( j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
			{
				if(CHECK2!=NULL){
					sprintf(SPLIT2[j],(char*)CHECK2);
				}else{
					break;
				}
			}

			IPPHONE_CHK2[RECSEE_CH[k].HEX_KEY]=k; 

			IPPHONE_CHK[atoi(RECSEE_CH[k].PHONE_NUM)]=k; 
			FURENCE_DC[atoi(SPLIT2[2])][atoi(SPLIT2[3])]=k;

			FURENCE_MAC[k] = RecSeeCH[k].EXT_MAC; 

	//		PQclear(res);			
		}

		PQclear(res);

		REC_INIT=1;
		//sprintf(tot_ch,"%d",TOTAL_LINE);
		
		i = TOTAL_USER+1;
	}

    memset(query,0,sizeof query);
	sprintf(query , "SELECT r_user_id, r_user_name,r_bg_code, r_mg_code,r_sg_code, coalesce(r_ext_no,' ') AS r_ext_no,coalesce(r_emp_id,' ') AS r_emp_id, coalesce(r_cti_id, ' ') AS r_cti_id FROM rs_ruser_info where r_user_id='%s'",AgentID); 
	res = PQexec(conn, query);
	
	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		//PQfinish(conn);
		return -1;
	}

	memset(RecSeeUSER[i].USER_ID, 0x00, sizeof RecSeeUSER[i].USER_ID);
	memset(RecSeeUSER[i].USER_NAME, 0x00, sizeof RecSeeUSER[i].USER_NAME);
	memset(RecSeeUSER[i].BG_CODE, 0x00, sizeof RecSeeUSER[i].BG_CODE);
	memset(RecSeeUSER[i].MG_CODE, 0x00, sizeof RecSeeUSER[i].MG_CODE);
	memset(RecSeeUSER[i].SG_CODE, 0x00, sizeof RecSeeUSER[i].SG_CODE);
	memset(RecSeeUSER[i].EXT_NO, 0x00, sizeof RecSeeUSER[i].EXT_NO);
	memset(RecSeeUSER[i].EMP_ID, 0x00, sizeof RecSeeUSER[i].EMP_ID);
	memset(RecSeeUSER[i].BG_NAME, 0x00, sizeof RecSeeUSER[i].BG_NAME);
	memset(RecSeeUSER[i].MG_NAME, 0x00, sizeof RecSeeUSER[i].MG_NAME);
	memset(RecSeeUSER[i].SG_NAME, 0x00, sizeof RecSeeUSER[i].SG_NAME);
	memset(RecSeeUSER[i].REC_KIND, 0x00, sizeof RecSeeUSER[i].REC_KIND);
	memset(RecSeeUSER[i].CTI_ID, 0x00, sizeof RecSeeUSER[i].CTI_ID);


	sprintf(RecSeeUSER[i].USER_ID,"%s", PQgetvalue(res, 0, 0));
	sprintf(RecSeeUSER[i].USER_NAME,"%s", PQgetvalue(res, 0, 1));
	sprintf(RecSeeUSER[i].BG_CODE,"%s",  PQgetvalue(res, 0, 2));
	
	FindBGCode(RecSeeUSER[i].BG_CODE, i);
	
	sprintf(RecSeeUSER[i].MG_CODE,"%s",  PQgetvalue(res, 0, 3));
		
	FindMGCode(RecSeeUSER[i].BG_CODE,RecSeeUSER[i].MG_CODE, i);
		
	sprintf(RecSeeUSER[i].SG_CODE,"%s",  PQgetvalue(res, 0, 4));
	
	FindSGCode(RecSeeUSER[i].BG_CODE,RecSeeUSER[i].MG_CODE,RecSeeUSER[i].SG_CODE, i);

	sprintf(RecSeeUSER[i].EXT_NO,"%s",  PQgetvalue(res, 0, 5));
	sprintf(RecSeeUSER[i].EMP_ID,"%s",  PQgetvalue(res, 0, 6));			
	sprintf(RecSeeUSER[i].CTI_ID,"%s",  PQgetvalue(res, 0, 7));		

	PQclear(res);		

	MatchingChannelInfo();
	
	return 1;
}

int DBGetChannelInfo() {

	char query[1024];
	PGresult      *res;

	int field_num;
	int row_num;
	int i;
	int j;
	char SPLIT2[50][30];
	char *CHECK2;
	char SRC_IP[20];   
	char auto_yn[2]; 
	char log_yn[2]; 
	char rec_yn[2]; 

	PGconn *mconn;

    mconn = PQsetdbLogin(pghost, pgport, pgoptions, NULL, 
                        dbname, pguser, pgpass);

    if (PQstatus(mconn) == CONNECTION_BAD)
    {
        fprintf(stderr, "%s", PQerrorMessage(mconn));
        return -1;
    }

	sprintf(query, "SELECT r_sys_id, r_sys_ip FROM rs_sys_info"); 
	res = PQexec(mconn, query);
	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		printf("no record rs_sys_info\n");
		PQfinish(mconn);
		return -1;
	}

	row_num = PQntuples(res);

	for (i = 0; i < row_num; i++)
	{
		memset(RecSeeSer[i+1].SERVER_CODE, 0, sizeof RecSeeSer[i+1].SERVER_CODE);
		memset(RecSeeSer[i+1].SERVER_IP, 0, sizeof RecSeeSer[i+1].SERVER_IP);
		sprintf(RecSeeSer[i+1].SERVER_CODE,"%s", PQgetvalue(res, i, 0));
		sprintf(RecSeeSer[i+1].SERVER_IP,"%s", PQgetvalue(res, i, 1));
	}
	PQclear(res);

	
	//sprint(query, "SELECT r_ch_num, r_sys_code, r_ext_num, coalesce(r_ext_mac,' ') AS r_ext_mac, coalesce(r_ext_key,' ') AS r_ext_kry , coalesce(r_ext_ip,' ') AS r_ext_ip FROM rs_ch_info WHERE r_sys_code='%s' ORDER BY r_ch_num",SERVER_CODE);
	sprintf(query, "SELECT r_ch_num, r_sys_code, r_ext_num, coalesce(r_ext_mac,' ') AS r_ext_mac, coalesce(r_ext_key,' ') AS r_ext_key , coalesce(r_ext_ip,' ') AS r_ext_ip, coalesce(r_auto_yn,'Y') AS r_auto_yn, coalesce(r_rec_yn,'Y') AS r_rec_yn, coalesce(r_log_yn,'Y') AS r_log_yn FROM rs_ch_info ORDER BY r_ch_num");

	res = PQexec(mconn, query);

	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		printf("no record rs_ch_info\n");
		PQfinish(mconn);
		return -1;
	}

	row_num = PQntuples(res);
	for (i = 0; i < row_num; i++)
	{
		RecSeeChinit(i+1);		
		memset(SRC_IP,0x00,sizeof SRC_IP);
		memset(RecSeeCH[i+1].V_SYS_CODE, 0x00, sizeof RecSeeCH[i+1].V_SYS_CODE);
		memset(RecSeeCH[i+1].S_SYS_CODE, 0x00, sizeof RecSeeCH[i+1].S_SYS_CODE);
		memset(RecSeeCH[i+1].T_SYS_CODE, 0x00, sizeof RecSeeCH[i+1].T_SYS_CODE);
		memset(RecSeeCH[i+1].EXT_NUM, 0x00, sizeof RecSeeCH[i+1].EXT_NUM);
		memset(RecSeeEX[i+1].EXT_NUM, 0x00, sizeof RecSeeEX[i+1].EXT_NUM);
		memset(RecSeeCH[i+1].EXT_MAC, 0x00, sizeof RecSeeCH[i+1].EXT_MAC);
		memset(RecSeeCH[i+1].EXT_KEY, 0x00, sizeof RecSeeCH[i+1].EXT_KEY);
		memset(RecSeeCH[i+1].EXT_AGT_IP, 0x00, sizeof RecSeeCH[i+1].EXT_AGT_IP);
		memset(RecSeeCH[i+1].EXT_IP, 0x00, sizeof RecSeeCH[i+1].EXT_IP);
		memset(auto_yn,0,sizeof auto_yn);
		memset(rec_yn,0,sizeof rec_yn);
		memset(log_yn,0,sizeof log_yn);

		sprintf(RecSeeCH[i+1].CH_NUM, "%s", PQgetvalue(res, i, 0));
		sprintf(RecSeeCH[i+1].V_SYS_CODE,"%s", PQgetvalue(res, i, 1));
		sprintf(RecSeeCH[i+1].S_SYS_CODE,"%s", PQgetvalue(res, i, 1));
		sprintf(RecSeeCH[i+1].T_SYS_CODE,"%s", PQgetvalue(res, i, 1));
		sprintf(RecSeeCH[i+1].EXT_NUM,"%s", PQgetvalue(res, i, 2));
		sprintf(RecSeeEX[i+1].EXT_NUM,"%s", PQgetvalue(res, i, 2));
		sprintf(RecSeeCH[i+1].EXT_MAC, "%s", PQgetvalue(res, i, 3));	
		sprintf(RecSeeCH[i+1].EXT_KEY,"%s", PQgetvalue(res, i, 4));
		sprintf(RecSeeCH[i+1].EXT_IP,"%s", PQgetvalue(res, i, 5));
		sprintf(auto_yn,"%s", PQgetvalue(res, i, 6));	
		sprintf(rec_yn,"%s", PQgetvalue(res, i, 7));
		sprintf(log_yn,"%s", PQgetvalue(res, i, 8));
	
		if (strcmp(auto_yn,"ACR")==0)
		{	
			RecSeeCH[i+1].AUTO_REC=1;
		}
		else
		{
			RecSeeCH[i+1].AUTO_REC=0;
		}
		if (strcmp(rec_yn,"Y")==0)
		{	
			RecSeeCH[i+1].REC_YN=1;
		}
		else
		{
			RecSeeCH[i+1].REC_YN=0;
		}
		if (strcmp(log_yn,"Y")==0)
		{	
			RecSeeCH[i+1].LOG_YN=1;
		}
		else
		{
			RecSeeCH[i+1].LOG_YN=0;
		}
		sprintf(RECSEE_CH[i+1].IPADDR,"%s",PQgetvalue(res, i, 5));
		sprintf(RECSEE_CH[i+1].PHONE_NUM,"%s",PQgetvalue(res, i, 2));
		sprintf(SRC_IP,"%s",RECSEE_CH[i+1].IPADDR);
		
		printf("Extension %d : [%s]\n", i+1, RecSeeCH[i+1].EXT_NUM);
		
		if(InitFileChk==0)
		{ rFileChk[i+1] = 0;
		  InitFileChk=1;
		}

		PHONE_LINE[atoi(RecSeeCH[i+1].EXT_NUM)]=i+1;

		memset(SPLIT2,0,sizeof SPLIT2);
		CHECK2 = strtok( SRC_IP, "." );

		for ( j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
		{
			if(CHECK2!=NULL){
				sprintf(SPLIT2[j],(char*)CHECK2);
			}else{
				break;
			}
		}

		IPPHONE_CHK2[RECSEE_CH[i+1].HEX_KEY]=i+1; 

		//IPPHONE_CHK[atoi(RECSEE_CH[i+1].PHONE_NUM)]=i+1; 
		FURENCE_DC[atoi(SPLIT2[2])][atoi(SPLIT2[3])]=i+1;

		FURENCE_MAC[i+1] = RecSeeCH[i+1].EXT_MAC; 

		// test
		//RecSeeCH[i+1].SRTP_YN=1;
	}

	PQclear(res);

	REC_INIT=1;
	TOTAL_LINE = i;
	//sprintf(tot_ch,"%d",TOTAL_LINE);

	PQfinish(mconn);

	return 1;
}


int DBGetUserInfo() {

	char query[1024];
	PGresult      *res;

	int field_num;
	int row_num;
	int i;

	PGconn *mconn;

    mconn = PQsetdbLogin(pghost, pgport, pgoptions, NULL, 
                        dbname, pguser, pgpass);

    if (PQstatus(mconn) == CONNECTION_BAD)
    {
        fprintf(stderr, "%s", PQerrorMessage(mconn));
        return -1;
    }

	sprintf(query, "SELECT r_bg_code, r_bg_name FROM rs_bg_info");
	res = PQexec(mconn, query);

	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		printf("no record rs_bg_info\n");
		PQfinish(mconn);
		return -1;
	}

	row_num = PQntuples(res);

	for (i = 0; i < row_num; i++)
	{
		memset(RecSeeBG[i].BG_CODE, 0x00, sizeof RecSeeBG[i].BG_CODE);
		memset(RecSeeBG[i].BG_NAME, 0x00, sizeof RecSeeBG[i].BG_NAME);
		sprintf(RecSeeBG[i].BG_CODE,"%s", PQgetvalue(res, i, 0));
		sprintf(RecSeeBG[i].BG_NAME,"%s", PQgetvalue(res, i, 1));
	}
	PQclear(res);
	
	TOTAL_BG = i;

	memset(query,0,sizeof query);
	sprintf(query, "SELECT r_bg_code, r_mg_code, r_mg_name FROM rs_mg_info");	
	res = PQexec(mconn, query);

	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		printf("no record rs_mg_info\n");
		PQfinish(mconn);
		return -1;
	}

	row_num = PQntuples(res);
	for (i = 0; i < row_num; i++)
	{
		memset(RecSeeMG[i].BG_CODE, 0x00, sizeof RecSeeMG[i].BG_CODE);
		memset(RecSeeMG[i].MG_CODE, 0x00, sizeof RecSeeMG[i].MG_CODE);
		memset(RecSeeMG[i].MG_NAME, 0x00, sizeof RecSeeMG[i].MG_NAME);
		sprintf(RecSeeMG[i].BG_CODE,"%s", PQgetvalue(res, i, 0));
		sprintf(RecSeeMG[i].MG_CODE,"%s", PQgetvalue(res, i, 1));
		sprintf(RecSeeMG[i].MG_NAME,"%s", PQgetvalue(res, i, 2));
	}
	PQclear(res);
	TOTAL_MG = i;
	
	
memset(query,0,sizeof query);
	sprintf(query, "SELECT r_bg_code, r_mg_code, r_sg_code, r_sg_name FROM rs_sg_info");	
	res = PQexec(mconn, query);

	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		printf("no record rs_sg_info\n");
		PQfinish(mconn);
		return -1;
	}

	row_num = PQntuples(res);
	for (i = 0; i < row_num; i++)
	{
		memset(RecSeeSG[i].BG_CODE, 0x00, sizeof RecSeeSG[i].BG_CODE);
		memset(RecSeeSG[i].MG_CODE, 0x00, sizeof RecSeeSG[i].MG_CODE);
		memset(RecSeeSG[i].SG_CODE, 0x00, sizeof RecSeeSG[i].SG_CODE);
		memset(RecSeeSG[i].SG_NAME, 0x00, sizeof RecSeeSG[i].SG_NAME);
		sprintf(RecSeeSG[i].BG_CODE,"%s", PQgetvalue(res, i, 0));
		sprintf(RecSeeSG[i].MG_CODE,"%s", PQgetvalue(res, i, 1));
		sprintf(RecSeeSG[i].SG_CODE,"%s", PQgetvalue(res, i, 2));
		sprintf(RecSeeSG[i].SG_NAME,"%s", PQgetvalue(res, i, 3));
	}
	PQclear(res);
	TOTAL_SG = i;

	
	memset(query,0,sizeof query);
	sprintf(query , "SELECT r_user_id, r_user_name,r_bg_code, r_mg_code,r_sg_code, coalesce(r_ext_no,' ') AS r_ext_no,coalesce(r_emp_id,' ') AS r_emp_id, coalesce(r_cti_id, ' ') AS r_cti_id FROM rs_ruser_info"); 

	res = PQexec(mconn, query);

	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		printf("no record rs_ruser_info\n");
		PQfinish(mconn);
		return -1;
	}

	row_num = PQntuples(res);
	for (i = 0; i < row_num; i++)
	{
		memset(RecSeeUSER[i].USER_ID, 0x00, sizeof RecSeeUSER[i].USER_ID);
		memset(RecSeeUSER[i].USER_NAME, 0x00, sizeof RecSeeUSER[i].USER_NAME);
		memset(RecSeeUSER[i].BG_CODE, 0x00, sizeof RecSeeUSER[i].BG_CODE);
		memset(RecSeeUSER[i].MG_CODE, 0x00, sizeof RecSeeUSER[i].MG_CODE);
		memset(RecSeeUSER[i].SG_CODE, 0x00, sizeof RecSeeUSER[i].SG_CODE);
		memset(RecSeeUSER[i].EXT_NO, 0x00, sizeof RecSeeUSER[i].EXT_NO);
		memset(RecSeeUSER[i].EMP_ID, 0x00, sizeof RecSeeUSER[i].EMP_ID);
		memset(RecSeeUSER[i].BG_NAME, 0x00, sizeof RecSeeUSER[i].BG_NAME);
		memset(RecSeeUSER[i].MG_NAME, 0x00, sizeof RecSeeUSER[i].MG_NAME);
		memset(RecSeeUSER[i].SG_NAME, 0x00, sizeof RecSeeUSER[i].SG_NAME);
		memset(RecSeeUSER[i].REC_KIND, 0x00, sizeof RecSeeUSER[i].REC_KIND);
		memset(RecSeeUSER[i].CTI_ID, 0x00, sizeof RecSeeUSER[i].CTI_ID);


		sprintf(RecSeeUSER[i].USER_ID,"%s", PQgetvalue(res, i, 0));
		sprintf(RecSeeUSER[i].USER_NAME,"%s", PQgetvalue(res, i, 1));
		sprintf(RecSeeUSER[i].BG_CODE,"%s",  PQgetvalue(res, i, 2));
		
		FindBGCode(RecSeeUSER[i].BG_CODE, i);
		
		sprintf(RecSeeUSER[i].MG_CODE,"%s",  PQgetvalue(res, i, 3));
			
		FindMGCode(RecSeeUSER[i].BG_CODE,RecSeeUSER[i].MG_CODE, i);
			
		sprintf(RecSeeUSER[i].SG_CODE,"%s",  PQgetvalue(res, i, 4));
		
		FindSGCode(RecSeeUSER[i].BG_CODE,RecSeeUSER[i].MG_CODE,RecSeeUSER[i].SG_CODE, i);

		sprintf(RecSeeUSER[i].EXT_NO,"%s",  PQgetvalue(res, i, 5));
		sprintf(RecSeeUSER[i].EMP_ID,"%s",  PQgetvalue(res, i, 6));			
		sprintf(RecSeeUSER[i].CTI_ID,"%s",  PQgetvalue(res, i, 7));		
	}

	PQclear(res);	
	PQfinish(mconn);

	TOTAL_USER = i;

	return 1;
}

int FindBGCode(char *Code, int Index)
{
	for(int i =0; i < TOTAL_BG; i ++)
	{
		if(strcmp(Code,RecSeeBG[i].BG_CODE)==0)
		{
			memset(RecSeeUSER[Index].BG_NAME,0x00,sizeof RecSeeUSER[Index].BG_NAME);
			sprintf(RecSeeUSER[Index].BG_NAME,"%s",RecSeeBG[i].BG_NAME);
			return 1;
		}
	}
	sprintf(RecSeeUSER[Index].BG_NAME,"%s","");
	return 0;
}

int FindMGCode(char *Code1, char *Code2 ,int Index)
{
//	int j;
	for(int i =0; i < TOTAL_MG; i ++)
	{
		if(strcmp(Code1,RecSeeMG[i].BG_CODE)==0)
		{
			if(strcmp(Code2,RecSeeMG[i].MG_CODE)==0)
			{
				memset(RecSeeUSER[Index].MG_NAME,0x00,sizeof RecSeeUSER[Index].MG_NAME);
				sprintf(RecSeeUSER[Index].MG_NAME,"%s",RecSeeMG[i].MG_NAME);
				return 1;
			}
		}
	}

	memset(RecSeeUSER[Index].MG_NAME,0x00,sizeof RecSeeUSER[Index].MG_NAME);
	memset(RecSeeUSER[Index].SG_NAME,0x00,sizeof RecSeeUSER[Index].SG_NAME);

	return 0;
}

int FindSGCode(char *Code1, char *Code2, char *Code3, int Index)
{
//	int j;
	for(int i =0; i < TOTAL_SG; i ++)
	{
		if(strcmp(Code1,RecSeeSG[i].BG_CODE)==0)
		{
			if(strcmp(Code2,RecSeeSG[i].MG_CODE)==0)
			{
				if(strcmp(Code3,RecSeeSG[i].SG_CODE)==0)
				{
				memset(RecSeeUSER[Index].SG_NAME,0x00,sizeof RecSeeUSER[Index].SG_NAME);
				sprintf(RecSeeUSER[Index].SG_NAME,"%s",RecSeeSG[i].SG_NAME);
				return 1;
				}
			}
		}
	}
	memset(RecSeeUSER[Index].SG_NAME,0x00,sizeof RecSeeUSER[Index].SG_NAME);
	return 0;
}


int MatchingChannelInfo()
{
	int i,j;
	int EXTNUM;

	for(i=1; i< TOTAL_LINE; i++)
	{
		for(j=0; j<TOTAL_USER; j++)
		{
			if(strcmp(RecSeeCH[i].EXT_NUM,RecSeeUSER[j].EXT_NO)==0 && strlen(RecSeeUSER[j].EXT_NO)>0)
			{			
				EXTNUM =atoi(RecSeeCH[i].EXT_NUM);

				sprintf(RecSeeCH[i].USER_NAME,"%s",RecSeeUSER[j].USER_NAME);
				sprintf(RecSeeCH[i].USER_ID,"%s", RecSeeUSER[j].USER_ID);
				sprintf(RecSeeCH[i].BG_CODE,"%s", RecSeeUSER[j].BG_CODE);
				sprintf(RecSeeCH[i].MG_CODE,"%s", RecSeeUSER[j].MG_CODE);
				sprintf(RecSeeCH[i].SG_CODE,"%s", RecSeeUSER[j].SG_CODE);
				sprintf(RecSeeCH[i].BG_NAME,"%s", RecSeeUSER[j].BG_NAME);
				sprintf(RecSeeCH[i].MG_NAME,"%s", RecSeeUSER[j].MG_NAME);
				sprintf(RecSeeCH[i].SG_NAME,"%s", RecSeeUSER[j].SG_NAME);
				sprintf(RecSeeCH[i].REC_KIND, "%s", RecSeeUSER[j].REC_KIND);

				break;
			}	
		}
	}

	return 1;
}


/*
 * Called each time a packet arrives.
 * Stores incoming SIP messages in list.
 * Searches and present statistics on outgoing packets
 */



Node *createNode(message_entry item) 
{

	
	 Node *newNode = NULL;

	
	 newNode = (Node *) malloc(sizeof(Node));
	
	 newNode->element = item;
	
	 newNode->next = NULL;
	
	 newNode->prev = NULL;

	
	 return newNode;

}


	 
Node *insertNodeTail(Node *head, message_entry item) {

	
	Node *newNode = NULL, *runNode = head;
	
	newNode = createNode(item);

	
	if (head == NULL)
 return newNode;

	
	while (runNode->next != NULL)
		
		runNode = runNode->next;

	
		runNode->next = newNode;
	
		newNode->prev = runNode;
	
		return head;

}
		


Node *deleteNode(Node *head, message_entry item, message_entry * found) 
{

	
	Node *runNode = head;

	
	while (runNode != NULL && runNode->element.phone_number
	!= item.phone_number) 
	{
		
		if ((item.ts.tv_sec - runNode->element.ts.tv_sec) > MAX_MESSAGE_AGE) {
			
			Node * temp = runNode;
			
			if (temp->prev == NULL) // we're in head
			
			{ 
				//delete head node
				
				if (temp->next != NULL) { 
					//check if not last in list
					
					head = head->next;
					
					head->prev = NULL;
				
				} else {

					head = NULL;
				
				}
			
			} else {
				
				temp->prev->next = temp->next;
				
				if (temp->next != NULL)
					
						temp->next->prev = temp->prev;
			
				}

			
				//                          
				printf("deleting OLD entry: %u\n",runNode->element.phone_number);
			
				runNode = runNode->next;
			
				free(temp);
			
				deleted_old++;
		
			} else {
			
				runNode = runNode->next;
		
			}
	
		}

	
		if (runNode == NULL) {
		
			//        
			printf("data not found [%d]\n",item.phone_number);
	
		} else {
		
			//    	
			memcpy ( found, &runNode->element, sizeof(Entry));
		
			found->phone_number = runNode->element.phone_number;
		
			found->ts.tv_sec = runNode->element.ts.tv_sec;
		
			found->ts.tv_usec = runNode->element.ts.tv_usec;

		
			if (runNode->prev == NULL) 
				// we're in head
		
			{ 
				//delete head node
			
				if (runNode->next != NULL) { 
					//check if not last in list
				
					head = head->next;
				
					head->prev = NULL;
			
				} else {
				
					head = NULL;
			
				}
		
			} else {
			
				runNode->prev->next = runNode->next;
			
				if (runNode->next != NULL)
				
						runNode->next->prev = runNode->prev;
		
				}
		
				free(runNode);
	
			}
	
	return head;

}
/*
 * Shows all Nodes in a list (for Debug)
 */

						
void displayNode(Node *head) {
	Node *runNode = head;

	while (runNode != NULL) {
		
		printf("[%u]->", runNode->element.phone_number);
		
		runNode = runNode->next;
	}
	
	printf("NULL\n");
}


int GetResource() 
{
	string Query;
	char QuerySQL[1000];
	char QuerySQL1[100];
	char QuerySQL2[1000];
	long numPages, pageSize, freePages, totalSize, totalUsed, totalFree;
	float mem=0;
	float cpu=0;
	int	hdd=0;
	time_t t;
	struct tm *tm;
	struct timeval mytime;
	char currDate[10];
	char currTime[10];
	struct statvfs vfs;

	numPages = sysconf(_SC_PHYS_PAGES)/1024;
	
	pageSize = sysconf(_SC_PAGESIZE)/1024;
	
	freePages = sysconf(_SC_AVPHYS_PAGES)/1024;	
	
	totalSize = numPages * pageSize;
	
	totalFree = pageSize * freePages;
	
	totalUsed = totalSize - totalFree;

	printf("total memory = %u MB\n", totalSize);
	
	printf("free memory = %u MB\n", totalFree);
	
	printf("used memory = %u MB\n", totalUsed);

	get_sys_status(&cpu, &mem);
	sleep(1);
	get_sys_status(&cpu, &mem);

	printf("cpu usage : %2.0f\n", cpu);

    if (statvfs("/", &vfs) < 0) return -1;
	
	printf("Block size: %lu\n", vfs.f_bsize);
   printf("Total blocks: %lu (%llu Bytes)\n", vfs.f_blocks, (unsigned long long) vfs.f_bsize * vfs.f_blocks);

	cout << "Total: " << vfs.f_bsize * vfs.f_blocks / div4giga  << endl;
    cout << "Free: " << vfs.f_bsize * vfs.f_bavail / div4giga  << endl;
    cout << "Used: " << vfs.f_bsize * (vfs.f_blocks-vfs.f_bavail) / div4giga << endl;
	
	hdd = (int)(vfs.f_bsize * (vfs.f_blocks-vfs.f_bavail) / div4giga)*100 / (int)(vfs.f_bsize * vfs.f_blocks / div4giga);
    printf("HDD USED: %d %\n", hdd);

	time(&t);
	tm=localtime(&t);
    gettimeofday(&mytime, NULL);
  	
	memset(currDate,0,sizeof currDate);
	memset(currTime,0,sizeof currTime);
	sprintf(currDate,"%04d%02d%02d", tm->tm_year+1900,tm->tm_mon+1,tm->tm_mday);
	sprintf(currTime,"%02d%02d%02d",tm->tm_hour,tm->tm_min,tm->tm_sec );

	memset(QuerySQL2, 0x00, sizeof QuerySQL2);
	Query="INSERT INTO rs_sys_monitoring(";
	Query = Query + "r_sys_id, r_sys_name, r_sys_date, r_sys_time, r_hdd_use, ";
	Query = Query + "r_memory_size, r_memory_free, r_memory_used, r_cpu_used) ";
	sprintf(QuerySQL1,"%s",(char*)Query.c_str()); 
	sprintf(QuerySQL2,"VALUES('%s','%s','%s','%s','%d','%u','%u','%u','%2.0f')",
			"IPCR",
			"IPCR",
			currDate,
			currTime,
			hdd,
			totalSize,
			totalFree,
			totalUsed,
			cpu);

	QueueWriteRead(1, QuerySQL);	

	return 0;	

}


void got_packet(u_char *args, const struct pcap_pkthdr *header,
		const u_char *packet) {

	static int count = 1; /* packet counter */
	/* define pointers to packet headers */
	const struct ether_header *ethernet; /* ethernet header */
	const struct ip *ip; /* IP header */
	const struct tcphdr *tcp; /* TCP header */
	const struct icmphdr *icmp; /* UDP header */
	const struct udphdr *udp;
	const char *payload; /* payload */
	char rtp_ip[20];
	u_int16_t latency = 0;
	int srcPort;
	int desPort;
	int chdev;
	char destination_ip[20];
	char source_ip[20];

	const char * STR_INVITE = "INVITE sip";
	const char * STR_180 = "SIP/2.0 180 Ringing";
	const char * STR_OK = "SIP/2.0 200 OK";
	const char * STR_ACK = "ACK sip";
	const char * STR_BYE = "BYE sip";
	const char * STR_SIP = "SIP/2.0";
	const char * STR_CANCEL = "CANCEL sip";

	message_entry sip_message;
	message_entry sip_matched;
	sip_matched.phone_number = 0;
	sip_matched.ts.tv_sec = 0;
	sip_matched.ts.tv_usec = 0;

	/* ethernet headers are always exactly 14 bytes */
	int size_ethernet = 14;
	int size_ip;
	int size_tcp;
	int size_payload;
	char SPLIT1[50][30];
	char *CHECK1;
	char SPLIT2[50][30];
	char *CHECK2;
	int j;
	char tmpip[20];

	//printf("\nPacket number %d:\n", count);
	count++;
	/* define ethernet header */
	ethernet = (struct ether_header*) (packet);

	/* define/compute ip header offset */
	ip = (struct ip*) (packet + size_ethernet);
	size_ip = ip->ip_hl * 4;

	if (size_ip < 20) {
		printf(" * Invalid IP header length: %u bytes\n", size_ip);
		return;
	}

	/* print source and destination IP addresses */
	memset(rtp_ip,0,sizeof rtp_ip);

	sprintf(destination_ip, "%s", inet_ntoa(ip->ip_dst));
	
	sprintf(source_ip, "%s", inet_ntoa(ip->ip_src));

	/*
	memset(SPLIT1,0,sizeof SPLIT1);
	memset(tmpip,0,sizeof tmpip);
	
	sprintf(tmpip, source_ip);
	
	
	CHECK1 = strtok( tmpip, "." );
	for ( j=0 ; j<10; j++, CHECK1 = strtok( NULL, "." ))
	{
		if(CHECK1!=NULL){
			
			sprintf(SPLIT1[j],(char*)CHECK1);
		}else{
			break;
		}
	}

	memset(tmpip,0,sizeof tmpip);
	
	sprintf(tmpip, destination_ip);
	memset(SPLIT2,0,sizeof SPLIT2);
	CHECK2 = strtok( tmpip, "." );
	for ( j=0 ; j<10; j++, CHECK2 = strtok( NULL, "." ))
	{
		if(CHECK2!=NULL){
			sprintf(SPLIT2[j],(char*)CHECK2);
		}else{
			break;
		}
	}

	if(atoi(SPLIT1[3])==255||atoi(SPLIT2[3])==255)return ;
	chdev = FURENCE_DC[atoi(SPLIT1[2])][atoi(SPLIT1[3])];

	if(chdev==0) 
	{	
		chdev=FURENCE_DC[atoi(SPLIT2[2])][atoi(SPLIT2[3])];
		//sprintf(rtp_ip, destination_ip);
	}
	else
	{
		//sprintf(rtp_ip,source_ip);
	}	

	if (chdev<1 || chdev > 600) {
		return;
	}

	*/

	if(ip->ip_p==IPPROTO_TCP||ip->ip_p==IPPROTO_UDP)
	{
		//udp = (struct udp *)(packet + ip->ip_hl * 4);
		udp = (struct udphdr*) (packet + size_ethernet + size_ip);
		srcPort = ntohs(udp->source);
		desPort = ntohs(udp->dest);
	//printf("ch=%d[%d:%d]",chdev,srcPort,desPort);	
		//if ((srcPort!=5060)(desPort!=5060)) {
			chdev = FindChannelByPortNo(srcPort);
			if (chdev<0){
				chdev = FindChannelByPortNo(desPort);
			}

			if (chdev<0) return;
		//}


		payload = (const char*) (packet + sizeof(struct ether_header)
						+ sizeof(struct ip) + sizeof(struct udphdr));
		size_payload = ntohs(ip->ip_len) - (size_ip + sizeof(struct udphdr));

		char * searched_buffer = (char *) malloc(size_payload);
		//strncpy(searched_buffer, (char*)payload, size_payload);
		memcpy(searched_buffer,&payload[0],size_payload);
//printf("%x %x %x %x %x %x\n", searched_buffer[0], searched_buffer[1], searched_buffer[2],searched_buffer[56], searched_buffer[21], searched_buffer[0]);

		RecSee_RtpPacketSIP(chdev,searched_buffer,size_payload,source_ip);
		
	}else{ 
		return;
	}
	
	
	/*
	switch (ip->ip_p) {
	case IPPROTO_TCP:
		tcp = (struct tcphdr*) (packet + size_ethernet + size_ip);
		size_tcp = tcp->doff * 4;

		if (size_tcp < 20) {
			printf(" * Invalid TCP header length: %u bytes\n", size_tcp);
			return;
		}

		payload = (u_char *) (packet + size_ethernet + size_ip + size_tcp);

		size_payload = ntohs(ip->ip_len) - (size_ip + size_tcp);

		//sip_print(payload, size_payload);

		break;
	case IPPROTO_UDP: //case UDP

		udp = (struct udphdr*) (packet + size_ethernet + size_ip);
		payload = (const char*) (packet + sizeof(struct ether_header)
				+ sizeof(struct ip) + sizeof(struct udphdr));
		size_payload = ntohs(ip->ip_len) - (size_ip + sizeof(struct udphdr));

		char * searched_buffer = (char *) malloc(size_payload);
		strncpy(searched_buffer, payload, size_payload);

		
		if (strstr(searched_buffer, STR_INVITE) != 0) { //if message is INVITE
			sip_message = get_data_entry_from_message(searched_buffer,
					header, SIP_INVITE, size_payload);
			incoming_inv_messages = insertNodeTail( //add to invite list
					incoming_inv_messages, sip_message);
		} else if (strstr(searched_buffer, STR_OK) != 0) { //if message is 200 OK
			sip_message = get_data_entry_from_message(searched_buffer,
					header, SIP_OK, size_payload);
			incoming_200_messages = insertNodeTail( //add to 200 list
					incoming_200_messages, sip_message);
		} else if ((strstr(searched_buffer, STR_BYE) != 0) || (strstr(searched_buffer, STR_CANCEL) != 0)) { //if message is BYE
			sip_message = get_data_entry_from_message(searched_buffer,
					header, SIP_OK, size_payload);
			
			//sip_message.phone_number

		    Cphonebuf = getPhoneNo(getHeader(Oristr, "To"));
			if (Cphonebuf=="")
				Cphonebuf = getPhoneNo(getHeader(Oristr, "to"));
			if (Cphonebuf=="")
				Cphonebuf = getPhoneNo(getHeader(Oristr, "t"));
			Cphonebuf1 = getPhoneNo(getHeader(Oristr, "From"));
			if (Cphonebuf1=="")
				Cphonebuf1 = getPhoneNo(getHeader(Oristr, "from"));
			if (Cphonebuf1=="")
				Cphonebuf1 = getPhoneNo(getHeader(Oristr, "f"));

			Chdev = FindChannelByDN((char *)(const char *)Cphonebuf);
			if (Chdev<0) Chdev = FindChannelByDN((char *)(const char *)Cphonebuf1);

			if(Chdev<0) return;

			if (RecSeeCH[Chdev].R_SIG==0) return;

			RecSee_New_Record_Stop(Chdev);	

			RecSeeCH[Chdev].SIGNAL_END = 0;

			str.Format("SIP Record Stop[%d]",Chdev);

			LOG_EVENT3(str);
////////////
			sip_message = get_data_entry_from_message(searched_buffer,
					header, SIP_BYE, size_payload);
			incoming_bye_messages = insertNodeTail( //add to bye list
					incoming_bye_messages, sip_message);
		}
		*/



		/*
		if (strstr(searched_buffer, STR_SIP) != 0) { //if message is SIP
			// incoming messages
			if (strstr(inet_ntoa(ip->ip_dst), imsg_prefix) != 0) {
				if (strstr(searched_buffer, STR_INVITE) != 0) { //if message is INVITE
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_INVITE, size_payload);
					incoming_inv_messages = insertNodeTail( //add to invite list
							incoming_inv_messages, sip_message);

				} else if (strstr(searched_buffer, STR_180) != 0) { //if message is 180 Ringing
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_ONE_EIGHTY, size_payload);
					incoming_180_messages = insertNodeTail( //add to 180 list
							incoming_180_messages, sip_message);
				} else if (strstr(searched_buffer, STR_OK) != 0) { //if message is 200 OK
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_OK, size_payload);
					incoming_200_messages = insertNodeTail( //add to 200 list
							incoming_200_messages, sip_message);
				} else if (strstr(searched_buffer, STR_ACK) != 0) { //if message is ACK
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_ACK, size_payload);
					incoming_ack_messages = insertNodeTail( //add to ack list
							incoming_ack_messages, sip_message);
				} else if (strstr(searched_buffer, STR_BYE) != 0) { //if message is BYE
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_BYE, size_payload);
					incoming_bye_messages = insertNodeTail( //add to bye list
							incoming_bye_messages, sip_message);
				}
			}
			// outgoing messages
			else if (strstr(inet_ntoa(ip->ip_src), imsg_prefix) != 0) {
				if (strstr(searched_buffer, STR_INVITE) != 0) { //if message is INVITE
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_INVITE, size_payload);
					incoming_inv_messages = deleteNode(incoming_inv_messages,
							sip_message, &sip_matched); // search outgoing message in incomign list
					if (sip_matched.phone_number != 0) { //if found increase number of messages and calculate latency
						total_num_inv++;
						latency = calculate_latency(&sip_matched, &sip_message);
						message_latency_histogram(latency, SIP_INVITE); //add latency information to statistics
					}
				} else if (strstr(searched_buffer, STR_180) != 0) { //if message is 180 Ringing
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_ONE_EIGHTY, size_payload);
					incoming_180_messages = deleteNode(incoming_180_messages,
							sip_message, &sip_matched);
					if (sip_matched.phone_number != 0) {
						total_num_180++;
						latency = calculate_latency(&sip_matched, &sip_message);
						message_latency_histogram(latency, SIP_ONE_EIGHTY);
					}
				} else if (strstr(searched_buffer, STR_OK) != 0) { //if message is 200 OK
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_OK, size_payload);
					incoming_200_messages = deleteNode(incoming_200_messages,
							sip_message, &sip_matched);
					if (sip_matched.phone_number != 0) {
						total_num_200++;
						latency = calculate_latency(&sip_matched, &sip_message);
						message_latency_histogram(latency, SIP_OK);
					}
				} else if (strstr(searched_buffer, STR_ACK) != 0) { //if message is ACK
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_ACK, size_payload);
					incoming_ack_messages = deleteNode(incoming_ack_messages,
							sip_message, &sip_matched);
					if (sip_matched.phone_number != 0) {
						total_num_ack++;
						latency = calculate_latency(&sip_matched, &sip_message);
						message_latency_histogram(latency, SIP_ACK);
					}
				} else if (strstr(searched_buffer, STR_BYE) != 0) { //if message is BYE
					sip_message = get_data_entry_from_message(searched_buffer,
							header, SIP_BYE, size_payload);
					incoming_bye_messages = deleteNode(incoming_bye_messages,
							sip_message, &sip_matched);
					if (sip_matched.phone_number != 0) {
						total_num_bye++;
						latency = calculate_latency(&sip_matched, &sip_message);
						message_latency_histogram(latency, SIP_BYE);
					}
				}

			}
			if (offline == FALSE) {
				time_t temp_time = time(NULL);
				if ((temp_time - current_time) > SCREEN_REFRESH) { //Refreshing the screen each X seconds
					system("clear");
					print_latency_stats();
					current_time = temp_time;
				}
			}
		} else {
			//printf("This message is no SIP\n");
			//sip_print(payload, ntohs(udp->len));
		}
		free(searched_buffer);
		break;
	}
	*/

	return;
}

void RecSee_SignalPacketLG(int chdev,char *bufx,int caplen,int len)
{

	
	char *buf;
	
	unsigned short    taport_number=0; //h245 port
	
	unsigned short    xaport_number=0; //h245 port
	
	unsigned long ulBytesReceived;
	
	unsigned char he[2048];

	
	int offt=0;
	
	int all=0;
	
	int con_port=0;

	
	int add=0;
	
	int real;
	
	int hdd=1;
	
	int pcnt=0;
	
	unsigned int off=0;

	
	char PHONENUM[256];
	
	
	char  *pSource , *pDest ;
	
	char *data;
	
	
	struct in_addr ina ;
	
	char   szSource [30];// , szDest[30] ;//, szErr [ 50 ];
	
	int q931=0;
	
	int kbo=0;
	
	int h245=0;
	
	int rtp_data_len=0;


	
	ulBytesReceived = caplen;
	
	if(ulBytesReceived==0) return;
	
	buf=bufx;

	
	off=20;


	//UpIpHeader = (UIPHEADER *)(buf+14);
	//real=ntohs(UpIpHeader->real_ren)-8;
	
	real = caplen-42;
	
	
	rtp_data_len=real-12;
	
	data=(char*)(buf+42);
	//off+14+8+off+add);
	
	memset(he,0,sizeof he);
	
	memcpy( he , data ,real) ;
	
	con_port=chdev;
	
	
	memcpy( he , &data[6] ,real-6) ;
		
	
	unsigned char *iPECS;
	
	iPECS=he+14;

	
	char CID[10];
	
	char Slot[10];
	
	char Protocol[10];
	
	char Cmd[10];
	
	char Length[10];
	
	short Isize=0;
	
	char sss[1024];
	
	char ANI[100];
	
	char ANN[100];
	
	int inc=0;
	
	int chk;
	
	
	
	con_port=chdev;

	
	memset(sss,0,sizeof sss);

	
	memcpy(&sss[0],iPECS,rtp_data_len);

	
	int total_len=0;
	
	int sum_len=0;
	
	int kkk=9;

	
	total_len=sss[7]*256+sss[8];
		
	
	memset(CID,0,sizeof  CID);
	
	memset(Slot,0,sizeof Slot);
	
	memset(Protocol,0,sizeof Protocol);
	
	memset(Cmd,0,sizeof Cmd);
	
	memset(Length,0,sizeof Length);
	
	memcpy(Slot,&iPECS[4],1);
	
	memcpy(Protocol,&iPECS[5],1);
	
	memcpy(Cmd,&iPECS[6],1);

	

	unsigned char START_HEXA[3]={0x1f,0x43,0x1a};

	
	unsigned char END_HEXA[2]={0x02,0x04};

	
	unsigned char STL_START_HEXA[4]={0x01,0x19,0x01,0x19};

	
	unsigned char STL_END_HEXA[3]={0x70,0x1f,0x00};

	
	int chk_num;
	
		
	
	//End Option
	
	chk_num=HexaFind(rtp_data_len,(unsigned char *)iPECS ,2,(unsigned char *)END_HEXA);

	
	if(chk_num>0)
	{
		
		printf("Start : CH: %d / %s\n", chdev, pDest);
		
		RecSee_New_Record_Start(chdev);		
		
		//LOG_EVENT3(str);

		
		return;
	
	}

	
	//STL Start
	
	chk_num=HexaFind(rtp_data_len,(unsigned char *)iPECS ,4,(unsigned char *)STL_START_HEXA);

	
	if(chk_num>0)
	{
		
		printf("STL Start : CH: %d / %s\n", chdev, pDest);
		
		RecSee_New_Record_Start(chdev);
		
		//LOG_EVENT3(str);

		
		memset(RecSeeCH[chdev].CALL_KIND1,0x00,sizeof RecSeeCH[chdev].CALL_KIND1);
		
		sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","O");
		
		
		return ;
	
	}

	
	//STL End Option
	
	chk_num=HexaFind(rtp_data_len,(unsigned char *)iPECS ,3,(unsigned char *)STL_END_HEXA);

	
	if(chk_num>0)
	{
		
		printf("STL END CH: %d  / %s\n", chdev, pDest);
		
		RecSee_New_Record_Stop(chdev);
		
		//LOG_EVENT3(str);
		
		return;
	
	}
		
	
	if(iPECS[53]==0x4f && iPECS[54]==0xb9 && iPECS[55]==0x01)
	{
		
		//OutBound Start
		
		printf("OutBound Start : %02x / %d  - CH: %d\n", he[11], he[11],chdev);
		
		//LOG_EVENT3(str);
		
		RecSee_New_Record_Start(chdev);
	
	}

	
	//Call Number Check	
	
	if(iPECS[53]==0x41 && iPECS[54]==0x0 && iPECS[55]==0x1 && iPECS[56]==0x4f )
	{
		
		memset(PHONENUM,0,sizeof PHONENUM);
		
		
		real = rtp_data_len - 56;
		
		memcpy(PHONENUM,&iPECS[56],real);
		
		//str1.Format("%s",PHONENUM);
		
		//str1.Replace("O","");
		
		//str.Format("CUSTOMER : - %s - CH:", str1 ,chdev);
		
		//LOG_EVENT3(str);
		
	
	}		

	
	//if(iPECS[56]==0x41 && iPECS[57]==0x0 && iPECS[58]==0x1 && iPECS[59]==0x4f )
	
	if(iPECS[17]==0x41 && iPECS[18]==0x0 && iPECS[19]==0x1 && iPECS[20]==0x4f )
	{
		
		memset(PHONENUM,0,sizeof PHONENUM);
			
		
		//real = rtp_data_len - 59;
		
		memcpy(PHONENUM,&iPECS[21],real-41);
		
		//str1.Format("%s",PHONENUM);
		
		//str1.Replace("O","");	
		
		//str.Format("CUSTOMER@ : - %s - CH: %d", str1 ,chdev);
		
		
		memset(ANI,0,sizeof ANI);
		
		memcpy(PHONENUM,&iPECS[21],real-41);
			
		
		for(chk=0;chk<(real-41);chk++)
		
		{
			
			if (PHONENUM[chk]==0x00) break;
			
			if(PHONENUM[chk]>=0x30&&PHONENUM[chk]<=0x39) ANI[inc++]=PHONENUM[chk];
		
		}
		
		printf("PHONE [%s]\n", ANI);
		
		memset(RecSeeCH[chdev].CUST_PHONE1,0,sizeof RecSeeCH[chdev].CUST_PHONE1);
		
		sprintf(RecSeeCH[chdev].CUST_PHONE1,"%s",ANI);
		
		//LOG_EVENT3(str);
		
	
	}

	
	//bc b1 84 20 00 84
	
	
	int ChkLen;
	
	inc=0;
	
	//int chk;
	
	int size;
	
	//char ANN[300];
	
	//char ANI[300];

	
	unsigned char CHKANI_HEXA[6]={0x18,0x4f,0x33,0x00,0x41,0x00};

	
	ChkLen=HexaFind(caplen-54,(unsigned char *)data ,6,(unsigned char *)CHKANI_HEXA);

	
	if(ChkLen>0 && ChkLen<400)
	{
		
		memset(ANN,0,sizeof ANN);
		
		memset(ANI,0,sizeof ANI);
		
		sprintf(ANN,"%s", &data[ChkLen+6]);
		
		size=strlen(ANN);

		
		if(size>100||size==0)return;

		
		for(chk=0;chk<size;chk++)
{
			
			if(ANN[chk]>=0x30&&ANN[chk]<=0x39)ANI[inc++]=ANN[chk];
		
		}
		
		
		
		if(strlen(ANI)>2 &&strlen(ANI)<40)
{
			
			sprintf(RecSeeCH[chdev].CUST_PHONE1,"%s",ANI);
			
			printf("CustPhone : %s\n", ANI);		
			
			//SDlg->SetGridItem(RecSeeCH[chdev].ROWIDX, 3, RecSeeCH[chdev].CUST_PHONE1);
		
			
			inc =0;
		
		}
	
	}

	
	
	unsigned char CHKANI_HEXA2[6]={0xbc,0xb1,0x84,0x20,0x00,0x84};
	
	
	ChkLen=HexaFind(caplen-54,(unsigned char *)data ,6,(unsigned char *)CHKANI_HEXA2);

	
	if(ChkLen>0 && ChkLen<400)
	{
		
		memset(ANN,0,sizeof ANN);
		
		memset(ANI,0,sizeof ANI);
		
		sprintf(ANN,"%s", &data[ChkLen+6]);
		
		size=strlen(ANN);

		
		if(size>100||size==0)return;

		
		for(chk=0;chk<size;chk++)
{
			
			if(ANN[chk]>=0x30&&ANN[chk]<=0x39)ANI[inc++]=ANN[chk];
	
		}
		
		
		if(strlen(ANI)>2 &&strlen(ANI)<40)
{
			
			sprintf(RecSeeCH[chdev].CUST_PHONE1,"%s",ANI);
			
			printf("CustPhone : %s\n", ANI);		
			
			//SDlg->SetGridItem(RecSeeCH[chdev].ROWIDX, 3, RecSeeCH[chdev].CUST_PHONE1);
		
		
			inc =0;
		
		}
	
	}

	
	
	return;

}

/*
void RecSee_SignalPacketSIP(int chdev, char *bufx,int caplen,int len)
{
	char *buf;
	unsigned long ulBytesReceived;
	u_short sport;          
	u_short dport;          
	int real;
	
	char  *pSource , *pDest ;
	char *data;
	struct in_addr ina ;
	char   szSource [30];
	int rtp_data_len=0;
    	char Pstr[13000]; 
	char Ptk[1];
	string Oristr;
	int Descheck;
	char str[200];
	string headerValue;
	string callid;
	int pos;
	//20081021 SIM
	string referid;
	string Cphonebuf;
	string Cphonebuf1;
	char cmd[15];	


	memset(Pstr,0,sizeof Pstr);
	
	ulBytesReceived = caplen;
	if(ulBytesReceived==0) return ;
	buf=bufx;

	data=(char*)(buf+42);
	if(chdev==0)
	{
		return;
	}

	for (int i=1; (i < caplen + 1 ) ; i++)
	{
		memset(Ptk,0x00, sizeof Ptk);
		sprintf(Ptk,"%c", data[i-1]);
		strcat(Pstr,Ptk);
	}

	char *temp_bye = NULL;
	char *temp_cancel = NULL;
	temp_bye = strstr(Pstr, "From:");
	temp_cancel = strstr(Pstr, "<sip:");
	if ((temp_bye == NULL) || (temp_cancel == NULL) ) {
		RecSeeCH[chdev].SIGNAL_END = 0;

		//str.Format("SIP Record Stop[%d]",chdev);
		//LOG_EVENT3(str);

		return;
	}
	
	//Oristr.Format("%s",Pstr);
	Oristr = Pstr;
	
	memset(cmd,0,sizeof cmd);
	memcpy(cmd, &Pstr[0], 6);
	if (strcmp(cmd, "INVITE")==0)
	//if (Oristr.Left(6) == "INVITE")
	if (Oristr.substr(0,6)=="INVITE")	
	{
		headerValue = getHeader(Pstr, "CSeq");
		if (headerValue == "")
			headerValue = getHeader(Pstr, "cseq");
		if (headerValue != "")
		{
			//if (strstr(headerValue, "INVITE") != NULL)
			if (headerValue.find("INVITE",0) != -1)
			{
				// 20090420 sim
				referid = "";
				referid = getHeader(Pstr, "referred-by");
				if (referid != "")
				{
					sprintf(RecSeeCH[chdev].CALL_KIND2,"%s","T");
					memset(RecSeeCH[chdev].CUST_PHONE3,0x00, sizeof RecSeeCH[chdev].CUST_PHONE3);
					Cphonebuf = getPhoneNo((char*)referid.c_str());					
					sprintf(RecSeeCH[chdev].CUST_PHONE3,"%s",Cphonebuf.c_str());
				}
			
				Cphonebuf = getPhoneNo((char*)getHeader(Pstr, "To").c_str());
				if (Cphonebuf=="")
					Cphonebuf = getPhoneNo((char*)getHeader(Pstr, "to").c_str());
				if (Cphonebuf=="")
					Cphonebuf = getPhoneNo((char*)getHeader(Pstr, "t").c_str());
				Cphonebuf1 = getPhoneNo((char*)getHeader(Pstr, "From").c_str());
				if (Cphonebuf1=="")
					Cphonebuf1 = getPhoneNo((char*)getHeader(Pstr, "from").c_str());
				if (Cphonebuf1=="")
					Cphonebuf1 = getPhoneNo((char*)getHeader(Pstr, "f").c_str());

				if (strlen(RecSeeCH[chdev].CALL_KIND1)>0)
				{
					//str.Format("[1]%s[2]%s",Cphonebuf,Cphonebuf1);
					//LOG_EVENT3(str);
					printf("[1]%s[2]%s\n",Cphonebuf,Cphonebuf1);

					if (strcmp(RecSeeCH[chdev].CALL_KIND1,"I")==0)
					{
						return;
					}
					else
					{
						memset(RecSeeCH[chdev].CUST_PHONE3,0x00, sizeof RecSeeCH[chdev].CUST_PHONE3);
						sprintf(RecSeeCH[chdev].CUST_PHONE3,"%s",Cphonebuf.c_str());
						return;
					}
				}

			}
		}
	}
	//else if (Oristr.Left(14) == "SIP/2.0 200 OK")
	else if (Oristr.substr(0,14) == "SIP/2.0 200 OK")
	{
		headerValue = getHeader(Pstr, "CSeq");
		if (headerValue == "")
			headerValue = getHeader(Pstr, "cseq");
		if (headerValue != "")
		{
			if (headerValue.find("INVITE",0) != -1)
			{
				// 1. CALLID ����
				callid = getHeader(Pstr, "Call-ID");
				if (callid == "")
					callid = getHeader(Pstr, "call-id");
				if (callid == "")
					callid = getHeader(Pstr, "i");
				if (callid != "")
				{
					pos = callid.find("@",0);
					if (pos!=-1)
						//callid = callid.Mid(0,pos);
						callid = callid.substr(0,pos);
					//callid.TrimLeft();
					//callid.TrimRight();
					
					memset(RecSeeCH[chdev].CALLID, 0, sizeof(RecSeeCH[chdev].CALLID));
					sprintf(RecSeeCH[chdev].CALLID, "%s",callid.c_str());
					
				}
				
				//Descheck=FURENCE_DC[ih->saddr.byte3][ih->saddr.byte4];
				
				Cphonebuf = getPhoneNo((char*)getHeader(Pstr, "To").c_str());
				if (Cphonebuf=="")
					Cphonebuf = getPhoneNo((char*)getHeader(Pstr, "to").c_str());
				if (Cphonebuf=="")
					Cphonebuf = getPhoneNo((char*)getHeader(Pstr, "t").c_str());
				Cphonebuf1 = getPhoneNo((char*)getHeader(Pstr, "From").c_str());
				if (Cphonebuf1=="")
					Cphonebuf1 = getPhoneNo((char*)getHeader(Pstr, "from").c_str());
				if (Cphonebuf1=="")
					Cphonebuf1 = getPhoneNo((char*)getHeader(Pstr, "f").c_str());
				
				if (strlen(RecSeeCH[chdev].CALL_KIND1)>0)
				{
					if (strcmp(RecSeeCH[chdev].CALL_KIND1,"I")==0)
					{
						return;
					}
				}

				if(Descheck==0){
					//---> �ƿ��ٿ���.
					if(Cphonebuf==Cphonebuf1)
					{
						//str.Format("[X][OUT]Customer Same[%d]",chdev);
						//LOG_EVENT3(str);
						return;
					}
					//LogSave("", Pstr, "OUT_PKT");

					memset(RecSeeCH[chdev].CUST_PHONE1,0x00, sizeof RecSeeCH[chdev].CUST_PHONE1);
					sprintf(RecSeeCH[chdev].CUST_PHONE1,"%s",Cphonebuf.c_str());

					memset(RecSeeCH[chdev].CUST_PHONE2,0x00, sizeof RecSeeCH[chdev].CUST_PHONE2);
					sprintf(RecSeeCH[chdev].CUST_PHONE2,"%s",Cphonebuf1.c_str());

					memset(RecSeeCH[chdev].CALL_KIND1,0x00, sizeof RecSeeCH[chdev].CALL_KIND1);
					if ( (Cphonebuf.length()>0) && (Cphonebuf.length()<5) ) 
						sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","Z");
					else
						sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","O");
				
					if (strlen(RecSeeCH[chdev].CUST_PHONE3) > 0)
					{
						memset(RecSeeCH[chdev].CALL_KIND2,0x00, sizeof RecSeeCH[chdev].CALL_KIND2);
						sprintf(RecSeeCH[chdev].CALL_KIND2,"%s","T");
						//str.Format("[TRANS]Customer Num[%s][%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,RecSeeCH[chdev].CUST_PHONE3,chdev);		
						sprintf(str,"[TRANS]Customer Num[%s][%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,RecSeeCH[chdev].CUST_PHONE3,chdev);		

					}
					else
					{
						//str.Format("[OUT]Customer Num[%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,chdev);	
						sprintf(str,"[OUT]Customer Num[%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,chdev);	
					}

					//LOG_EVENT3(str);
					printf("%s\n",str);

				}else{
					//---> �ιٿ���.
					if(Cphonebuf==Cphonebuf1)
					{
						//str.Format("[X][IN]Customer Same[%d]",chdev);
						sprintf(str, "[X][IN]Customer Same[%d]",chdev);
						//LOG_EVENT3(str);
						printf("%s\n", str);
						return;
					}
					//LogSave("", Pstr, "IN_PKT");

					memset(RecSeeCH[chdev].CUST_PHONE1,0x00, sizeof RecSeeCH[chdev].CUST_PHONE1);
					sprintf(RecSeeCH[chdev].CUST_PHONE1,"%s",Cphonebuf1.c_str());

					memset(RecSeeCH[chdev].CALL_KIND1,0x00, sizeof RecSeeCH[chdev].CALL_KIND1);
					if ( (Cphonebuf1.length()>0) && (Cphonebuf1.length()<5) ) 
						sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","Z");
					else
						sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","I");
					
					memset(RecSeeCH[chdev].CUST_PHONE2,0x00, sizeof RecSeeCH[chdev].CUST_PHONE2);
					sprintf(RecSeeCH[chdev].CUST_PHONE2,"%s",Cphonebuf.c_str());
					//str.Format("[IN]Customer Num[%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,chdev);
					sprintf(str,"[IN]Customer Num[%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,chdev);
					//LOG_EVENT3(str);
					printf("%s\n", str);
				}

				// 2. ���� ����
				if(BROAD_REC_START==1)
				{
					//str.Format("SIP Record Start[%d]",chdev);
					sprintf(str,"SIP Record Start[%d]",chdev);
					RecSee_New_Record_Start(chdev);
				}else{
					//str.Format("[X]SIP Record Start[%d]",chdev);
					sprintf(str,"[X]SIP Record Start[%d]",chdev);
					//return;
				}
				//LOG_EVENT3(str);
				printf("%s\n", str);
			}
		}
	}
	//else if (Oristr.Left(5) == "REFER")
	else if (Oristr.substr(0,5) == "REFER")
	{
		// 1. CALLID ���� �� Ʈ���������̸� ����
		callid = getHeader(Pstr, "Call-ID");
		if (callid=="")
			callid = getHeader(Pstr, "i");
		if (callid != "")
		{
			pos = callid.find("@",0);
			if (pos!=-1)
				//callid = callid.Mid(0,pos);
				callid = callid.substr(0,pos);
			//callid.TrimLeft();
			//callid.TrimRight();
			
			if (strcmp(RecSeeCH[chdev].CALLID, callid.c_str())==0)
			{
				string Cphonebuf;
								
				Cphonebuf = getPhoneNo((char*)getHeader(Pstr, "Refer-To").c_str());
			
				//LogSave("", Pstr, "TR_PKT");

				memset(RecSeeCH[chdev].CUST_PHONE3,0x00, sizeof RecSeeCH[chdev].CUST_PHONE3);
				sprintf(RecSeeCH[chdev].CUST_PHONE3,"%s",Cphonebuf.c_str());
				
				//str.Format("[TRANS]Customer Num[%s][%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,RecSeeCH[chdev].CUST_PHONE3,chdev);
				printf("[TRANS]Customer Num[%s][%s][%s][%d]",RecSeeCH[chdev].CUST_PHONE1,RecSeeCH[chdev].CUST_PHONE2,RecSeeCH[chdev].CUST_PHONE3,chdev);
				//LOG_EVENT3(str);
			}
		}
	}

	return ;
}
*/

void printBlockOfLength(unsigned char *b, int len) {
	int i;
  
	for (i=0; i<len; i++, b++) {
		printf("%02x", *b);
		if (i%4==3 && i<len-1) printf(" ");
	}
}

void printBlock(unsigned char *b) {
  printBlockOfLength(b, 16);
}


void RecSee_RtpPacketSIP(int chdev,char *bufx,int caplen,char *ip)
{
	char *buf;
	unsigned short    taport_number=0; 
	unsigned short    xaport_number=0; 
	unsigned long ulBytesReceived;
	unsigned char he[200];
	int CODEC_TYPE;	
	int Pay_load_type=0;
	int Pay_load_marker=0;
	u_short sport;          // Source port
	u_short dport;          // Destination port
	int offt=0;
	int add=0;
	int real;
	int hdd=1;
	int pcnt=0;
	u_int off=0;
	char  *pSource , *pDest ;
	char *data;
	char *pUdp;
	struct in_addr ina ;
	char   szSource [30];
	int rtp_data_len=0;
	int current_term;
	string str;
	// 20090719 sim
	char SendStr[100];
	int	ssize=0;
	int inputSize;
  	unsigned char mk[ENC_ARIA_KEY_BITS / 8];
	//EVRB_SESSION*	sion = 0;
	int		cipherMode;
	int		i;
	int octets_recvd;
    err_status_t stat;
	srtp_hdr_t *sheader;

	char skey[100];
 
	if(chdev<=0){return;}

	ulBytesReceived = caplen;
	
	if(ulBytesReceived==0) return ;
	buf=bufx;

	real = caplen-42;
	rtp_data_len=caplen-12;
	
	data = (char*)buf;
	//if(rtp_data_len!=160){ return ; }
	if(rFileChk[chdev]==0){	return;	}
	
	memset(he,0,sizeof he);
	memcpy( he , data , real) ;

	if(he[0]==0x80)
	{
			Pay_load_type=he[1]&0x7f;							
			Pay_load_marker=he[1]&0x80;	
			
			CODEC_TYPE=he[1]&0x7f;							
			
			RECSEE_CH[chdev].CODEC_TYPE=CODEC_TYPE;
			RECSEE_CH[chdev].SIG_CHK =1;

			if ((CODEC_TYPE!=0) && (CODEC_TYPE!=8)) //G.279 Processing
			{
				return ;
			}

			//printf("SRTP YN = %d",RecSeeCH[chdev].SRTP_YN);
			// srtp
			if (RecSeeCH[chdev].SRTP_YN==1)
			{
				
				if (ch_srtp_ctx[chdev].srtp_ctx == NULL)
				{
					return;
				}
				

				memcpy(&ch_srtp_ctx[chdev].message, data, real);

				sheader = (srtp_hdr_t*)malloc(sizeof (srtp_hdr_t));

				stat = srtp_unprotect(ch_srtp_ctx[chdev].srtp_ctx,
							&ch_srtp_ctx[chdev].message.header, &octets_recvd);
				  if (stat) {
					fprintf(stderr,
						"error: srtp unprotection failed with code %d%s\n", stat,
						stat == err_status_replay_fail ? " (replay check failed)" :
						stat == err_status_auth_fail ? " (auth check failed)" : "");
					return;
				  }
				  pUdp = (char*)malloc(sizeof octets_recvd);
				  strncpy(pUdp, ch_srtp_ctx[chdev].message.body, octets_recvd);
				/*
				i = evrb_decrypt(RecSeeCH[chdev].sion->distant.crypto,(char*)data,rtp_data_len+12);
	
				if (i != 0)
				{
					fprintf(stdout,"---sVoIP_RTP_bad_recv--\n");fflush(stdout);
				}
				*/
				/*
				if (SRTP_TYPE==1)   // AES
				{
					
				}
				else if (SRTP_TYPE==2)   // ARIA
				{
					inputSize = rtp_data_len/2;

					memset(skey,0,sizeof skey);
					sprintf(skey,"%s",RecSeeCH[chdev].RTPKEY);
					int keyBytes = 24;   //ARIA
				  	//unsigned char* mk = new unsigned char[keyBytes];
				  	//hex_to_bin(mk, edMasterKey->Text.c_str(), edMasterKey->Text.Length());
				  	if (Aria_initialize((unsigned char*)skey, ENC_ARIA_KEY_BITS, 0))
				  	//delete[] mk;
	
					unsigned char* input = new unsigned char[inputSize];
				  	//hex_to_bin(input, mmInput->Lines->Text.c_str(), inputSize * 2);

					unsigned char* output = new unsigned char[inputSize];
					int res = Aria_crypt((unsigned char*)pUdp, output, inputSize);
					if (res != -1)
					{
						//unsigned char* hex = new unsigned char[res * 2 + 1];
						//bin_to_hex(hex, output, res);
						//hex[res * 2] = '\0';
						//mmOutput->Lines->Text = (char*)hex;
						pUdp = (char*)output;
						//delete[] hex;
					}
					delete[] input;
					delete[] output;
				}
				*/
			}
			else if (RecSeeCH[chdev].SRTP_YN==1)
			{
				inputSize = rtp_data_len/2;
/*
				memset(skey,0,sizeof skey);
				sprintf(skey,"%s",RecSeeCH[chdev].RTPKEY);
				int keyBytes = 24;   //ARIA
				//unsigned char* mk = new unsigned char[keyBytes];
				//hex_to_bin(mk, edMasterKey->Text.c_str(), edMasterKey->Text.Length());
				if (Aria_initialize((unsigned char*)skey, ENC_ARIA_KEY_BITS, 0))
				//delete[] mk;
*/
				unsigned char* input = new unsigned char[inputSize];
				//hex_to_bin(input, mmInput->Lines->Text.c_str(), inputSize * 2);

				unsigned char* output = new unsigned char[inputSize];
				int res = Aria_crypt((unsigned char*)pUdp, output, inputSize);
				if (res != -1)
				{
					//unsigned char* hex = new unsigned char[res * 2 + 1];
					//bin_to_hex(hex, output, res);
					//hex[res * 2] = '\0';
					//mmOutput->Lines->Text = (char*)hex;
					pUdp = (char*)output;
					//delete[] hex;
				}
				delete[] input;
				delete[] output;
			}
			else{
				pUdp=data;
				pUdp=pUdp+12;
			}
		

			for (int cnt=0;cnt<5;cnt++)
			{
				if (RecSeeCH[chdev].monclient[cnt].MonFlag == 1)
				{	//printf("ip=%s [%d]\n",RecSeeCH[chdev].monclient[cnt].IPAddress,MONITOR_PORT);
					 RecSee_TSC(0,RecSeeCH[chdev].monclient[cnt].IPAddress,MONITOR_PORT,(char*)data,rtp_data_len+12);
				}
			}
			RecSee_CfileWrite(chdev, (char*)pUdp, rtp_data_len);
						
			RECSEE_CH[chdev].kcnt=RECSEE_CH[chdev].kcnt+rtp_data_len;



			/*
			if(strncmp(RECSEE_CH[chdev].IPADDR,ip,strlen(ip))==0){
				for (int cnt=0;cnt<5;cnt++)
				{
					if (RecSeeCH[chdev].monclient[cnt].MonFlag == 1)
					{
						 RecSee_TSC(0,RecSeeCH[chdev].monclient[cnt].IPAddress,MONITOR_PORT,(char*)data,rtp_data_len+12);
					}
				}
			}
			else{
				for (int cnt=0;cnt<5;cnt++)
				{
					if (RecSeeCH[chdev].monclient[cnt].MonFlag == 1)
					{
						 RecSee_TSC(0,RecSeeCH[chdev].monclient[cnt].IPAddress,MONITOR_PORT+1,(char*)data,rtp_data_len+12);
					}
				}
			}

			

		  	if((strncmp(FC_RTP[chdev].IPADDR,ip,strlen(ip))!=0)&&(strlen(FC_RTP[chdev].IPADDR)>4))
			{
				current_term=GetTick()-FC_RTP[chdev].TIME;
				if(current_term>35&&Pay_load_type==0)
				{
					if(FC_RTP[chdev].MIXING!=1)
					{
						if(RECSEE_CH[chdev].kcnt==0) 
						{
							RecSee_CfileWrite(chdev, (char*)pUdp, rtp_data_len);
						}else{
							RecSee_CfileWrite(chdev, (char *)FC_RTP[chdev].BUFFER, rtp_data_len);
						}
						RECSEE_CH[chdev].kcnt=RECSEE_CH[chdev].kcnt+rtp_data_len;

					}

				FC_RTP[chdev].MIXING=0;
				//ZeroMemory(&FC_RTP[chdev],sizeof FC_RTP[chdev]);
				memset(&FC_RTP[chdev],0,sizeof FC_RTP[chdev]);
				sprintf(FC_RTP[chdev].IPADDR,ip);
				memcpy(FC_RTP[chdev].BUFFER,pUdp,rtp_data_len);
				FC_RTP[chdev].LENGTH =rtp_data_len;
				FC_RTP[chdev].TIME=GetTick();
			}else
			{ 
				unsigned char mix[512]; 	
				memset(mix,0,sizeof mix);
				if(rtp_data_len>FC_RTP[chdev].LENGTH) 
				{
					memcpy(mix,pUdp,rtp_data_len);
					RecSee_Mixing(FC_RTP[chdev].BUFFER,(unsigned char*)pUdp,mix,FC_RTP[chdev].LENGTH,Pay_load_type);
					RecSee_CfileWrite(chdev, (char *)FC_RTP[chdev].BUFFER, rtp_data_len);

					RECSEE_CH[chdev].kcnt=RECSEE_CH[chdev].kcnt+rtp_data_len;
				}else if(rtp_data_len<FC_RTP[chdev].LENGTH)
				{
					memcpy(mix,FC_RTP[chdev].BUFFER,FC_RTP[chdev].LENGTH );
					RecSee_Mixing(FC_RTP[chdev].BUFFER,(unsigned char*)pUdp,mix,rtp_data_len,Pay_load_type);
					RecSee_CfileWrite(chdev, (char *)FC_RTP[chdev].BUFFER, rtp_data_len);
					RECSEE_CH[chdev].kcnt=RECSEE_CH[chdev].kcnt+FC_RTP[chdev].LENGTH;
				}else{
					RecSee_Mixing((unsigned char*)FC_RTP[chdev].BUFFER,(unsigned char*)pUdp,(unsigned char*)FC_RTP[chdev].MIX,rtp_data_len,Pay_load_type);									
					RecSee_CfileWrite(chdev, (char *)FC_RTP[chdev].MIX, rtp_data_len);
					RECSEE_CH[chdev].kcnt=RECSEE_CH[chdev].kcnt+FC_RTP[chdev].LENGTH;
				}

					//ZeroMemory(&FC_RTP[chdev],sizeof FC_RTP[chdev]);
					memset(&FC_RTP[chdev],0,sizeof FC_RTP[chdev]);
					FC_RTP[chdev].TIME=GetTick();
					FC_RTP[chdev].MIXING=1;
			}


				}else
				{
					if(FC_RTP[chdev].MIXING!=1)
					{
						if(RECSEE_CH[chdev].kcnt==0){
							RecSee_CfileWrite(chdev, (char*)pUdp, rtp_data_len);
						}
							
							RECSEE_CH[chdev].kcnt=RECSEE_CH[chdev].kcnt+rtp_data_len;
							RecSee_CfileWrite(chdev,(char *) FC_RTP[chdev].BUFFER, rtp_data_len);
						}

					FC_RTP[chdev].MIXING=0;
					//ZeroMemory(&FC_RTP[chdev],sizeof FC_RTP[chdev]);
					memset(&FC_RTP[chdev],0,sizeof FC_RTP[chdev]);
					sprintf(FC_RTP[chdev].IPADDR,ip);
					memcpy(FC_RTP[chdev].BUFFER,pUdp,rtp_data_len);
					FC_RTP[chdev].LENGTH =rtp_data_len;
					FC_RTP[chdev].TIME=GetTick();
				}
			*/

		} // end ==0x80

	
	return ;
}		


int RecSee_TSC(int flag, char *IP_Addr, int PORT, char *RTP_DATA, int RTP_LENGTH)
{
	
	char rBuf[2048];
	
	char recv_buf[200];

	
	int sk;
	
	struct sockaddr_in server;
	
	struct hostent *hp;
	
	int n_sent;

	
	
//	printf("[%s] [%d] [%d]\n", IP_Addr, PORT, RTP_LENGTH);

	
	if ((sk = socket(PF_INET,SOCK_DGRAM,0))<0)
	{
		
		printf("UDP SOCKET ERROR\n");
		return -1;
	}

	
		
	server.sin_family = AF_INET;
	
	server.sin_addr.s_addr = inet_addr(IP_Addr);
	
	server.sin_port=htons(PORT);

	
	n_sent = sendto(sk, RTP_DATA, RTP_LENGTH, 0, (struct sockaddr*)&server, sizeof(server));
	
	if (n_sent<0)
	{
		
		printf("UDP Send ERROR!\n");
		
		return -1;
	}

	
		
	close(sk);

	
	return 1;

}




int RecSee_CfileWrite(int Channel, char * buf, int length)
{
	if(rFileChk[Channel]==0){	return 0;	}

	//if (rFile[Channel] == NULL)
	if (RecSeeCH[Channel].rFIle == NULL)
	{
		return 0;
	}
	
	//fwrite(buf, length, 1, rFile[Channel]);
	fwrite(buf, length, 1,RecSeeCH[Channel].rFIle);

	return 0;
}

string getInline(char *fHead, char *Tag)
{
	int i, j;
	//string findstr;
	char findstr[20];
	string rstr = "";
	string tmp = "\r\n";
	char *szpFind1 = NULL;
	char *szpFind2 = NULL;
	int icount = 0;

	sprintf(findstr, "%s:", Tag);
	szpFind1 = strstr(fHead, findstr);
	if (szpFind1)
	{
		szpFind1 += strlen(findstr);
	}
	else
	{
		return "";
	}

	szpFind2 = strstr(szpFind1, "\r");
	if (szpFind2)
	{
		icount = szpFind2 - szpFind1;
		szpFind1[icount] = NULL; 
	}
	return szpFind1;
}


string getHeader(char *fHead, char *Tag)
{
	int i, j;
	//string findstr;
	char findstr[20];
	string rstr = "";
	string tmp = "\r\n";
	char *szpFind1 = NULL;
	char *szpFind2 = NULL;
	int icount = 0;

	//findstr = "\r\n"+Tag+":";
	sprintf(findstr, "\r\n%s:", Tag);
	szpFind1 = strstr(fHead, findstr);
	if (szpFind1)
	{
		szpFind1 += strlen(findstr)+1;
	}
	else
	{
		return "";
	}

	szpFind2 = strstr(szpFind1, "\r");
	if (szpFind2)
	{
		icount = szpFind2 - szpFind1;
		szpFind1[icount] = NULL; 
	}
	return szpFind1;
	/*			
	i = fHead.Find(findstr);
	if (i<0) return "";
	
	i = i + (2+Tag.GetLength()+1);
	j = i;
	for (j=i;j<=fHead.GetLength();j++)
	{
		if (fHead.Mid(j,1)=="\r")
			break;
	}

	rstr = fHead.Mid(i,j-i);
	return rstr;
	*/
}

string getPhoneNo(char *Msg)
{
	int i,j;
	
	char *szpFind1 = NULL;
	char *szpFind2 = NULL;
	int icount = 0;
	char findstr[6];

	//findstr = "<sip:";
	sprintf(findstr, "<sip:");

	szpFind1 = strstr(Msg, findstr);
	if (szpFind1)
	{
		szpFind1 += strlen(findstr);
	}
	else
	{
		return "";
	}
	szpFind2 = strstr(szpFind1, "@");
	if (szpFind2)
	{
		icount = szpFind2 - szpFind1;
		szpFind1[icount] = NULL; 
	}
	else
	{
		return "";
	}

	return szpFind1;

	/*
	i = Msg.Find("<sip:");
	if (i<0) return "";
	i = i + 5;
	
	j = Msg.Find("@");
	if (j<0) return "";
	
	retstr = Msg.Mid(i,j-i);
	
	return retstr;
	*/
}

char* getSRTPKey(char *fHead, char *Tag)
{
	int i, j;
	//string findstr;
	char findstr[30];
	string rstr = "";
	string tmp = "\r\n";
	char *szpFind1 = NULL;
	char *szpFind2 = NULL;
	int icount = 0;

	//findstr = "\r\n"+Tag+":";
	sprintf(findstr, "\r\n%s", Tag);
	szpFind1 = strstr(fHead, findstr);
	if (szpFind1)
	{
		szpFind1 += strlen(findstr);
	}
	else
	{
		return "";
	}

	szpFind2 = strstr(szpFind1, "\r");
	if (szpFind2)
	{
		icount = szpFind2 - szpFind1;
		szpFind1[icount] = 0x00; 
	}
	return szpFind1;
	/*			
	i = fHead.Find(findstr);
	if (i<0) return "";
	
	i = i + (2+Tag.GetLength()+1);
	j = i;
	for (j=i;j<=fHead.GetLength();j++)
	{
		if (fHead.Mid(j,1)=="\r")
			break;
	}

	rstr = fHead.Mid(i,j-i);
	return rstr;
	*/
}

int RecSee_New_Record_Start(int chdev)
{
	char SendData[512];
	char VideoData[512];
	char MonData[200];

	memset(SendData,0x00, sizeof SendData);
	memset(VideoData,0x00, sizeof VideoData);

	if(rFileChk[chdev]==1)
	{	
		// 20090521 sim
		if (FORCE_OFFHOOK==1)
		{
			RecSee_New_Record_Stop(chdev);
		}
		else
			return 0;
	}

	RecSee_StartSeting(chdev);

	RecSeeCH[chdev].SIGNAL_END = 1;

	RecSeeCH[chdev].rFIle = fopen(RECSEE_CH[chdev].TMP_FILE_PATH, "wb");
	if (RecSeeCH[chdev].rFIle==NULL)
	{
		MakeLogDB(1200,RecSeeEX[chdev].EXT_NUM,RECSEE_CH[chdev].TMP_FILE_PATH);
		MakeLogDB(1002,RecSeeEX[chdev].EXT_NUM,RECSEE_CH[chdev].TMP_FILE_PATH);
	}
	
	rFileChk[chdev]=1;

	printf("CH[%d] RECORDING START FROM [%s] --> [%s]\n", chdev, RecSeeEX[chdev].EXT_NUM,RecSeeCH[chdev].CALL_ID1);
	MakeLogDB(1001,RecSeeEX[chdev].EXT_NUM,RECSEE_CH[chdev].TMP_FILE_PATH);
	
	memset(RecSeeCH[chdev].NOW_STATUS,0x00,sizeof RecSeeCH[chdev].NOW_STATUS);
	sprintf(RecSeeCH[chdev].NOW_STATUS,"%s","5");	

	// 20090212 sim
	if (strcmp(EU_MON_USING,"Y")==0)
	{
		memset(MonData,0,sizeof MonData);
		sprintf(MonData,"/RECSEE/%6s/Y/%s",RecSeeEX[chdev].EXT_NUM,RecSeeCH[chdev].LISTEN_URL);
		//RecSee_TcpSend(EUIP, atoi(EUPORT), MonData);	
	}

	
	return 1;
}


int RecSee_StartSeting(int Channel)
{
	int IChannel = Channel;
	char TmpFilename[100];

	char PartName[100];
	char FlagHDDString[2];
	int  ChkScreenIdx;
	RECSEE_CH[IChannel].kcnt=0;
	
	time_t t;
	struct tm *tm;
	struct timeval mytime;
	
	time(&t);
	tm=localtime(&t);
    	gettimeofday(&mytime, NULL);
    	
	memset(TmpFilename,0x00, sizeof TmpFilename);
	sprintf(TmpFilename,"%04d%02d%02d%02d%02d%02d%03d",tm->tm_year+1900,tm->tm_mon+1,tm->tm_mday,tm->tm_hour,tm->tm_min,tm->tm_sec,mytime.tv_usec/1000);

	memset(RecSeeCH[IChannel].REC_DATE,0x00, sizeof RecSeeCH[IChannel].REC_DATE);
	memset(RecSeeCH[IChannel].REC_TIME,0x00, sizeof RecSeeCH[IChannel].REC_TIME);
	memset(RecSeeCH[IChannel].REC_RTIME,0x00, sizeof RecSeeCH[IChannel].REC_RTIME);
	memset(RecSeeCH[IChannel].CALL_STIME,0x00, sizeof RecSeeCH[IChannel].CALL_STIME);
	
	sprintf(RecSeeCH[IChannel].REC_DATE,"%04d%02d%02d", tm->tm_year+1900,tm->tm_mon+1,tm->tm_mday);
	sprintf(RecSeeCH[IChannel].REC_TIME,"%02d%02d%02d",tm->tm_hour,tm->tm_min,tm->tm_sec );

	sprintf(RecSeeCH[IChannel].REC_RTIME,"%02d",tm->tm_hour);
	sprintf(RecSeeCH[IChannel].CALL_STIME ,"%s", RecSeeCH[IChannel].REC_TIME);
	RecSeeCH[IChannel].BEGIN_TIME = GetTick()/1000;		
	RecSeeCH[IChannel].STATUS_START_TIME = (GetTick()/1000);

	memset(RecSeeCH[IChannel].V_FILENAME,0x00, sizeof RecSeeCH[IChannel].V_FILENAME);
	memset(RecSeeCH[IChannel].S_FILENAME,0x00, sizeof RecSeeCH[IChannel].S_FILENAME);
	memset(RecSeeCH[IChannel].T_FILENAME,0x00, sizeof RecSeeCH[IChannel].T_FILENAME);

	RecSeeCH[IChannel].VOC_CHECK = 0;

	sprintf(RecSeeCH[IChannel].V_FILENAME ,"%s-%s.wav", TmpFilename, RecSeeEX[IChannel].EXT_NUM);
	sprintf(RecSeeCH[IChannel].S_FILENAME ,"%s.swf", RecSeeCH[IChannel].S_FILENOEXT);
	sprintf(RecSeeCH[IChannel].T_FILENAME ,"%s-%s.xml", TmpFilename, RecSeeEX[IChannel].EXT_NUM);

	memset(FlagHDDString,0x00,sizeof FlagHDDString);

	memset(PartName,0x00,sizeof PartName);

	if (strcmp(FOLDER_TYPE, "B") == 0)
	{
		sprintf(PartName,"%s", RecSeeCH[IChannel].BG_NAME);
	}else if(strcmp(FOLDER_TYPE, "M") == 0)
	{
		sprintf(PartName,"%s", RecSeeCH[IChannel].MG_NAME);
	}else if(strcmp(FOLDER_TYPE, "S") == 0)
	{
		sprintf(PartName,"%s", RecSeeCH[IChannel].SG_NAME);
		
	}else{
		sprintf(PartName,"%s", "RecSee_Data");
	}

	if(strlen(PartName)<2)
	{
		sprintf(PartName,"%s", "RecSee_Data");
	}

	memset(RecSeeCH[IChannel].PARTNAME, 0, sizeof RecSeeCH[IChannel].PARTNAME);
	sprintf(RecSeeCH[IChannel].PARTNAME, "%s", PartName);
	
	//SetFolder(4, HDDInfo[HDDCount].HDD_DRIVER,PartName, RecSeeCH[IChannel].REC_DATE, RecSeeCH[IChannel].REC_RTIME);
	if (SetFolder(4, "REC",PartName, RecSeeCH[IChannel].REC_DATE, RecSeeCH[IChannel].REC_RTIME)<0)
	{
		MakeLogDB(1003,"","SET FOLDER ERROR");
	}

	RecSeeCH[IChannel].NOW_RECORD=1;

	memset(RECSEE_CH[IChannel].TMP_FILE_PATH,0x0, sizeof RECSEE_CH[IChannel].TMP_FILE_PATH);
	sprintf(RECSEE_CH[IChannel].TMP_FILE_PATH,"/var/%s/%s/%s/%s/%s","REC",PartName,RecSeeCH[IChannel].REC_DATE,RecSeeCH[IChannel].REC_RTIME,RecSeeCH[IChannel].V_FILENAME );
	
	memset(RecSeeCH[IChannel].TMP_FILE_PATH,0x0, sizeof RecSeeCH[IChannel].TMP_FILE_PATH);
	sprintf(RecSeeCH[IChannel].TMP_FILE_PATH,"/var/%s/%s/%s/%s/%s","REC",PartName,RecSeeCH[IChannel].REC_DATE,RecSeeCH[IChannel].REC_RTIME,RecSeeCH[IChannel].V_FILENAME );

	memset(RecSeeCH[IChannel].CLI_FILE_PATH,0x0, sizeof RecSeeCH[IChannel].CLI_FILE_PATH);
	sprintf(RecSeeCH[IChannel].CLI_FILE_PATH,"/%s/%s/%s/%s/%s","REC",PartName,RecSeeCH[IChannel].REC_DATE,RecSeeCH[IChannel].REC_RTIME,RecSeeCH[IChannel].V_FILENAME );

	memset(RecSeeCH[IChannel].SCE_FILE_PATH,0x0, sizeof RecSeeCH[IChannel].SCE_FILE_PATH);
	sprintf(RecSeeCH[IChannel].SCE_FILE_PATH,"/%s/%s/%s/%s/%s""REC",PartName,RecSeeCH[IChannel].REC_DATE,RecSeeCH[IChannel].REC_RTIME,RecSeeCH[IChannel].S_FILENAME );

	memset(RecSeeCH[IChannel].LISTEN_URL,0x0, sizeof RecSeeCH[IChannel].LISTEN_URL);
	sprintf(RecSeeCH[IChannel].LISTEN_URL,"http://%s/%s/%s/%s/%s/%s", SYSTEM_IP , "REC",PartName,RecSeeCH[IChannel].REC_DATE, RecSeeCH[IChannel].REC_RTIME, RecSeeCH[IChannel].V_FILENAME);
	
	memset(RecSeeCH[IChannel].VDO_FILE_PATH,0x0, sizeof RecSeeCH[IChannel].VDO_FILE_PATH);
	sprintf(RecSeeCH[IChannel].VDO_FILE_PATH,"/%s/%s/%s/%s/%s-%s","REC",PartName,RecSeeCH[IChannel].REC_DATE,RecSeeCH[IChannel].REC_RTIME, TmpFilename, RecSeeEX[IChannel].EXT_NUM);
	
	memset(RecSeeCH[IChannel].VDO_URL,0x0, sizeof RecSeeCH[IChannel].LISTEN_URL);
	sprintf(RecSeeCH[IChannel].VDO_URL,"http://%s/%s/%s/%s/%s/%s-%s", SYSTEM_IP , "REC",PartName,RecSeeCH[IChannel].REC_DATE, RecSeeCH[IChannel].REC_RTIME, TmpFilename, RecSeeEX[IChannel].EXT_NUM);
	
	//RecSeeCH[IChannel].BLOCK_YN = 0;
	
	return 1;
}


int RecSee_New_Record_Stop(int chdev)
{
	char ReqFileName[1024];
	char SendData[256];
	char VideoData[256];
	char LogStr[256];
	int FieldCnt = 0;
	char FieldName[20];
	char FieldPart[20];
	char NewFileName[50];
	char FullPath[200];
	char FlagHDDString[2];
	char MonData[200];
	wave_header_t	wave_header;
	int _channels, u_long, _samplerate;
   int _sampbits;
	struct stat st;
	FILE *fd;
	unsigned short blockalign;
	char *rtpData;

	time_t t;
	struct tm *tm;
	time(&t);
	tm=localtime(&t);

	memset(ReqFileName,0x00, sizeof ReqFileName);
	memset(SendData,0x00, sizeof SendData);
	memset(VideoData,0x00, sizeof VideoData);	
	memset(LogStr,0x00, sizeof LogStr);

	//delete rx[chdev];
	if(REC_CTIUSING==0)
	{
		memset(RecSeeCH[chdev].NOW_STATUS,0x00,sizeof RecSeeCH[chdev].NOW_STATUS);
		sprintf(RecSeeCH[chdev].NOW_STATUS,"%s","4");	
	}else{
		memset(RecSeeCH[chdev].NOW_STATUS,0x00,sizeof RecSeeCH[chdev].NOW_STATUS);
		sprintf(RecSeeCH[chdev].NOW_STATUS,"%s","6");	
	}

	if(rFileChk[chdev]==0){	return 0; }
	rFileChk[chdev]=0;

	if (RecSeeCH[chdev].rFIle!=NULL)
	{
		fclose(RecSeeCH[chdev].rFIle);
	}

	FILE_SIZE_COUNT = 1000;
	EMPTY_FILE_DELETE = 0;

	if(FILE_SIZE_COUNT < RECSEE_CH[chdev].kcnt){
		RecSeeCH[chdev].DELETE_YN = 0;
	}else{
		RecSeeCH[chdev].DELETE_YN = 1;
		sprintf(LogStr,"[%s]- FileName: %s, Size=%d", RecSeeEX[chdev].EXT_NUM,RecSeeCH[chdev].V_FILENAME,RECSEE_CH[chdev].kcnt);
		MakeLogDB(1210,RecSeeEX[chdev].EXT_NUM,LogStr);		
		//LogSave2("", LogStr, "XBUG");	
	}

	RECSEE_CH[chdev].qcnt=0;
	RECSEE_CH[chdev].kcnt=0;

	sprintf(RecSeeCH[chdev].CALL_ETIME ,"%02d%02d%02d",tm->tm_hour,tm->tm_min,tm->tm_sec );
	RecSeeCH[chdev].END_TIME = (GetTick()/1000) - RecSeeCH[chdev].BEGIN_TIME;
	RecSeeCH[chdev].STATUS_START_TIME = (GetTick()/1000);
	sprintf(RecSeeCH[chdev].CALL_TTIME,"%d",RecSeeCH[chdev].END_TIME);

	if(strlen(RecSeeCH[chdev].CALL_KIND1)==0)
	{
		if(strlen(RecSeeCH[chdev].CUST_PHONE1)>0)
		{
			sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","O");
		}else{
			sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","I");
		}
		if(strlen(RecSeeCH[chdev].CUST_PHONE1)<5 && strlen(RecSeeCH[chdev].CUST_PHONE1)>0)
		{
			sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","Z");
		}
	}

	RecSeeCH[chdev].REC_CODEC = 1;
	if(RecSeeCH[chdev].PART_START > 0){ RecSeeCH[chdev].PART_YN=1;}

	if (strcmp(EU_MON_USING,"Y")==0)
	{
		memset(MonData,0,sizeof MonData);
		sprintf(MonData,"/RECSEE/%6s/N",RecSeeEX[chdev].EXT_NUM );
		//RecSee_TcpSend(EUIP, atoi(EUPORT), MonData);	
	}

	MakeQuery(chdev);

	if ((RecSeeCH[chdev].AUTO_REC==1) || ( (RecSeeCH[chdev].AUTO_REC==0) && (RecSeeCH[chdev].BLOCK_YN == 1) ))
	{
		/* 
		stat(RECSEE_CH[chdev].TMP_FILE_PATH, &st); 
		unsigned long databytes = st.st_size; 
		
		fd = fopen(RECSEE_CH[chdev].TMP_FILE_PATH ,"rb");
		
		if (fd!=NULL)
		{
			
			rtpData = (char*)malloc(databytes+1);
			
			fread(rtpData, databytes, 1, fd);
			fclose(fd);
		}

		_channels = 1;
		_sampbits   = 8 ;
		blockalign  = 1 ;
		_samplerate = 8000;
		
		wave_header.RiffID		= { 'R', 'I', 'F', 'F' };
		wave_header.RiffSize		= sizeof ( wave_header_t) + databytes - 8 ;
		wave_header.WaveID		= { 'W', 'A', 'V', 'E' };
		wave_header.FmtID		= { 'f', 'm', 't', ' ' };
		wave_header.FmtSize		= 16; //sizeof ( wave_header_t) + databytes - 8 ;
		wave_header.wFormatTag		= WAVE_FORMAT_MULAW ;
		wave_header.nChannels		= _channels ;
		wave_header.nSamplesPerSec	= _samplerate ;
		wave_header.nAvgBytesPerSec	= _samplerate * (unsigned long) blockalign ;
		wave_header.nBlockAlign		= blockalign ;
		wave_header.wBitsPerSample	= _sampbits ;
		wave_header.DataID		= { 'd', 'a', 't', 'a' };
		wave_header.nDataBytes		= databytes;
		
		fd = fopen(RECSEE_CH[chdev].TMP_FILE_PATH ,"wb");
		if (fd!=NULL)
		{
			fseek(fd, 0, SEEK_SET); // seek to end of file 
			
			fwrite(&wave_header, sizeof ( wave_header_t), 1, fd);
			fwrite(rtpData, 1, databytes, fd);
			fclose(fd);
		}

		if (rtpData!=NULL)
		{
			free(rtpData);
		}
		*/
		ConvertG711ToG721(RECSEE_CH[chdev].TMP_FILE_PATH);
	}

	RECSEE_CH[chdev].RTP_YN=0;
	RecSeeCH[chdev].NOW_RECORD=0;

	memset(RecSeeCH[chdev].CUST_TEMP, 0, sizeof RecSeeCH[chdev].CUST_TEMP);

	InitRecordingInfo(chdev);

	MakeLogDB(1011,RecSeeEX[chdev].EXT_NUM,RECSEE_CH[chdev].TMP_FILE_PATH);

	return 1;
}

int RecSee_New_Record_Stop2(int chdev)
{
	char ReqFileName[1024];
	char SendData[256];
	char VideoData[256];
	char LogStr[256];
	int FieldCnt = 0;
	char FieldName[20];
	char FieldPart[20];
	char NewFileName[50];
	char FullPath[200];
	char FlagHDDString[2];
	char MonData[200];
	wave_header_t	wave_header;
	int _channels, u_long, _samplerate;
   int _sampbits;
	struct stat st;
	FILE *fd;
	unsigned short blockalign;
	char *rtpData;

	time_t t;
	struct tm *tm;
	time(&t);
	tm=localtime(&t);

	memset(ReqFileName,0x00, sizeof ReqFileName);
	memset(SendData,0x00, sizeof SendData);
	memset(VideoData,0x00, sizeof VideoData);	
	memset(LogStr,0x00, sizeof LogStr);

	//delete rx[chdev];

	if(rFileChk[chdev]==0){	return 0; }
	rFileChk[chdev]=0;

	if (RecSeeCH[chdev].rFIle!=NULL)
	{
		fclose(RecSeeCH[chdev].rFIle);
	}

	FILE_SIZE_COUNT = 1000;
	EMPTY_FILE_DELETE = 0;

	if(FILE_SIZE_COUNT < RECSEE_CH[chdev].kcnt){
		RecSeeCH[chdev].DELETE_YN = 0;
	}else{
		RecSeeCH[chdev].DELETE_YN = 1;
		sprintf(LogStr,"[%s]- FileName: %s, Size=%d", RecSeeEX[chdev].EXT_NUM,RecSeeCH[chdev].V_FILENAME,RECSEE_CH[chdev].kcnt);
		MakeLogDB(1210,RecSeeEX[chdev].EXT_NUM,LogStr);		
		//LogSave2("", LogStr, "XBUG");	
	}

	RECSEE_CH[chdev].qcnt=0;
	RECSEE_CH[chdev].kcnt=0;

	sprintf(RecSeeCH[chdev].CALL_ETIME ,"%02d%02d%02d",tm->tm_hour,tm->tm_min,tm->tm_sec );
	RecSeeCH[chdev].END_TIME = (GetTick()/1000) - RecSeeCH[chdev].BEGIN_TIME;
	RecSeeCH[chdev].STATUS_START_TIME = (GetTick()/1000);
	sprintf(RecSeeCH[chdev].CALL_TTIME,"%d",RecSeeCH[chdev].END_TIME);

	if(strlen(RecSeeCH[chdev].CALL_KIND1)==0)
	{
		if(strlen(RecSeeCH[chdev].CUST_PHONE1)>0)
		{
			sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","O");
		}else{
			sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","I");
		}
		if(strlen(RecSeeCH[chdev].CUST_PHONE1)<5 && strlen(RecSeeCH[chdev].CUST_PHONE1)>0)
		{
			sprintf(RecSeeCH[chdev].CALL_KIND1,"%s","Z");
		}
	}

	RecSeeCH[chdev].REC_CODEC = 1;
	if(RecSeeCH[chdev].PART_START > 0){ RecSeeCH[chdev].PART_YN=1;}

	MakeQuery(chdev);

	if ((RecSeeCH[chdev].AUTO_REC==1) || ( (RecSeeCH[chdev].AUTO_REC==0) && (RecSeeCH[chdev].BLOCK_YN == 1) ))
	{
		/* 
		stat(RECSEE_CH[chdev].TMP_FILE_PATH, &st); 
		unsigned long databytes = st.st_size; 

		
		fd = fopen(RECSEE_CH[chdev].TMP_FILE_PATH ,"rb");
		
		if (fd!=NULL)
		{
			
			rtpData = (char*)malloc(databytes+1);
			
			fread(rtpData, databytes, 1, fd);
			
			//fread(&wave_header, sizeof ( wave_header_t), 1, fd);
			fclose(fd);
		}

//printf("datasize = %lu\n", databytes);
		// write wav headrer
		_channels = 1;
		_sampbits   = 8 ;
		blockalign  = 1 ;
		_samplerate = 8000;
		
		wave_header.RiffID		= { 'R', 'I', 'F', 'F' };
		wave_header.RiffSize		= sizeof ( wave_header_t) + databytes - 8 ;
		wave_header.WaveID		= { 'W', 'A', 'V', 'E' };
		wave_header.FmtID		= { 'f', 'm', 't', ' ' };
		wave_header.FmtSize		= 16; //sizeof ( wave_header_t) + databytes - 8 ;
		wave_header.wFormatTag		= WAVE_FORMAT_MULAW ;
		wave_header.nChannels		= _channels ;
		wave_header.nSamplesPerSec	= _samplerate ;
		wave_header.nAvgBytesPerSec	= _samplerate * (unsigned long) blockalign ;
		wave_header.nBlockAlign		= blockalign ;
		wave_header.wBitsPerSample	= _sampbits ;
		wave_header.DataID		= { 'd', 'a', 't', 'a' };
		wave_header.nDataBytes		= databytes;
		
		fd = fopen(RECSEE_CH[chdev].TMP_FILE_PATH ,"wb");
		if (fd!=NULL)
		{
			fseek(fd, 0, SEEK_SET); // seek to end of file 
			
			fwrite(&wave_header, sizeof ( wave_header_t), 1, fd);
			fwrite(rtpData, 1, databytes, fd);
			fclose(fd);
		}

		if (rtpData!=NULL)
		{
			free(rtpData);
		}
		*/
		ConvertG711ToG721(RECSEE_CH[chdev].TMP_FILE_PATH);
	}

	RECSEE_CH[chdev].RTP_YN=0;
	RecSeeCH[chdev].NOW_RECORD=0;

	memset(RecSeeCH[chdev].CUST_TEMP, 0, sizeof RecSeeCH[chdev].CUST_TEMP);

	InitRecordingInfo(chdev);

	MakeLogDB(1011,RecSeeEX[chdev].EXT_NUM,RECSEE_CH[chdev].TMP_FILE_PATH);

	return 1;
}


int InitRecordingInfo(int Channel)
{
	sprintf(RecSeeCH[Channel].CUST_PHONE1,"%s","");	
	sprintf(RecSeeCH[Channel].CUST_PHONE2,"%s","");	
	sprintf(RecSeeCH[Channel].RECEIPT_NUM,"%s","");	
	sprintf(RecSeeCH[Channel].CALL_KIND1,"%s","");	
	sprintf(RecSeeCH[Channel].CALL_KIND2,"%s","");	
	sprintf(RecSeeCH[Channel].CALL_ID1,"%s","");	
	sprintf(RecSeeCH[Channel].CALL_ID2,"%s","");	
	sprintf(RecSeeCH[Channel].REC_VISIBLE,"%s","");	
	

	sprintf(RecSeeCH[Channel].CUST_NAME,"%s","");	
	sprintf(RecSeeCH[Channel].CUST_PHONE2,"%s","");	
	sprintf(RecSeeCH[Channel].CUST_PHONE3,"%s","");	
	sprintf(SRecSeeCH[Channel].CUST_SOCIAL_NUM,"%s","");	
	sprintf(SRecSeeCH[Channel].CONTRACT_NUM,"%s","");	

	sprintf(SRecSeeCH[Channel].COUNSEL_CODE,"%s","");	
	sprintf(SRecSeeCH[Channel].COUNSEL_CONTENT,"%s","");	
	sprintf(SRecSeeCH[Channel].CUST_ADDRESS,"%s","");	
	sprintf(SRecSeeCH[Channel].BUFFER1,"%s","");	
	sprintf(SRecSeeCH[Channel].BUFFER2,"%s","");	
	sprintf(SRecSeeCH[Channel].BUFFER3,"%s","");	
	sprintf(RecSeeCH[Channel].RTPKEY,"%s","");


	memset(SRecSeeCH[Channel].R_CUST_ID,0,sizeof SRecSeeCH[Channel].R_CUST_ID);
	memset(SRecSeeCH[Channel].R_REGI_DATE,0,sizeof SRecSeeCH[Channel].R_REGI_DATE);
	memset(SRecSeeCH[Channel].R_MANAGER,0,sizeof SRecSeeCH[Channel].R_MANAGER);


	RecSeeCH[Channel].PART_START = 0;
	RecSeeCH[Channel].PART_END = 0;
	RecSeeCH[Channel].PART_YN = 0;
	
	RecSeeCH[Channel].MARKING1=0;
	RecSeeCH[Channel].MARKING2=0;
	RecSeeCH[Channel].MARKING3=0;
	RecSeeCH[Channel].MARKING4=0;

	RecSeeCH[Channel].PART_START=0;
	RecSeeCH[Channel].PART_END=0;

	// 20081021 SIM
	sprintf(RecSeeCH[Channel].CALLID, "%s", "");
	RecSeeCH[Channel].SIGNAL_END = 0;

	// 20090212 sim
	RecSeeCH[Channel].BLOCK_YN = 0;

	RecSeeCH[Channel].IPCR_REC = 0;

	// 20090719 sim
	RecSeeCH[Channel].RTP_COUNT = 0;

	// 20090524 sim
	RecSeeCH[Channel].VOC_CHECK = 0;

	// 20091019 sim
	RecSeeCH[Channel].AVAIL_TIME = 0;

	RecSeeCH[Channel].PortNo = 0;

	RecSeeCH[Channel].NOWSTATUS = 0;

	RecSeeCH[Channel].SRTP_YN = 0;

	for (int i=0;i<5;i++)
	{
		RecSeeCH[Channel].monclient[i].MonFlag = 0;
		memset(RecSeeCH[Channel].monclient[i].IPAddress,0,sizeof RecSeeCH[Channel].monclient[i].IPAddress);
	}

	return 1;
}


int SetFolder(int IDX, char *DrvFolder,char *PartName, char *DateFolder, char *TimeFolder)
{
	int r;
	char Path[200];
	
	/*
	if (...)  // disk full
		if(chdir("/outdisk") == -1) {
			perror("chdir failed");
		return -1;
	else
	{
		if(chdir("/var") == -1) {
			perror("chdir failed");
		return -1;
	}

	}
	*/

	if(chdir("/var") == -1) {
		perror("chdir failed");
	return -1;
	}

	if(mkdir(DrvFolder, 0777) == -1) {   /* rootsub �����丮�� ���� */
		//printf("mkdir failed [%s]\n", DrvFolder);
		//return -1;
	}

	if(chdir(DrvFolder) == -1) {
		perror("chdir failed");
		return -1;
	}
	
	if(mkdir(PartName, 0777) == -1) {
		//printf("mkdir failed [%s]\n", PartName);
		//return -1;
		MakeLogDB(1003,"",PartName);
	}

	if(chdir(PartName) == -1) {
		perror("chdir failed");
		return -1;
	}

	if(mkdir(DateFolder, 0777) == -1) {
		//printf("mkdir failed [%s]\n", DateFolder);
		//return -1;
	}

	if(chdir(DateFolder) == -1) {
		perror("chdir failed");
		return -1;
	}
	
	if(mkdir(TimeFolder, 0777) == -1) {
		//printf("mkdir failed [%s]\n", TimeFolder);
		//return -1;
	}

	return 1;
}


short RecSee_Amplification(short buf,double val)
{
	short min;
	short master;
	unsigned short max;	

	min=buf ;
	master=(buf*val);
		if(min<0)
		{
			max= (labs(buf)*val);

				if(max>32768)//32124)
				{
					master =-32768;
				}
		}else
		{
			max= (buf*val);
			if(max>32767)
			{
				master =32767;
			}
		}
	return master;
}

int RecSee_Mixing(unsigned char* cpFILEBUF_F,unsigned char* cpFILEBUF_S,unsigned char* cpRESULTBUF,int RTP_LENGTH,int Type)
{
	short * File_Buffer;
	short * PCM_LINEAR_F;
	short * PCM_LINEAR_S;
	//CFile   File_1, File_2, File_3, File_Add;
	unsigned int   dwByteCount = 0;
	unsigned int   dwTemporaryF, dwTemporaryS;

	unsigned int   i = 0;

	dwTemporaryF=0;
	dwTemporaryS=0;
	dwTemporaryF = RTP_LENGTH;//310;//sizeof cpFile1_buf;
	
	memset(cpRESULTBUF,0,dwTemporaryF);
	//ZeroMemory(cpRESULTBUF, dwTemporaryF);
	File_Buffer = new short[dwTemporaryF*20];
	//ZeroMemory(File_Buffer, dwTemporaryF*20);
	memset(File_Buffer, 0, dwTemporaryF*20);

	PCM_LINEAR_F = new short[dwTemporaryF*20];
	PCM_LINEAR_S = new short[dwTemporaryF*20];
	//ZeroMemory(PCM_LINEAR_F, dwTemporaryF*20);
	memset(PCM_LINEAR_F, 0, dwTemporaryF*20);
	//ZeroMemory(PCM_LINEAR_S, dwTemporaryF*20);
	memset(PCM_LINEAR_S, 0, dwTemporaryF*20);

	for(i=0; i<dwTemporaryF; i++)
	{
		if(cpFILEBUF_F[i] >= 0 && cpFILEBUF_F[i] < 256)
		{
			if(Type==0){            
				PCM_LINEAR_F[i] = ulaw2Short[ cpFILEBUF_F[i] ];
			}else{
				PCM_LINEAR_F[i] = alaw2Short[ cpFILEBUF_F[i] ];
			}
		}
		else{   PCM_LINEAR_F[i] = 128; }                                              // 8bit  128 
	}

	for(i = 0 ; i < dwTemporaryF ; i++) 
	{
		if(cpFILEBUF_S[i] >= 0 && cpFILEBUF_S[i] < 256)
		{
			if(Type==0){
			  PCM_LINEAR_S[i] = ulaw2Short[ cpFILEBUF_S[i] ];
			}else{
			  PCM_LINEAR_S[i] = alaw2Short[ cpFILEBUF_S[i] ];
			}
		}
		else{  PCM_LINEAR_S[i] = 128; 	}
	}

	for(i = 0 ; i <  dwTemporaryF ; i++) 
	{
		File_Buffer[i] = (PCM_LINEAR_F[i] + PCM_LINEAR_S[i]) ;        //  .
		File_Buffer[i]= RecSee_Amplification(File_Buffer[i],2);
		cpRESULTBUF[i]=linear2ulaw(File_Buffer[i]);
	}

	delete File_Buffer ;
	delete PCM_LINEAR_F ;
	delete PCM_LINEAR_S;

	return 0;

}



int MakeQuery(int Channel)
{
	string Query;
	char QuerySQL[3000];
	char QuerySQL1[1000];
	char QuerySQL2[2000];
	int IChannel = Channel;
	
	memset(QuerySQL2, 0x00, sizeof QuerySQL2);

	Query="INSERT INTO RS_RECFILE(";
	Query = Query + "R_REC_DATE, R_REC_RTIME, R_EXT_NUM, R_REC_TIME, ";
	Query = Query + "R_BG_CODE, R_MG_CODE, R_SG_CODE, R_USER_ID, R_CH_NUM, ";
	Query = Query + "R_USER_NAME, R_CALL_ID1, R_CALL_ID2, R_CALL_ID3, ";
	Query = Query + "R_CUST_NAME, R_CUST_PHONE1, R_CUST_PHONE2, R_CUST_PHONE3, ";
	Query = Query + "R_CALL_KIND1, R_CALL_KIND2, R_CALL_STIME, R_CALL_ETIME, ";
	Query = Query + "R_CALL_TTIME, R_SELFDIS_YN, ";
	Query = Query + "R_V_SYS_CODE, R_V_HDD_FLAG, R_LISTEN_URL, R_V_FILENAME,";
	Query = Query + "R_S_SYS_CODE, R_S_HDD_FLAG, R_SCREEN_URL, R_S_FILENAME,";
	Query = Query + "R_T_SYS_CODE, R_T_HDD_FLAG, R_TEXT_URL, R_T_FILENAME,";
	Query = Query + "R_PART_START, R_PART_END, R_REC_VISIBLE, R_REC_MEMO, ";
	Query = Query + "R_MARKING1, R_MARKING2, R_MARKING3, R_MARKING4, ";
	Query = Query + "R_PLAYER_KIND , R_BUFFER1, R_BUFFER2, R_BUFFER3";
	Query = Query + ") ";

	sprintf(QuerySQL1,"%s",(char*)Query.c_str());

	sprintf(QuerySQL2,"VALUES('%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s','%s', '%s','%s','%s','%s','%s','%s','%s','%d','%d','%s','%s','%d','%d','%d','%d','%s','%s','%s','%s')",
			//Query,
			RecSeeCH[IChannel].REC_DATE,
			RecSeeCH[IChannel].REC_RTIME,
			RecSeeEX[IChannel].EXT_NUM,
			RecSeeCH[IChannel].REC_TIME,
			RecSeeCH[IChannel].BG_CODE,
			RecSeeCH[IChannel].MG_CODE,
			RecSeeCH[IChannel].SG_CODE,
			RecSeeCH[IChannel].USER_ID,
			RecSeeCH[IChannel].CH_NUM,
			RecSeeCH[IChannel].USER_NAME,
			RecSeeCH[IChannel].CALL_ID1,
			RecSeeCH[IChannel].CALL_ID2,
			RecSeeCH[IChannel].CALL_ID3,
			RecSeeCH[IChannel].CUST_NAME,
			RecSeeCH[IChannel].CUST_PHONE1,
			RecSeeCH[IChannel].CUST_PHONE2,
			RecSeeCH[IChannel].CUST_PHONE3,
			RecSeeCH[IChannel].CALL_KIND1,
			RecSeeCH[IChannel].CALL_KIND2,
			RecSeeCH[IChannel].CALL_STIME,
			RecSeeCH[IChannel].CALL_ETIME,
			RecSeeCH[IChannel].CALL_TTIME,
			RecSeeCH[IChannel].SELFDIS_YN,
			SERVER_CODE,
			RecSeeCH[IChannel].V_HDD_FLAG,
			RecSeeCH[IChannel].LISTEN_URL,
			RecSeeCH[IChannel].V_FILENAME,
			RecSeeCH[IChannel].S_SYS_CODE,
			RecSeeCH[IChannel].S_HDD_FLAG,
			RecSeeCH[IChannel].SCREEN_URL,
			RecSeeCH[IChannel].S_FILENAME,
			RecSeeCH[IChannel].T_SYS_CODE,
			RecSeeCH[IChannel].T_HDD_FLAG,
			RecSeeCH[IChannel].TEXT_URL,
			RecSeeCH[IChannel].T_FILENAME,
			RecSeeCH[IChannel].PART_START,
			RecSeeCH[IChannel].PART_END,
			RecSeeCH[IChannel].REC_VISIBLE,
			"",
			RecSeeCH[IChannel].MARKING1,
			RecSeeCH[IChannel].MARKING2,
			RecSeeCH[IChannel].MARKING3,
			RecSeeCH[IChannel].MARKING4,
			RecSeeCH[IChannel].REC_KIND,
			SRecSeeCH[IChannel].BUFFER1,
			SRecSeeCH[IChannel].BUFFER2,
			SRecSeeCH[IChannel].BUFFER3
			//RecSeeCH[IChannel].RTPKEY
			);

	
			
	sprintf(QuerySQL,"%s%s",QuerySQL1,QuerySQL2);
//printf("%d  %d  %d\n",RecSeeCH[IChannel].NOW_RECORD,RecSeeCH[IChannel].AUTO_REC,RecSeeCH[IChannel].BLOCK_YN);
	if (RecSeeCH[IChannel].NOW_RECORD!=0)
	{	
		if ((RecSeeCH[IChannel].AUTO_REC==0)&&(RecSeeCH[IChannel].BLOCK_YN==0))
		{
			remove(RecSeeCH[IChannel].TMP_FILE_PATH);
		}
		else
		{
			if(RecSeeCH[IChannel].DELETE_YN==0)
			{
				QueueWriteRead(1, QuerySQL);	
			}
		}
	}

	return 1;
}


////////////////////// g.721 /////////////////////////
/*
 * quan()
 *
 * quantizes the input val against the table of size short integers.
 * It returns i if table[i - 1] <= val < table[i].
 *
 * Using linear search for simple coding.
 */
static int
quan(
	int		val,
	short		*table,
	int		size)
{
	int		i;

	for (i = 0; i < size; i++)
		if (val < *table++)
			break;
	return (i);
}

/*
 * fmult()
 *
 * returns the integer product of the 14-bit integer "an" and
 * "floating point" representation (4-bit exponent, 6-bit mantessa) "srn".
 */
static int
fmult(
	int		an,
	int		srn)
{
	short		anmag, anexp, anmant;
	short		wanexp, wanmag, wanmant;
	short		retval;

	anmag = (an > 0) ? an : ((-an) & 0x1FFF);
	anexp = quan(anmag, power2, 15) - 6;
	anmant = (anmag == 0) ? 32 :
	    (anexp >= 0) ? anmag >> anexp : anmag << -anexp;
	wanexp = anexp + ((srn >> 6) & 0xF) - 13;

	wanmant = (anmant * (srn & 077) + 0x30) >> 4;
	retval = (wanexp >= 0) ? ((wanmant << wanexp) & 0x7FFF) :
	    (wanmant >> -wanexp);

	return (((an ^ srn) < 0) ? -retval : retval);
}

/*
 * g72x_init_state()
 *
 * This routine initializes and/or resets the g72x_state structure
 * pointed to by 'state_ptr'.
 * All the initial state values are specified in the CCITT G.721 document.
 */
void
g72x_init_state(
	struct g72x_state *state_ptr)
{
	int		cnta;

	state_ptr->yl = 34816;
	state_ptr->yu = 544;
	state_ptr->dms = 0;
	state_ptr->dml = 0;
	state_ptr->ap = 0;
	for (cnta = 0; cnta < 2; cnta++) {
		state_ptr->a[cnta] = 0;
		state_ptr->pk[cnta] = 0;
		state_ptr->sr[cnta] = 32;
	}
	for (cnta = 0; cnta < 6; cnta++) {
		state_ptr->b[cnta] = 0;
		state_ptr->dq[cnta] = 32;
	}
	state_ptr->td = 0;
}

/*
 * predictor_zero()
 *
 * computes the estimated signal from 6-zero predictor.
 *
 */
int
predictor_zero(
	struct g72x_state *state_ptr)
{
	int		i;
	int		sezi;

	sezi = fmult(state_ptr->b[0] >> 2, state_ptr->dq[0]);
	for (i = 1; i < 6; i++)			/* ACCUM */
		sezi += fmult(state_ptr->b[i] >> 2, state_ptr->dq[i]);
	return (sezi);
}
/*
 * predictor_pole()
 *
 * computes the estimated signal from 2-pole predictor.
 *
 */
int
predictor_pole(
	struct g72x_state *state_ptr)
{
	return (fmult(state_ptr->a[1] >> 2, state_ptr->sr[1]) +
	    fmult(state_ptr->a[0] >> 2, state_ptr->sr[0]));
}
/*
 * step_size()
 *
 * computes the quantization step size of the adaptive quantizer.
 *
 */
int
step_size(
	struct g72x_state *state_ptr)
{
	int		y;
	int		dif;
	int		al;

	if (state_ptr->ap >= 256)
		return (state_ptr->yu);
	else {
		y = state_ptr->yl >> 6;
		dif = state_ptr->yu - y;
		al = state_ptr->ap >> 2;
		if (dif > 0)
			y += (dif * al) >> 6;
		else if (dif < 0)
			y += (dif * al + 0x3F) >> 6;
		return (y);
	}
}

/*
 * quantize()
 *
 * Given a raw sample, 'd', of the difference signal and a
 * quantization step size scale factor, 'y', this routine returns the
 * ADPCM codeword to which that sample gets quantized.  The step
 * size scale factor division operation is done in the log base 2 domain
 * as a subtraction.
 */
int
quantize(
	int		d,	/* Raw difference signal sample */
	int		y,	/* Step size multiplier */
	short		*table,	/* quantization table */
	int		size)	/* table size of short integers */
{
	short		dqm;	/* Magnitude of 'd' */
	short		exp;	/* Integer part of base 2 log of 'd' */
	short		mant;	/* Fractional part of base 2 log */
	short		dl;	/* Log of magnitude of 'd' */
	short		dln;	/* Step size scale factor normalized log */
	int		i;

	/*
	 * LOG
	 *
	 * Compute base 2 log of 'd', and store in 'dl'.
	 */
	dqm = abs(d);
	exp = quan(dqm >> 1, power2, 15);
	mant = ((dqm << 7) >> exp) & 0x7F;	/* Fractional portion. */
	dl = (exp << 7) + mant;

	/*
	 * SUBTB
	 *
	 * "Divide" by step size multiplier.
	 */
	dln = dl - (y >> 2);

	/*
	 * QUAN
	 *
	 * Obtain codword i for 'd'.
	 */
	i = quan(dln, table, size);
	if (d < 0)			/* take 1's complement of i */
		return ((size << 1) + 1 - i);
	else if (i == 0)		/* take 1's complement of 0 */
		return ((size << 1) + 1); /* new in 1988 */
	else
		return (i);
}
/*
 * reconstruct()
 *
 * Returns reconstructed difference signal 'dq' obtained from
 * codeword 'i' and quantization step size scale factor 'y'.
 * Multiplication is performed in log base 2 domain as addition.
 */
int
reconstruct(
	int		sign,	/* 0 for non-negative value */
	int		dqln,	/* G.72x codeword */
	int		y)	/* Step size multiplier */
{
	short		dql;	/* Log of 'dq' magnitude */
	short		dex;	/* Integer part of log */
	short		dqt;
	short		dq;	/* Reconstructed difference signal sample */

	dql = dqln + (y >> 2);	/* ADDA */

	if (dql < 0) {
		return ((sign) ? -0x8000 : 0);
	} else {		/* ANTILOG */
		dex = (dql >> 7) & 15;
		dqt = 128 + (dql & 127);
		dq = (dqt << 7) >> (14 - dex);
		return ((sign) ? (dq - 0x8000) : dq);
	}
}


int block4l (short int dl)
{
		static int sl = 0 ;
        int wd1, wd2, wd3, wd4, wd5;
        static int spl = 0 ;
        static int szl = 0 ;
        static int rlt  [3] = { 0, 0, 0 } ;
        static int al   [3] = { 0, 0, 0 } ;
        static int plt  [3] = { 0, 0, 0 } ;
        static int dlt  [7] = { 0, 0, 0, 0, 0, 0, 0 } ;
        static int bl   [7] = { 0, 0, 0, 0, 0, 0, 0 } ;
        static int sg   [7] = { 0, 0, 0, 0, 0, 0, 0 } ;
/****************** pointer ****************************/
        register int *sgp, *pltp, *alp, *dltp, *blp, *rltp;
        register int *pltp_1, *dltp_1, *rltp_1;
/*************************************** BLOCK 4L, RECONS ***********/
        *dlt = dl;

        *rlt = sl + dl ;
/*
        if ( *rlt > 32767 ) *rlt = 32767;
        else if ( *rlt < -32768 ) *rlt = -32768;
*/
/*************************************** BLOCK 4L, PARREC ***********/

        *plt = dl + szl ;
/*
        if ( plt[0] > 32767 ) plt[0] = 32767;
        else if ( plt[0] < -32768 ) plt[0] = -32768;
*/
/*****************************BLOCK 4L, UPPOL2*************************/
        sgp = sg, pltp = plt, alp = al ;
                *sgp++ = *pltp++ >> 15 ;
                *sgp++ = *pltp++ >> 15 ;
                *sgp++ = *pltp++ >> 15 ;

        wd1 = *++alp << 2;

        if ( wd1 > 32767 ) wd1 = 32767;
        else if ( wd1 < -32768 ) wd1 = -32768;

        wd2= ( *sg == *(sg+1) )?  -wd1: wd1 ;
        if ( wd2 > 32767 ) wd2 = 32767;

        wd2 = wd2 >> 7 ;
        wd3= ( *sg == *(sg+2) )? 128: -128 ;
        wd4 = wd2 + wd3 ;
        wd5 = (*++alp * 32512) >> 15 ;

        *alp = wd4 + wd5 ;

        if ( *alp  >  12288 )  *alp =  12288 ;
        else if ( *alp  < -12288 )  *alp = -12288 ;

/************************************* BLOCK 4L, UPPOL1 ***************/

        *sg = *plt >> 15 ;
        *(sg+1) = *(plt+1) >> 15 ;
        wd1 = ( *sg == *(sg+1) )?  192 : -192 ;

        wd2 = (*--alp * 32640) >> 15 ;

        *alp = wd1 + wd2 ;
/*
        if ( *alp > 32767 ) *alp = 32767;
        else if ( *alp < -32768 ) *alp = -32768;
*/
        wd3 = (15360 - *++alp) ;
/*
        if ( wd3 > 32767 ) wd3 = 32767;
        else if ( wd3 < -32768 ) wd3 = -32768;
*/
        if ( *--alp >  wd3)  *alp =  wd3 ;
        else if ( *alp  < -wd3)  *alp = -wd3 ;

/*************************************** BLOCK 4L, UPZERO ************/
        wd1 = ( dl == 0 ) ? 0 : 128;
        *sg = dl >> 15 ;
        sgp = sg, dltp = dlt, blp = bl;

                *++sgp = *++dltp >> 15 ;
                wd2 = ( *sgp == *sg ) ? wd1 : -wd1 ;
                wd3 = (*++blp * 32640) >> 15 ;
                *blp = wd2 + wd3 ;
/*
                if ( *blp > 32767 ) *blp = 32767;
                else if ( *blp < -32768 ) *blp = -32768;
*/

                *++sgp = *++dltp >> 15 ;
                wd2 = ( *sgp == *sg ) ? wd1 : -wd1 ;
                wd3 = (*++blp * 32640) >> 15 ;
                *blp = wd2 + wd3 ;
/*
                if ( *blp > 32767 ) *blp = 32767;
                else if ( *blp < -32768 ) *blp = -32768;
*/

                *++sgp = *++dltp >> 15 ;
                wd2 = ( *sgp == *sg ) ? wd1 : -wd1 ;
                wd3 = (*++blp * 32640) >> 15 ;
                *blp = wd2 + wd3 ;
/*
                if ( *blp > 32767 ) *blp = 32767;
                else if ( *blp < -32768 ) *blp = -32768;
*/

                *++sgp = *++dltp >> 15 ;
                wd2 = ( *sgp == *sg ) ? wd1 : -wd1 ;
                wd3 = (*++blp * 32640) >> 15 ;       /* for g721_40, use 32704 instead of 32640 */
                *blp = wd2 + wd3 ;
/*
                if ( *blp > 32767 ) *blp = 32767;
                else if ( *blp < -32768 ) *blp = -32768;
*/

                *++sgp = *++dltp >> 15 ;
                wd2 = ( *sgp == *sg ) ? wd1 : -wd1 ;
                wd3 = (*++blp * 32640) >> 15 ;
                *blp = wd2 + wd3 ;
/*
                if ( *blp > 32767 ) *blp = 32767;
                else if ( *blp < -32768 ) *blp = -32768;
*/

                *++sgp = *++dltp >> 15 ;
                wd2 = ( *sgp == *sg ) ? wd1 : -wd1 ;
                wd3 = (*++blp * 32640) >> 15 ;
                *blp = wd2 + wd3 ;
/*
                if ( *blp > 32767 ) *blp = 32767;
                else if ( *blp < -32768 ) *blp = -32768;
*/

/********************************* BLOCK 4L, DELAYA ******************/
        dltp_1 = dltp - 1;
                *dltp--  = *dltp_1-- ;
                *dltp--  = *dltp_1-- ;
                *dltp--  = *dltp_1-- ;
                *dltp--  = *dltp_1-- ;
                *dltp--  = *dltp_1-- ;
                *dltp--  = *dltp_1-- ;

        rltp =rlt+2, pltp = plt+2 ;
        rltp_1 = rltp - 1, pltp_1 = pltp - 1;

                *rltp-- = *rltp_1--;
                *pltp-- = *pltp_1--;
                *rltp-- = *rltp_1--;
                *pltp-- = *pltp_1--;
/********************************* BLOCK 4L, FILTEP ******************/

        wd1 = ( *alp * *++rltp ) >> 14 ;

        wd2 = ( *++alp * *++rltp ) >> 14 ;

        spl = wd1 + wd2 ;
/*
        if ( spl > 32767 ) spl = 32767;
        else if ( spl < -32768 ) spl = -32768;
*/
/*************************************** BLOCK 4L, FILTEZ ***********/

        blp = blp - 6;
                szl = (*++blp * *++dltp) >> 14 ;
/*
                if ( szl > 32767 ) szl = 32767;
                else if ( szl < -32768 ) szl = -32768;
*/
                szl += (*++blp * *++dltp) >> 14 ;
/*
                if ( szl > 32767 ) szl = 32767;
                else if ( szl < -32768 ) szl = -32768;
*/
                szl += (*++blp * *++dltp) >> 14 ;
/*
                if ( szl > 32767 ) szl = 32767;
                else if ( szl < -32768 ) szl = -32768;
*/
                szl += (*++blp * *++dltp) >> 14 ;
/*
                if ( szl > 32767 ) szl = 32767;
                else if ( szl < -32768 ) szl = -32768;
*/
                szl += (*++blp * *++dltp) >> 14 ;
/*
                if ( szl > 32767 ) szl = 32767;
                else if ( szl < -32768 ) szl = -32768;
*/
                szl += (*++blp * *++dltp) >> 14 ;
/*
                if ( szl > 32767 ) szl = 32767;
                else if ( szl < -32768 ) szl = -32768;
*/
/*********************************BLOCK 4L, PREDIC *******************/

        sl = spl + szl ;
/*
        if ( sl > 32767 ) sl = 32767;
        else if ( sl < -32768 ) sl = -32768;
*/

        return (sl) ;
}


/*
 * update()
 *
 * updates the state variables for each output code
 */
void
update(
	int		code_size,	/* distinguish 723_40 with others */
	int		y,		/* quantizer step size */
	int		wi,		/* scale factor multiplier */
	int		fi,		/* for long/short term energies */
	int		dq,		/* quantized prediction difference */
	int		sr,		/* reconstructed signal */
	int		dqsez,		/* difference from 2-pole predictor */
	struct g72x_state *state_ptr)	/* coder state pointer */
{
	int		cnt;
	short		mag, exp, mant;	/* Adaptive predictor, FLOAT A */
	short		a2p;		/* LIMC */
	short		a1ul;		/* UPA1 */
	short		ua2, pks1;	/* UPA2 */
	short		uga2a, fa1;
	short		uga2b;
	char		tr;		/* tone/transition detector */
	short		ylint, thr2, dqthr;
	short  		ylfrac, thr1;
	short		pk0;

	pk0 = (dqsez < 0) ? 1 : 0;	/* needed in updating predictor poles */

	mag = dq & 0x7FFF;		/* prediction difference magnitude */
	/* TRANS */
	ylint = state_ptr->yl >> 15;	/* exponent part of yl */
	ylfrac = (state_ptr->yl >> 10) & 0x1F;	/* fractional part of yl */
	thr1 = (32 + ylfrac) << ylint;		/* threshold */
	thr2 = (ylint > 9) ? 31 << 10 : thr1;	/* limit thr2 to 31 << 10 */
	dqthr = (thr2 + (thr2 >> 1)) >> 1;	/* dqthr = 0.75 * thr2 */
	if (state_ptr->td == 0)		/* signal supposed voice */
		tr = 0;
	else if (mag <= dqthr)		/* supposed data, but small mag */
		tr = 0;			/* treated as voice */
	else				/* signal is data (modem) */
		tr = 1;

	/*
	 * Quantizer scale factor adaptation.
	 */

	/* FUNCTW & FILTD & DELAY */
	/* update non-steady state step size multiplier */
	state_ptr->yu = y + ((wi - y) >> 5);

	/* LIMB */
	if (state_ptr->yu < 544)	/* 544 <= yu <= 5120 */
		state_ptr->yu = 544;
	else if (state_ptr->yu > 5120)
		state_ptr->yu = 5120;

	/* FILTE & DELAY */
	/* update steady state step size multiplier */
	state_ptr->yl += state_ptr->yu + ((-state_ptr->yl) >> 6);

	/*
	 * Adaptive predictor coefficients.
	 */
	if (tr == 1) {			/* reset a's and b's for modem signal */
		state_ptr->a[0] = 0;
		state_ptr->a[1] = 0;
		state_ptr->b[0] = 0;
		state_ptr->b[1] = 0;
		state_ptr->b[2] = 0;
		state_ptr->b[3] = 0;
		state_ptr->b[4] = 0;
		state_ptr->b[5] = 0;
	} else {			/* update a's and b's */
		pks1 = pk0 ^ state_ptr->pk[0];		/* UPA2 */

		/* update predictor pole a[1] */
		a2p = state_ptr->a[1] - (state_ptr->a[1] >> 7);
		if (dqsez != 0) {
			fa1 = (pks1) ? state_ptr->a[0] : -state_ptr->a[0];
			if (fa1 < -8191)	/* a2p = function of fa1 */
				a2p -= 0x100;
			else if (fa1 > 8191)
				a2p += 0xFF;
			else
				a2p += fa1 >> 5;

			if (pk0 ^ state_ptr->pk[1])
				/* LIMC */
				if (a2p <= -12160)
					a2p = -12288;
				else if (a2p >= 12416)
					a2p = 12288;
				else
					a2p -= 0x80;
			else if (a2p <= -12416)
				a2p = -12288;
			else if (a2p >= 12160)
				a2p = 12288;
			else
				a2p += 0x80;
		}

		/* TRIGB & DELAY */
		state_ptr->a[1] = a2p;

		/* UPA1 */
		/* update predictor pole a[0] */
		state_ptr->a[0] -= state_ptr->a[0] >> 8;
		if (dqsez != 0)
			if (pks1 == 0)
				state_ptr->a[0] += 192;
			else
				state_ptr->a[0] -= 192;

		/* LIMD */
		a1ul = 15360 - a2p;
		if (state_ptr->a[0] < -a1ul)
			state_ptr->a[0] = -a1ul;
		else if (state_ptr->a[0] > a1ul)
			state_ptr->a[0] = a1ul;

		/* UPB : update predictor zeros b[6] */
		for (cnt = 0; cnt < 6; cnt++) {
			if (code_size == 5)		/* for 40Kbps G.723 */
				state_ptr->b[cnt] -= state_ptr->b[cnt] >> 9;
			else			/* for G.721 and 24Kbps G.723 */
				state_ptr->b[cnt] -= state_ptr->b[cnt] >> 8;
			if (dq & 0x7FFF) {			/* XOR */
				if ((dq ^ state_ptr->dq[cnt]) >= 0)
					state_ptr->b[cnt] += 128;
				else
					state_ptr->b[cnt] -= 128;
			}
		}
	}

	for (cnt = 5; cnt > 0; cnt--)
		state_ptr->dq[cnt] = state_ptr->dq[cnt-1];
	/* FLOAT A : convert dq[0] to 4-bit exp, 6-bit mantissa f.p. */
	if (mag == 0) {
		state_ptr->dq[0] = (dq >= 0) ? 0x20 : 0xFC20;
	} else {
		exp = quan(mag, power2, 15);
		state_ptr->dq[0] = (dq >= 0) ?
		    (exp << 6) + ((mag << 6) >> exp) :
		    (exp << 6) + ((mag << 6) >> exp) - 0x400;
	}

	state_ptr->sr[1] = state_ptr->sr[0];
	/* FLOAT B : convert sr to 4-bit exp., 6-bit mantissa f.p. */
	if (sr == 0) {
		state_ptr->sr[0] = 0x20;
	} else if (sr > 0) {
		exp = quan(sr, power2, 15);
		state_ptr->sr[0] = (exp << 6) + ((sr << 6) >> exp);
	} else if (sr > -32768) {
		mag = -sr;
		exp = quan(mag, power2, 15);
		state_ptr->sr[0] =  (exp << 6) + ((mag << 6) >> exp) - 0x400;
	} else
		state_ptr->sr[0] = 0xFC20;

	/* DELAY A */
	state_ptr->pk[1] = state_ptr->pk[0];
	state_ptr->pk[0] = pk0;

	/* TONE */
	if (tr == 1)		/* this sample has been treated as data */
		state_ptr->td = 0;	/* next one will be treated as voice */
	else if (a2p < -11776)	/* small sample-to-sample correlation */
		state_ptr->td = 1;	/* signal may be data */
	else				/* signal is voice */
		state_ptr->td = 0;

	/*
	 * Adaptation speed control.
	 */
	state_ptr->dms += (fi - state_ptr->dms) >> 5;		/* FILTA */
	state_ptr->dml += (((fi << 2) - state_ptr->dml) >> 7);	/* FILTB */

	if (tr == 1)
		state_ptr->ap = 256;
	else if (y < 1536)					/* SUBTC */
		state_ptr->ap += (0x200 - state_ptr->ap) >> 4;
	else if (state_ptr->td == 1)
		state_ptr->ap += (0x200 - state_ptr->ap) >> 4;
	else if (abs((state_ptr->dms << 2) - state_ptr->dml) >=
	    (state_ptr->dml >> 3))
		state_ptr->ap += (0x200 - state_ptr->ap) >> 4;
	else
		state_ptr->ap += (-state_ptr->ap) >> 4;
}


int
g721_encoder(
	int		sl,
	int		in_coding)
{
    static short	se = 0;
    static short        y0 = 544;
	short		d;			/* SUBTA */
	short		y;			/* MIX */
	short		dq, i;

	switch (in_coding) {	/* linearize input sample to 14-bit PCM */
	/*
	case AUDIO_ENCODING_ALAW:
		sl = alaw2linear(sl) >> 2;
		break;
	*/
	case AUDIO_ENCODING_ULAW:
		sl = ulaw2linear(sl) >> 2;
		break;
	case AUDIO_ENCODING_LINEAR:
		sl >>= 2;			/* 14-bit dynamic range */
		break;
	default:
		return (-1);
	}

	d = sl - se;			/* estimation difference from block4l*/

	/* quantize the prediction difference */
        y = y0;
	i = quantize(d, y, qtab_721, 7);	/* i = ADPCM code */

	dq = reconstruct(i & 8, _dqlntab[i], y);	/* quantized est diff */

        y0 = y + (((_witab[i] << 5) - y) >> 5);

        if (y0 < 544)        y0 = 544;
        else if (y0 > 5120)  y0 = 5120;

/*        se = block4l((dq<0) ? -(dq+0x8000) : dq);  */
        se = block4l(dq);

	return (i);
}


int
pack_output(
	unsigned		code,
	int			bits)
{
	static unsigned int	out_buffer = 0;
	static int		out_bits = 0;
	unsigned char		out_byte;

	out_buffer |= (code << out_bits);
	out_bits += bits;
	if (out_bits >= 8) {
		out_byte = out_buffer & 0xff;
		out_bits -= 8;
		out_buffer >>= 8;
		fwrite(&out_byte, sizeof (char), 1, stdout);
	}
	return (out_bits > 0);
}

int ConvertG711ToG721(char *filename)
{
	struct g72x_state	state;
	unsigned char		sample_char;
	short			sample_short;
	unsigned char		code;
	int			resid;
	int			in_coding;
	int			in_size;
	unsigned		*in_buf;
	int			(*enc_routine)(int, int);
	int			enc_bits;
	static unsigned int	out_buffer = 0;
	static int		out_bits = 0;
	unsigned char		out_byte;

	FILE *fp;
	FILE *fpout;
	char outfile[100];
	
	memset(outfile, 0, sizeof outfile);
	sprintf(outfile, "%s_temp", filename);

	g72x_init_state(&state);

	in_coding = AUDIO_ENCODING_ULAW;
	in_size = sizeof (char);
	in_buf = (unsigned *)&sample_char;
	enc_routine = g721_encoder;
	enc_bits = 4;

	fp = fopen(filename, "rb");
	fpout = fopen(outfile, "+wb");

	while (fread(in_buf, in_size, 1, fp) == 1) {
		//code = (*enc_routine)(in_size == 2 ? sample_short : sample_char, in_coding, &state);
		code = (*enc_routine)(in_size == 2 ? sample_short : sample_char, in_coding);
		
		out_buffer |= (code << out_bits);
		out_bits += enc_bits;
		if (out_bits >= 8) {
			out_byte = out_buffer & 0xff;
			out_bits -= 8;
			out_buffer >>= 8;
			fwrite(&out_byte, sizeof (char), 1, fpout);
		}
		resid = (out_bits > 0);
	}

	while (resid) {
		out_buffer |= (0 << out_bits);
		out_bits += enc_bits;
		if (out_bits >= 8) {
			out_byte = out_buffer & 0xff;
			out_bits -= 8;
			out_buffer >>= 8;
			fwrite(&out_byte, sizeof (char), 1, fpout);
		}
		resid = (out_bits > 0);
	}

	fclose(fpout);
	fclose(fp);

	// rename
	rename(outfile, filename);

	return 1;
}


void print_latency_stats() {
	printf("Latency snapshot\n");
	printf("================\n");
	printf("Average INVITE		: %f\n", (avg_inv_latency / total_num_inv));
	printf("Maximum INVITE		: %u\n", max_inv_latency);
	printf("-\n");
	printf("Average 180 Ringing	: %f\n", (avg_180_latency / total_num_180));
	printf("Maximum 180 Ringing	: %u\n", max_180_latency);
	printf("-\n");
	printf("Average 200 OK		: %f\n", (avg_200_latency / total_num_200));
	printf("Maximum 200 OK		: %u\n", max_200_latency);
	printf("-\n");
	printf("Average ACK		: %f\n", (avg_ack_latency / total_num_ack));
	printf("Maximum ACK		: %u\n", max_ack_latency);
	printf("-\n");
	printf("Average BYE		: %f\n", (avg_bye_latency / total_num_bye));
	printf("Maximum BYE		: %u\n", max_bye_latency);
}

void message_latency_histogram(u_int16_t latency, MessageType type) {
	int bin = (latency / BIN_SIZE);

	if (bin > MAX_LATENCY_BINS) {
		bin = MAX_LATENCY_BINS - 1;
	}

	switch (type) {
	case SIP_INVITE:
		latency_inv_histogram[bin]++;
		avg_inv_latency += latency;
		if (latency > max_inv_latency) {
			max_inv_latency = latency;
		}
		break;
	case SIP_ONE_EIGHTY:
		latency_180_histogram[bin]++;
		avg_180_latency += latency;
		if (latency > max_180_latency) {
			max_180_latency = latency;
		}
		break;
	case SIP_OK:
		latency_200_histogram[bin]++;
		avg_200_latency += latency;
		if (latency > max_200_latency) {
			max_200_latency = latency;
		}
		break;
	case SIP_ACK:
		latency_ack_histogram[bin]++;
		avg_ack_latency += latency;
		if (latency > max_ack_latency) {
			max_ack_latency = latency;
		}
		break;
	case SIP_BYE:
		latency_bye_histogram[bin]++;
		avg_bye_latency += latency;
		if (latency > max_bye_latency) {
			max_bye_latency = latency;
		}
		break;
	default:
		break;
	}

	return;
}

u_int16_t calculate_latency(message_entry *first, message_entry *second) {
	int l = ((second->ts.tv_sec - first->ts.tv_sec) * 1000)
			+ ((second->ts.tv_usec - first->ts.tv_usec) / 1000);
	return l;
}

message_entry get_data_entry_from_message(const u_char *message,
		const struct pcap_pkthdr *header, MessageType messageType, int len) {
	message_entry e;
	e.phone_number = extract_phone_number(message, len);
	e.ts = header->ts;
	return e;
}

u_int32_t extract_phone_number(const u_char *message, int len) {
	char *temp_string = NULL;
	char *temp_sip=NULL;
	char *temp_phone = NULL;
	int i;

	//temp_string = strstr(message, "From: <sip:");
	temp_string = strstr((char*)message, "From:");
	temp_sip = strstr((char*)message, "<sip:");
	if (temp_string == NULL) {
		//printf("Couldn't find FROM in message:");
		//sip_print(message, len);
		return 0;
	} else {
		temp_phone = (char*) malloc(MAX_PHONE_NUMBER);
		/*		
		temp_string += 11;
		for (i = 0; (i < MAX_PHONE_NUMBER) && (*temp_string != '@'); temp_string++) {
			if (isdigit(*temp_string)) {
				temp_phone[i++] = *temp_string;
			}
		}
		*/
		temp_sip += 5;
		for (i = 0; (i < MAX_PHONE_NUMBER) && (*temp_sip != '@'); temp_sip++) {
			if (isdigit(*temp_sip)) {
				temp_phone[i++] = *temp_sip;
			}
		}
		temp_phone[i] = '\0';
		//printf("phone : %s\n", temp_phone);
		sip_print(message, len);
	}
	int phone = atol(temp_phone);
	free(temp_phone);
	return phone;
}



void sip_print(register const u_char *pptr, register u_int len) {
	u_int idx;

	for (idx = 0; idx < len; idx++) {
		if (EXTRACT_16BITS(pptr+idx) != 0x0d0a) { /* linefeed ? */
			safeputchar(*(pptr + idx));
			;
		} else {
			printf("\n\t");
			idx += 1;
		}
	}

}

void safeputchar(int c) {
	unsigned char ch;

	ch = (unsigned char) (c & 0xff);
	if (ch < 0x80 && isprint(ch))
		printf("%c", ch);
	else
		printf("\\0x%02x", ch);
}


/*
 * parse user input to program
 */
void parse_user_input() {
	int i;
	
	char query[1024];
	PGresult      *res;

	int field_num;
	int row_num;
	int j;
	char SPLIT2[50][30];
	char *CHECK2;
	char SRC_IP[20];   
	char auto_yn[2]; 
	char log_yn[2]; 
	char rec_yn[2]; 

	filter_app = "rtp.p_type==0 || rtp.p_type==8";
	sprintf(dev,"eth0");	

	sprintf(query, "SELECT r_sys_ip,r_sys_tls_yn,r_sys_srtp_yn FROM rs_sys_info_ipcr"); 

	res = PQexec(conn, query);
	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		printf("Default configuration will be used.\n");
		/*	
		filter_app = "rtp.p_type==0 || rtp.p_type==8";
		sprintf(dev,"eth0");	
		sprintf(desired_id,"125");
		sprintf(desired_number,"125");
		sprintf(pass,"125");
		//sprintf(tot_ch,"50");
		sprintf(mpb,"192.168.150.109");
		sprintf(SYSTEM_IP,"150.150.150.78");
		*/

		PQclear(res);
		//PQfinish(conn);
		return;
	}
	row_num = PQntuples(res);

	for (i = 0; i < row_num; i++)
	{
		memset(SYSTEM_IP, 0, sizeof SYSTEM_IP);
		sprintf(SYSTEM_IP,"%s", PQgetvalue(res, i, 0));
		memset(TLS_YN,0,sizeof TLS_YN);
		sprintf(TLS_YN,"%s", PQgetvalue(res, i, 1));
		memset(SRTP_USE,0,sizeof SRTP_USE);
		sprintf(SRTP_USE,"%s", PQgetvalue(res, i, 2));
		SRTP_YN=0;
		if (strcmp(SRTP_USE,"AES")==0)
		{
			SRTP_YN=1;
			memset(SRTP_NAME,0,sizeof SRTP_NAME);
			sprintf(SRTP_NAME,"AES");
			SRTP_TYPE=1;
		}
		else if (strcmp(SRTP_USE,"ARIA")==0)
		{
			SRTP_YN=1;
			memset(SRTP_NAME,0,sizeof SRTP_NAME);
			sprintf(SRTP_NAME,"ARIA");
			SRTP_TYPE=2;
		}
	}
	PQclear(res);

	/*
	memset(query,0,sizeof query);
	sprintf(query, "SELECT r_sys_ip FROM rs_sys_info"); 
	res = PQexec(conn, query);
	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		//PQfinish(conn);
		return;
	}
	row_num = PQntuples(res);

	for (i = 0; i < row_num; i++)
	{
		memset(mpb, 0, sizeof mpb);
		sprintf(mpb,"%s", PQgetvalue(res, i, 0));
	}
	PQclear(res);
	*/
	memset(query,0,sizeof query);
	sprintf(query, "SELECT r_proxy_server_ip,r_server_id,r_server_pw FROM rs_sip_registration"); 
	res = PQexec(conn, query);
	if (PQresultStatus(res) != PGRES_TUPLES_OK)
	{
		PQclear(res);
		//PQfinish(conn);
		return;
	}
	row_num = PQntuples(res);
	MF_COUNT=row_num;
	for (i = 0; i < row_num; i++)
	{
		gvStack[i].g_hRegClientMgr  = NULL;
		gvStack[i].hRegClient = NULL;
		gvStack[i].g_hCallLegMgr  = NULL;
		gvStack[i].g_hLog         = NULL;

		memset(gvStack[i].mpb, 0, sizeof gvStack[i].mpb);
		sprintf(gvStack[i].mpb,"%s", PQgetvalue(res, i, 0));
		memset(gvStack[i].desired_id, 0, sizeof gvStack[i].desired_id);
		sprintf(gvStack[i].desired_id,"%s", PQgetvalue(res, i, 1));
		memset(gvStack[i].desired_number, 0, sizeof gvStack[i].desired_number);
		sprintf(gvStack[i].desired_number,"%s", gvStack[i].desired_id);
		memset(gvStack[i].pass, 0, sizeof gvStack[i].pass);
		sprintf(gvStack[i].pass,"%s", PQgetvalue(res, i, 2));
		gvStack[i].SYSTEM_ID = i+1;
	}
	PQclear(res);	

}



void exit_program(int sig) {
	
	printf("BYE...\r\n");

	exit(0);
}

boolean write_latency_to_file(MessageType type, char * file_name) {
	char buffer[MAX_LATENCY_FILE_SIZE];

	memset(buffer, 0, sizeof(buffer));

	message_latency_dump(buffer, type);

	FILE *stats = fopen(file_name, "w");

	if (stats) {
		fwrite(buffer, strlen(buffer), 1, stats);
		fclose(stats);
		return TRUE;
	} else {
		printf("\n couldn't open file %s for writing", file_name);
	}
	return FALSE;
}


void message_latency_dump(char *buf, MessageType type) {
	size_t len = 0;
	int max_len = MAX_LATENCY_FILE_SIZE;

	len += snprintf(buf, max_len, "Latency delay:\n"
		"=====================\n");

	len += snprintf(buf + len, max_len - len, ".         \n"
		"Histogram:\n"
		"==========\n"
		".         \n");

	if (type == SIP_ALL) {
		len
				+= snprintf(
						buf + len,
						max_len - len,
						"                       		  INV\t\t180\t\t200\t\tACK\t\tBYE\t\tTOTAL\n"
							"======================================================================================================================\n");
		print_latency_hisogram_all(buf, len, max_len);
	}

	print_message_latency_hisogram(buf, len, max_len, type);
}

void print_message_latency_hisogram(char *buf, size_t len, int max_len,
		MessageType type) {
	int i;

	switch (type) {
	case SIP_INVITE:
		for (i = 0; i < MAX_LATENCY_BINS; i++) {
			len += snprintf(buf + len, max_len - len,
					"BIN [%04u -> %04u] msec = %u\n", i * BIN_SIZE, (i + 1)
							* BIN_SIZE, latency_inv_histogram[i]);
		}
		return;
	case SIP_ONE_EIGHTY:
		for (i = 0; i < MAX_LATENCY_BINS; i++) {
			len += snprintf(buf + len, max_len - len,
					"BIN [%04u -> %04u] msec = %u\n", i * BIN_SIZE, (i + 1)
							* BIN_SIZE, latency_180_histogram[i]);
		}
		return;
	case SIP_OK:
		for (i = 0; i < MAX_LATENCY_BINS; i++) {
			len += snprintf(buf + len, max_len - len,
					"BIN [%04u -> %04u] msec = %u\n", i * BIN_SIZE, (i + 1)
							* BIN_SIZE, latency_200_histogram[i]);
		}
		return;
	case SIP_ACK:
		for (i = 0; i < MAX_LATENCY_BINS; i++) {
			len += snprintf(buf + len, max_len - len,
					"BIN [%04u -> %04u] msec = %u\n", i * BIN_SIZE, (i + 1)
							* BIN_SIZE, latency_ack_histogram[i]);
		}
		return;
	case SIP_BYE:
		for (i = 0; i < MAX_LATENCY_BINS; i++) {
			len += snprintf(buf + len, max_len - len,
					"BIN [%04u -> %04u] msec = %u\n", i * BIN_SIZE, (i + 1)
							* BIN_SIZE, latency_bye_histogram[i]);
		}
		return;
	}//switch
}

void print_latency_hisogram_all(char *buf, size_t len, int max_len) {
	int i;
	int total_bins_i = 0;

	for (i = 0; i < MAX_LATENCY_BINS; i++) {
		total_bins_i = latency_inv_histogram[i] + latency_180_histogram[i]
				+ latency_200_histogram[i] + latency_ack_histogram[i]
				+ latency_bye_histogram[i];

		len
				+= snprintf(
						buf + len,
						max_len - len,
						"BIN [%04u -> %04u] msec = %12u\t%12u\t%12u\t%12u\t%12u\t%12u\n",
						i * BIN_SIZE, (i + 1) * BIN_SIZE,
						latency_inv_histogram[i], latency_180_histogram[i],
						latency_200_histogram[i], latency_ack_histogram[i],
						latency_bye_histogram[i], total_bins_i);
	}

}


/*
 * output help
 */
static void print_help() {

	printf(
			"Help:\n"
				"\n"
				" -h|--help         Help\n"
				" -I|--interface    interface (ex. eth1)\n"
				" -F|--filter       capture filter (ex. \"udp port 5060\")\n"
				" -P|--prefix       SBC IP prefix (ex. 110.10 if SBC IP is 110.100.1.1 and 110.101.2.2)\n"
				" -D|--desired_id        Desired ID\n"
				" -N|--desired_number        Desired Number\n"
				" -W|--pass         Password\n"
				" -C|--channel         Total Channel\n"
				" -A|--mpb         MOB IP Address\n"
				" -L|--mpb         Local IP Address\n");
}

